/*
  ==============================================================================

  This is an automatically generated GUI class created by the Introjucer!

  Be careful when adding custom code to these files, as only the code within
  the "//[xyz]" and "//[/xyz]" sections will be retained when the file is loaded
  and re-saved.

  Created with Introjucer version: 3.1.0

  ------------------------------------------------------------------------------

  The Introjucer is part of the JUCE library - "Jules' Utility Class Extensions"
  Copyright 2004-13 by Raw Material Software Ltd.

  ==============================================================================
*/

//[Headers] You can add your own extra header files here...
/*
 * Copyright (c) 2013 - Teragon Audio LLC
 *
 * Permission is granted to use this software under the terms of either:
 * a) the GPL v2 (or any later version)
 * b) the Affero GPL v3
 *
 * Details of these licenses can be found at: www.gnu.org/licenses
 *
 * This software is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * ------------------------------------------------------------------------------
 *
 * This software uses the JUCE library.
 *
 * To release a closed-source product which uses JUCE, commercial licenses are
 * available: visit www.juce.com for more information.
 */
//[/Headers]

#include "PluginEditor.h"


//[MiscUserDefs] You can add your own user definitions and misc code here...
//[/MiscUserDefs]

//==============================================================================
ChaosChimpMainEditor::ChaosChimpMainEditor (AudioProcessor* ownerFilter, teragon::ConcurrentParameterSet &p, teragon::ResourceCache* r)
    : AudioProcessorEditor(ownerFilter), parameters(p), resources(r)
{
    addAndMakeVisible (dropoutsButton = new teragon::PushButton (parameters,
                                                                 "Audio Dropouts Enabled",
                                                                 resources));
    dropoutsButton->setName ("dropouts button");

    addAndMakeVisible (cpuHogButton = new teragon::PushButton (parameters,
                                                               "CPU Hog Enabled",
                                                               resources));
    cpuHogButton->setName ("cpu hog button");

    addAndMakeVisible (crashButton = new teragon::PushButton (parameters,
                                                              "Crasher Enabled",
                                                              resources));
    crashButton->setName ("crash button");

    addAndMakeVisible (feedbackButton = new teragon::PushButton (parameters,
                                                                 "Feedback Enabled",
                                                                 resources));
    feedbackButton->setName ("feedback button");

    addAndMakeVisible (eatMemoryButton = new teragon::PushButton (parameters,
                                                                  "Memory Eater Enabled",
                                                                  resources));
    eatMemoryButton->setName ("eat memory button");

    addAndMakeVisible (chaosActiveLight = new teragon::IndicatorLight (parameters,
                                                                       "Chaos Active",
                                                                       resources));
    chaosActiveLight->setName ("chaos active light");

    addAndMakeVisible (panicButton = new teragon::ToggleButton (parameters,
                                                                "Panic",
                                                                resources));
    panicButton->setName ("panic button");

    addAndMakeVisible (probabilityKnob = new teragon::ImageKnobSmall (parameters,
                                                                      "Probability",
                                                                      resources));
    probabilityKnob->setName ("probability knob");

    addAndMakeVisible (durationKnob = new teragon::ImageKnobSmall (parameters,
                                                                   "Chaos Duration",
                                                                   resources));
    durationKnob->setName ("duration knob");

    addAndMakeVisible (cooldownKnob = new teragon::ImageKnobSmall (parameters,
                                                                   "Cooldown Period",
                                                                   resources));
    cooldownKnob->setName ("cooldown knob");

    addAndMakeVisible (statusBar = new teragon::StatusBar (parameters,
                                                           resources));
    statusBar->setName ("status bar");

    addAndMakeVisible (versionLabel = new teragon::ParameterLabel (parameters,
                                                                   "Version"));
    versionLabel->setName ("version label");

    cachedImage_background_png = ImageCache::getFromMemory (background_png, background_pngSize);

    //[UserPreSize]
    //[/UserPreSize]

    setSize (454, 235);


    //[Constructor] You can add your own custom stuff here..
    statusBar->subscribeToParameters();
    statusBar->ignoreParameter("Chaos Active");

    versionLabel->setFont(teragon::StatusBar::getFont());
    versionLabel->setJustificationType(Justification::centredRight);
    //[/Constructor]
}

ChaosChimpMainEditor::~ChaosChimpMainEditor()
{
    //[Destructor_pre]. You can add your own custom destruction code here..
    //[/Destructor_pre]

    dropoutsButton = nullptr;
    cpuHogButton = nullptr;
    crashButton = nullptr;
    feedbackButton = nullptr;
    eatMemoryButton = nullptr;
    chaosActiveLight = nullptr;
    panicButton = nullptr;
    probabilityKnob = nullptr;
    durationKnob = nullptr;
    cooldownKnob = nullptr;
    statusBar = nullptr;
    versionLabel = nullptr;


    //[Destructor]. You can add your own custom destruction code here..
    //[/Destructor]
}

//==============================================================================
void ChaosChimpMainEditor::paint (Graphics& g)
{
    //[UserPrePaint] Add your own custom painting code here..
    //[/UserPrePaint]

    g.fillAll (Colours::white);

    g.setColour (Colours::black);
    g.drawImage (cachedImage_background_png,
                 0, 0, 454, 235,
                 0, 0, cachedImage_background_png.getWidth(), cachedImage_background_png.getHeight());

    //[UserPaint] Add your own custom painting code here..
    //[/UserPaint]
}

void ChaosChimpMainEditor::resized()
{
    dropoutsButton->setBounds (23, 20, 72, 40);
    cpuHogButton->setBounds (107, 20, 72, 40);
    crashButton->setBounds (188, 20, 72, 40);
    feedbackButton->setBounds (272, 20, 72, 40);
    eatMemoryButton->setBounds (356, 20, 72, 40);
    chaosActiveLight->setBounds (42, 80, 24, 24);
    panicButton->setBounds (39, 113, 72, 40);
    probabilityKnob->setBounds (145, 80, 66, 66);
    durationKnob->setBounds (241, 81, 66, 66);
    cooldownKnob->setBounds (338, 81, 66, 66);
    statusBar->setBounds (23, 186, 240, 30);
    versionLabel->setBounds (189, 200, 240, 16);
    //[UserResized] Add your own custom resize handling here..
    //[/UserResized]
}



//[MiscUserCode] You can add your own definitions of your custom methods or any other code here...
//[/MiscUserCode]


//==============================================================================
#if 0
/*  -- Introjucer information section --

    This is where the Introjucer stores the metadata that describe this GUI layout, so
    make changes in here at your peril!

BEGIN_JUCER_METADATA

<JUCER_COMPONENT documentType="Component" className="ChaosChimpMainEditor" componentName=""
                 parentClasses="public AudioProcessorEditor" constructorParams="AudioProcessor* ownerFilter, teragon::ConcurrentParameterSet &amp;p, teragon::ResourceCache* r"
                 variableInitialisers="AudioProcessorEditor(ownerFilter), parameters(p), resources(r)"
                 snapPixels="8" snapActive="1" snapShown="1" overlayOpacity="0.330"
                 fixedSize="1" initialWidth="454" initialHeight="235">
  <BACKGROUND backgroundColour="ffffffff">
    <IMAGE pos="0 0 454 235" resource="background_png" opacity="1" mode="0"/>
  </BACKGROUND>
  <GENERICCOMPONENT name="dropouts button" id="6b7ac22422539f5b" memberName="dropoutsButton"
                    virtualName="teragon::PushButton" explicitFocusOrder="0" pos="23 20 72 40"
                    class="Component" params="parameters,&#10;&quot;Audio Dropouts Enabled&quot;,&#10;resources"/>
  <GENERICCOMPONENT name="cpu hog button" id="bbbbbdc5a3eb0ef3" memberName="cpuHogButton"
                    virtualName="teragon::PushButton" explicitFocusOrder="0" pos="107 20 72 40"
                    class="Component" params="parameters,&#10;&quot;CPU Hog Enabled&quot;,&#10;resources"/>
  <GENERICCOMPONENT name="crash button" id="96a1ba05ce063d10" memberName="crashButton"
                    virtualName="teragon::PushButton" explicitFocusOrder="0" pos="188 20 72 40"
                    class="Component" params="parameters,&#10;&quot;Crasher Enabled&quot;,&#10;resources"/>
  <GENERICCOMPONENT name="feedback button" id="5c7e764114154b7a" memberName="feedbackButton"
                    virtualName="teragon::PushButton" explicitFocusOrder="0" pos="272 20 72 40"
                    class="Component" params="parameters,&#10;&quot;Feedback Enabled&quot;,&#10;resources"/>
  <GENERICCOMPONENT name="eat memory button" id="ab67cdcaaa72e21f" memberName="eatMemoryButton"
                    virtualName="teragon::PushButton" explicitFocusOrder="0" pos="356 20 72 40"
                    class="Component" params="parameters,&#10;&quot;Memory Eater Enabled&quot;,&#10;resources"/>
  <GENERICCOMPONENT name="chaos active light" id="c9ddc158c60a0c4f" memberName="chaosActiveLight"
                    virtualName="teragon::IndicatorLight" explicitFocusOrder="0"
                    pos="42 80 24 24" class="Component" params="parameters,&#10;&quot;Chaos Active&quot;,&#10;resources"/>
  <GENERICCOMPONENT name="panic button" id="edcde4f48dd50f49" memberName="panicButton"
                    virtualName="teragon::ToggleButton" explicitFocusOrder="0" pos="39 113 72 40"
                    class="Component" params="parameters,&#10;&quot;Panic&quot;,&#10;resources"/>
  <GENERICCOMPONENT name="probability knob" id="83c1b03c28ddad70" memberName="probabilityKnob"
                    virtualName="teragon::ImageKnobSmall" explicitFocusOrder="0"
                    pos="145 80 66 66" class="Component" params="parameters,&#10;&quot;Probability&quot;,&#10;resources"/>
  <GENERICCOMPONENT name="duration knob" id="92ff5a99f8b1074e" memberName="durationKnob"
                    virtualName="teragon::ImageKnobSmall" explicitFocusOrder="0"
                    pos="241 81 66 66" class="Component" params="parameters,&#10;&quot;Chaos Duration&quot;,&#10;resources"/>
  <GENERICCOMPONENT name="cooldown knob" id="55e7e5ed20a6c05" memberName="cooldownKnob"
                    virtualName="teragon::ImageKnobSmall" explicitFocusOrder="0"
                    pos="338 81 66 66" class="Component" params="parameters,&#10;&quot;Cooldown Period&quot;,&#10;resources"/>
  <GENERICCOMPONENT name="status bar" id="ac12ab51ac74ea20" memberName="statusBar"
                    virtualName="teragon::StatusBar" explicitFocusOrder="0" pos="23 186 240 30"
                    class="Component" params="parameters,&#10;resources"/>
  <GENERICCOMPONENT name="version label" id="29abd00ece16a278" memberName="versionLabel"
                    virtualName="teragon::ParameterLabel" explicitFocusOrder="0"
                    pos="189 200 240 16" class="Component" params="parameters,&#10;&quot;Version&quot;"/>
</JUCER_COMPONENT>

END_JUCER_METADATA
*/
#endif

//==============================================================================
// Binary resources - be careful not to edit any of these sections!

// JUCER_RESOURCE: background_png, 46255, "../Graphics/background.png"
static const unsigned char resource_ChaosChimpMainEditor_background_png[] = { 137,80,78,71,13,10,26,10,0,0,0,13,73,72,68,82,0,0,1,198,0,0,0,235,8,2,0,0,0,124,69,161,34,0,0,10,65,105,67,67,80,73,67,67,
32,80,114,111,102,105,108,101,0,0,72,13,157,150,119,84,83,217,22,135,207,189,55,189,208,18,34,32,37,244,26,122,9,32,210,59,72,21,4,81,137,73,128,80,2,134,132,38,118,68,5,70,20,17,41,86,100,84,192,1,71,
135,34,99,69,20,11,131,130,98,215,9,242,16,80,198,193,81,68,69,229,221,140,107,9,239,173,53,243,222,154,253,199,89,223,217,231,183,215,217,103,239,125,215,186,0,80,252,130,4,194,116,88,1,128,52,161,88,
20,238,235,193,92,18,19,203,196,247,2,24,16,1,14,88,1,192,225,102,102,4,71,248,68,2,212,252,189,61,153,153,168,72,198,179,246,238,46,128,100,187,219,44,191,80,38,115,214,255,127,145,34,55,67,36,6,0,10,
69,213,54,60,126,38,23,229,2,148,83,179,197,25,50,255,4,202,244,149,41,50,134,49,50,22,161,9,162,172,34,227,196,175,108,246,167,230,43,187,201,152,151,38,228,161,26,89,206,25,188,52,158,140,187,80,222,
154,37,225,163,140,4,161,92,152,37,224,103,163,124,7,101,189,84,73,154,0,229,247,40,211,211,248,156,76,0,48,20,153,95,204,231,38,161,108,137,50,69,20,25,238,137,242,2,0,8,148,196,57,188,114,14,139,249,
57,104,158,0,120,166,103,228,138,4,137,73,98,166,17,215,152,105,229,232,200,102,250,241,179,83,249,98,49,43,148,195,77,225,136,120,76,207,244,180,12,142,48,23,128,175,111,150,69,1,37,89,109,153,104,145,
237,173,28,237,237,89,214,230,104,249,191,217,223,30,126,83,253,61,200,122,251,85,241,38,236,207,158,65,140,158,89,223,108,236,172,47,189,22,0,246,36,90,155,29,179,190,149,85,0,180,109,6,64,229,225,172,
79,239,32,0,242,5,0,180,222,156,243,30,134,108,94,146,196,226,12,39,11,139,236,236,108,115,1,159,107,46,43,232,55,251,159,130,111,202,191,134,57,247,153,203,238,251,86,59,166,23,63,129,35,73,21,51,101,
69,229,166,167,166,75,68,204,204,12,14,151,207,100,253,247,16,255,227,192,57,105,205,201,195,44,156,159,192,23,241,133,232,85,81,232,148,9,132,137,104,187,133,60,129,88,144,46,100,10,132,127,213,225,127,
24,54,39,7,25,126,157,107,20,104,117,95,0,125,133,57,80,184,73,7,200,111,61,0,67,35,3,36,110,63,122,2,125,235,91,16,49,10,200,190,188,104,173,145,175,115,143,50,122,254,231,250,31,11,92,138,110,225,76,
65,34,83,230,246,12,143,100,114,37,162,44,25,163,223,132,108,193,2,18,144,7,116,160,10,52,129,46,48,2,44,96,13,28,128,51,112,3,222,32,0,132,128,72,16,3,150,3,46,72,2,105,64,4,178,65,62,216,0,10,65,49,
216,1,118,131,106,112,0,212,129,122,208,4,78,130,54,112,6,92,4,87,192,13,112,11,12,128,71,64,10,134,193,75,48,1,222,129,105,8,130,240,16,21,162,65,170,144,22,164,15,153,66,214,16,27,90,8,121,67,65,80,
56,20,3,197,67,137,144,16,146,64,249,208,38,168,24,42,131,170,161,67,80,61,244,35,116,26,186,8,93,131,250,160,7,208,32,52,6,253,1,125,132,17,152,2,211,97,13,216,0,182,128,217,176,59,28,8,71,194,203,224,
68,120,21,156,7,23,192,219,225,74,184,22,62,14,183,194,23,225,27,240,0,44,133,95,194,147,8,64,200,8,3,209,70,88,8,27,241,68,66,144,88,36,1,17,33,107,145,34,164,2,169,69,154,144,14,164,27,185,141,72,145,
113,228,3,6,135,161,97,152,24,22,198,25,227,135,89,140,225,98,86,97,214,98,74,48,213,152,99,152,86,76,23,230,54,102,16,51,129,249,130,165,98,213,177,166,88,39,172,63,118,9,54,17,155,141,45,196,86,96,143,
96,91,176,151,177,3,216,97,236,59,28,14,199,192,25,226,28,112,126,184,24,92,50,110,53,174,4,183,15,215,140,187,128,235,195,13,225,38,241,120,188,42,222,20,239,130,15,193,115,240,98,124,33,190,10,127,28,
127,30,223,143,31,198,191,39,144,9,90,4,107,130,15,33,150,32,36,108,36,84,16,26,8,231,8,253,132,17,194,52,81,129,168,79,116,34,134,16,121,196,92,98,41,177,142,216,65,188,73,28,38,78,147,20,73,134,36,23,
82,36,41,153,180,129,84,73,106,34,93,38,61,38,189,33,147,201,58,100,71,114,24,89,64,94,79,174,36,159,32,95,37,15,146,63,80,148,40,38,20,79,74,28,69,66,217,78,57,74,185,64,121,64,121,67,165,82,13,168,110,
212,88,170,152,186,157,90,79,189,68,125,74,125,47,71,147,51,151,243,151,227,201,173,147,171,145,107,149,235,151,123,37,79,148,215,151,119,151,95,46,159,39,95,33,127,74,254,166,252,184,2,81,193,64,193,
83,129,163,176,86,161,70,225,180,194,61,133,73,69,154,162,149,98,136,98,154,98,137,98,131,226,53,197,81,37,188,146,129,146,183,18,79,169,64,233,176,210,37,165,33,26,66,211,165,121,210,184,180,77,180,58,
218,101,218,48,29,71,55,164,251,211,147,233,197,244,31,232,189,244,9,101,37,101,91,229,40,229,28,229,26,229,179,202,82,6,194,48,96,248,51,82,25,165,140,147,140,187,140,143,243,52,230,185,207,227,207,219,
54,175,105,94,255,188,41,149,249,42,110,42,124,149,34,149,102,149,1,149,143,170,76,85,111,213,20,213,157,170,109,170,79,212,48,106,38,106,97,106,217,106,251,213,46,171,141,207,167,207,119,158,207,157,
95,52,255,228,252,135,234,176,186,137,122,184,250,106,245,195,234,61,234,147,26,154,26,190,26,25,26,85,26,151,52,198,53,25,154,110,154,201,154,229,154,231,52,199,180,104,90,11,181,4,90,229,90,231,181,
94,48,149,153,238,204,84,102,37,179,139,57,161,173,174,237,167,45,209,62,164,221,171,61,173,99,168,179,88,103,163,78,179,206,19,93,146,46,91,55,65,183,92,183,83,119,66,79,75,47,88,47,95,175,81,239,161,
62,81,159,173,159,164,191,71,191,91,127,202,192,208,32,218,96,139,65,155,193,168,161,138,161,191,97,158,97,163,225,99,35,170,145,171,209,42,163,90,163,59,198,56,99,182,113,138,241,62,227,91,38,176,137,
157,73,146,73,141,201,77,83,216,212,222,84,96,186,207,180,207,12,107,230,104,38,52,171,53,187,199,162,176,220,89,89,172,70,214,160,57,195,60,200,124,163,121,155,249,43,11,61,139,88,139,157,22,221,22,95,
44,237,44,83,45,235,44,31,89,41,89,5,88,109,180,234,176,250,195,218,196,154,107,93,99,125,199,134,106,227,99,179,206,166,221,230,181,173,169,45,223,118,191,237,125,59,154,93,176,221,22,187,78,187,207,
246,14,246,34,251,38,251,49,7,61,135,120,135,189,14,247,216,116,118,40,187,132,125,213,17,235,232,225,184,206,241,140,227,7,39,123,39,177,211,73,167,223,157,89,206,41,206,13,206,163,11,12,23,240,23,212,
45,24,114,209,113,225,184,28,114,145,46,100,46,140,95,120,112,161,212,85,219,149,227,90,235,250,204,77,215,141,231,118,196,109,196,221,216,61,217,253,184,251,43,15,75,15,145,71,139,199,148,167,147,231,
26,207,11,94,136,151,175,87,145,87,175,183,146,247,98,239,106,239,167,62,58,62,137,62,141,62,19,190,118,190,171,125,47,248,97,253,2,253,118,250,221,243,215,240,231,250,215,251,79,4,56,4,172,9,232,10,164,
4,70,4,86,7,62,11,50,9,18,5,117,4,195,193,1,193,187,130,31,47,210,95,36,92,212,22,2,66,252,67,118,133,60,9,53,12,93,21,250,115,24,46,44,52,172,38,236,121,184,85,120,126,120,119,4,45,98,69,68,67,196,187,
72,143,200,210,200,71,139,141,22,75,22,119,70,201,71,197,69,213,71,77,69,123,69,151,69,75,151,88,44,89,179,228,70,140,90,140,32,166,61,22,31,27,21,123,36,118,114,169,247,210,221,75,135,227,236,226,10,
227,238,46,51,92,150,179,236,218,114,181,229,169,203,207,174,144,95,193,89,113,42,30,27,31,29,223,16,255,137,19,194,169,229,76,174,244,95,185,119,229,4,215,147,187,135,251,146,231,198,43,231,141,241,93,
248,101,252,145,4,151,132,178,132,209,68,151,196,93,137,99,73,174,73,21,73,227,2,79,65,181,224,117,178,95,242,129,228,169,148,144,148,163,41,51,169,209,169,205,105,132,180,248,180,211,66,37,97,138,176,
43,93,51,61,39,189,47,195,52,163,48,67,186,202,105,213,238,85,19,162,64,209,145,76,40,115,89,102,187,152,142,254,76,245,72,140,36,155,37,131,89,11,179,106,178,222,103,71,101,159,202,81,204,17,230,244,
228,154,228,110,203,29,201,243,201,251,126,53,102,53,119,117,103,190,118,254,134,252,193,53,238,107,14,173,133,214,174,92,219,185,78,119,93,193,186,225,245,190,235,143,109,32,109,72,217,240,203,70,203,
141,101,27,223,110,138,222,212,81,160,81,176,190,96,104,179,239,230,198,66,185,66,81,225,189,45,206,91,14,108,197,108,21,108,237,221,102,179,173,106,219,151,34,94,209,245,98,203,226,138,226,79,37,220,
146,235,223,89,125,87,249,221,204,246,132,237,189,165,246,165,251,119,224,118,8,119,220,221,233,186,243,88,153,98,89,94,217,208,174,224,93,173,229,204,242,162,242,183,187,87,236,190,86,97,91,113,96,15,
105,143,100,143,180,50,168,178,189,74,175,106,71,213,167,234,164,234,129,26,143,154,230,189,234,123,183,237,157,218,199,219,215,191,223,109,127,211,1,141,3,197,7,62,30,20,28,188,127,200,247,80,107,173,
65,109,197,97,220,225,172,195,207,235,162,234,186,191,103,127,95,127,68,237,72,241,145,207,71,133,71,165,199,194,143,117,213,59,212,215,55,168,55,148,54,194,141,146,198,177,227,113,199,111,253,224,245,
67,123,19,171,233,80,51,163,185,248,4,56,33,57,241,226,199,248,31,239,158,12,60,217,121,138,125,170,233,39,253,159,246,182,208,90,138,90,161,214,220,214,137,182,164,54,105,123,76,123,223,233,128,211,157,
29,206,29,45,63,155,255,124,244,140,246,153,154,179,202,103,75,207,145,206,21,156,155,57,159,119,126,242,66,198,133,241,139,137,23,135,58,87,116,62,186,180,228,210,157,174,176,174,222,203,129,151,175,
94,241,185,114,169,219,189,251,252,85,151,171,103,174,57,93,59,125,157,125,189,237,134,253,141,214,30,187,158,150,95,236,126,105,233,181,239,109,189,233,112,179,253,150,227,173,142,190,5,125,231,250,93,
251,47,222,246,186,125,229,142,255,157,27,3,139,6,250,238,46,190,123,255,94,220,61,233,125,222,253,209,7,169,15,94,63,204,122,56,253,104,253,99,236,227,162,39,10,79,42,158,170,63,173,253,213,248,215,102,
169,189,244,236,160,215,96,207,179,136,103,143,134,184,67,47,255,149,249,175,79,195,5,207,169,207,43,70,180,70,234,71,173,71,207,140,249,140,221,122,177,244,197,240,203,140,151,211,227,133,191,41,254,
182,247,149,209,171,159,126,119,251,189,103,98,201,196,240,107,209,235,153,63,74,222,168,190,57,250,214,246,109,231,100,232,228,211,119,105,239,166,167,138,222,171,190,63,246,129,253,161,251,99,244,199,
145,233,236,79,248,79,149,159,141,63,119,124,9,252,242,120,38,109,102,230,223,247,132,243,251,50,58,89,126,0,0,0,9,112,72,89,115,0,0,11,19,0,0,11,19,1,0,154,156,24,0,0,4,222,105,84,88,116,88,77,76,58,
99,111,109,46,97,100,111,98,101,46,120,109,112,0,0,0,0,0,60,120,58,120,109,112,109,101,116,97,32,120,109,108,110,115,58,120,61,34,97,100,111,98,101,58,110,115,58,109,101,116,97,47,34,32,120,58,120,109,
112,116,107,61,34,88,77,80,32,67,111,114,101,32,53,46,49,46,50,34,62,10,32,32,32,60,114,100,102,58,82,68,70,32,120,109,108,110,115,58,114,100,102,61,34,104,116,116,112,58,47,47,119,119,119,46,119,51,46,
111,114,103,47,49,57,57,57,47,48,50,47,50,50,45,114,100,102,45,115,121,110,116,97,120,45,110,115,35,34,62,10,32,32,32,32,32,32,60,114,100,102,58,68,101,115,99,114,105,112,116,105,111,110,32,114,100,102,
58,97,98,111,117,116,61,34,34,10,32,32,32,32,32,32,32,32,32,32,32,32,120,109,108,110,115,58,116,105,102,102,61,34,104,116,116,112,58,47,47,110,115,46,97,100,111,98,101,46,99,111,109,47,116,105,102,102,
47,49,46,48,47,34,62,10,32,32,32,32,32,32,32,32,32,60,116,105,102,102,58,82,101,115,111,108,117,116,105,111,110,85,110,105,116,62,49,60,47,116,105,102,102,58,82,101,115,111,108,117,116,105,111,110,85,
110,105,116,62,10,32,32,32,32,32,32,32,32,32,60,116,105,102,102,58,67,111,109,112,114,101,115,115,105,111,110,62,53,60,47,116,105,102,102,58,67,111,109,112,114,101,115,115,105,111,110,62,10,32,32,32,32,
32,32,32,32,32,60,116,105,102,102,58,88,82,101,115,111,108,117,116,105,111,110,62,55,50,60,47,116,105,102,102,58,88,82,101,115,111,108,117,116,105,111,110,62,10,32,32,32,32,32,32,32,32,32,60,116,105,102,
102,58,79,114,105,101,110,116,97,116,105,111,110,62,49,60,47,116,105,102,102,58,79,114,105,101,110,116,97,116,105,111,110,62,10,32,32,32,32,32,32,32,32,32,60,116,105,102,102,58,89,82,101,115,111,108,117,
116,105,111,110,62,55,50,60,47,116,105,102,102,58,89,82,101,115,111,108,117,116,105,111,110,62,10,32,32,32,32,32,32,60,47,114,100,102,58,68,101,115,99,114,105,112,116,105,111,110,62,10,32,32,32,32,32,
32,60,114,100,102,58,68,101,115,99,114,105,112,116,105,111,110,32,114,100,102,58,97,98,111,117,116,61,34,34,10,32,32,32,32,32,32,32,32,32,32,32,32,120,109,108,110,115,58,101,120,105,102,61,34,104,116,
116,112,58,47,47,110,115,46,97,100,111,98,101,46,99,111,109,47,101,120,105,102,47,49,46,48,47,34,62,10,32,32,32,32,32,32,32,32,32,60,101,120,105,102,58,80,105,120,101,108,88,68,105,109,101,110,115,105,
111,110,62,52,53,52,60,47,101,120,105,102,58,80,105,120,101,108,88,68,105,109,101,110,115,105,111,110,62,10,32,32,32,32,32,32,32,32,32,60,101,120,105,102,58,67,111,108,111,114,83,112,97,99,101,62,49,60,
47,101,120,105,102,58,67,111,108,111,114,83,112,97,99,101,62,10,32,32,32,32,32,32,32,32,32,60,101,120,105,102,58,80,105,120,101,108,89,68,105,109,101,110,115,105,111,110,62,50,51,53,60,47,101,120,105,
102,58,80,105,120,101,108,89,68,105,109,101,110,115,105,111,110,62,10,32,32,32,32,32,32,60,47,114,100,102,58,68,101,115,99,114,105,112,116,105,111,110,62,10,32,32,32,32,32,32,60,114,100,102,58,68,101,
115,99,114,105,112,116,105,111,110,32,114,100,102,58,97,98,111,117,116,61,34,34,10,32,32,32,32,32,32,32,32,32,32,32,32,120,109,108,110,115,58,100,99,61,34,104,116,116,112,58,47,47,112,117,114,108,46,111,
114,103,47,100,99,47,101,108,101,109,101,110,116,115,47,49,46,49,47,34,62,10,32,32,32,32,32,32,32,32,32,60,100,99,58,115,117,98,106,101,99,116,62,10,32,32,32,32,32,32,32,32,32,32,32,32,60,114,100,102,
58,66,97,103,47,62,10,32,32,32,32,32,32,32,32,32,60,47,100,99,58,115,117,98,106,101,99,116,62,10,32,32,32,32,32,32,60,47,114,100,102,58,68,101,115,99,114,105,112,116,105,111,110,62,10,32,32,32,32,32,32,
60,114,100,102,58,68,101,115,99,114,105,112,116,105,111,110,32,114,100,102,58,97,98,111,117,116,61,34,34,10,32,32,32,32,32,32,32,32,32,32,32,32,120,109,108,110,115,58,120,109,112,61,34,104,116,116,112,
58,47,47,110,115,46,97,100,111,98,101,46,99,111,109,47,120,97,112,47,49,46,48,47,34,62,10,32,32,32,32,32,32,32,32,32,60,120,109,112,58,77,111,100,105,102,121,68,97,116,101,62,50,48,49,51,45,49,50,45,50,
52,84,49,51,58,49,50,58,49,50,60,47,120,109,112,58,77,111,100,105,102,121,68,97,116,101,62,10,32,32,32,32,32,32,32,32,32,60,120,109,112,58,67,114,101,97,116,111,114,84,111,111,108,62,80,105,120,101,108,
109,97,116,111,114,32,51,46,48,60,47,120,109,112,58,67,114,101,97,116,111,114,84,111,111,108,62,10,32,32,32,32,32,32,60,47,114,100,102,58,68,101,115,99,114,105,112,116,105,111,110,62,10,32,32,32,60,47,
114,100,102,58,82,68,70,62,10,60,47,120,58,120,109,112,109,101,116,97,62,10,100,4,5,122,0,0,64,0,73,68,65,84,120,1,236,125,7,160,29,85,241,126,242,18,2,33,144,80,66,66,18,74,66,39,244,94,164,247,110,71,
127,250,67,81,80,252,137,8,130,138,136,32,77,16,59,130,141,98,3,11,42,42,77,122,9,8,72,239,9,77,84,164,247,158,64,242,146,255,183,59,123,102,231,204,153,115,246,236,189,247,133,224,223,231,243,189,217,
57,223,124,243,205,156,179,231,238,238,189,47,12,94,115,237,245,7,89,95,115,102,207,177,220,189,241,13,238,27,156,67,36,53,152,33,18,96,18,134,81,141,33,53,207,28,191,3,131,109,205,156,162,145,153,145,
117,138,65,131,100,148,9,96,176,68,178,243,45,49,88,231,64,72,2,185,71,219,235,89,144,29,227,66,216,233,165,46,189,41,140,210,70,44,145,117,82,12,154,120,138,114,177,97,58,57,78,118,40,50,196,176,39,36,
76,132,135,96,230,97,131,194,99,200,4,57,51,188,245,6,79,68,124,178,98,5,54,138,31,154,110,65,14,111,154,193,92,70,115,250,253,221,42,148,25,47,181,33,157,79,149,9,142,148,233,237,161,49,170,152,223,19,
82,78,97,85,117,143,74,243,248,123,116,16,233,131,183,239,203,84,18,239,245,129,151,172,135,246,250,41,71,164,13,30,73,59,104,144,23,37,179,248,176,138,131,156,18,38,201,149,157,3,75,96,6,15,233,83,132,
56,4,222,20,86,34,171,90,212,21,69,63,159,14,115,230,204,153,29,82,118,229,9,245,216,45,202,91,162,44,101,78,127,41,52,190,152,25,217,123,131,87,87,167,217,121,226,204,201,13,167,207,132,153,59,219,160,
193,131,135,166,11,102,46,78,195,30,47,144,139,244,188,229,65,178,108,166,13,227,200,195,233,10,195,204,146,228,143,209,42,170,198,205,46,202,147,55,192,83,8,56,87,212,16,106,22,203,49,65,213,178,147,
185,41,176,93,249,39,119,102,96,117,58,177,24,50,132,36,89,47,163,52,121,188,64,251,21,87,240,19,39,17,118,86,66,37,89,93,17,179,214,60,67,87,228,162,224,135,42,115,148,212,170,59,64,81,130,29,229,136,
141,223,34,214,24,77,184,148,66,57,101,166,114,69,69,248,26,41,103,51,152,41,21,91,31,202,40,246,138,112,89,29,231,98,169,149,199,36,177,216,224,147,132,12,81,6,39,82,126,117,200,50,216,95,4,206,153,227,
111,169,82,156,40,12,49,233,52,33,59,167,73,27,68,107,214,25,102,76,100,9,193,102,94,145,200,187,246,33,112,3,137,108,14,179,251,93,98,183,50,26,152,21,186,60,68,177,28,197,178,201,131,67,30,226,208,208,
195,67,202,96,54,229,199,97,98,136,192,149,128,242,234,76,103,68,127,92,55,244,80,144,169,76,84,79,65,159,11,196,111,92,168,5,240,194,161,182,33,19,211,214,217,168,83,17,102,246,7,81,146,89,69,201,33,
230,39,140,57,196,24,211,232,32,164,39,60,42,175,60,55,213,144,153,142,156,50,138,97,50,92,218,38,160,184,54,26,60,88,117,24,215,9,188,90,192,160,70,77,206,130,92,45,60,183,38,57,175,50,66,158,50,145,
127,149,106,86,200,68,33,133,26,82,210,213,40,31,22,134,175,190,184,42,105,42,160,8,226,62,121,92,246,129,18,67,177,173,24,20,175,220,227,234,161,114,70,235,67,211,146,197,102,148,73,28,144,170,74,128,
159,61,100,100,150,195,81,166,58,56,21,143,73,78,78,73,37,237,146,217,109,244,178,94,74,233,87,29,4,14,234,167,187,200,152,62,223,31,134,243,184,42,164,74,238,174,196,189,81,37,210,87,200,132,202,0,67,
152,221,163,85,1,229,97,35,0,168,28,140,197,157,235,99,217,29,39,178,25,92,27,189,27,139,188,102,170,170,153,159,141,116,109,84,8,109,89,170,168,126,63,82,141,250,131,245,145,218,253,138,40,87,93,13,34,
43,82,32,221,189,121,87,169,81,22,65,161,10,150,114,165,173,69,248,199,74,61,6,195,88,149,200,39,104,113,196,204,249,132,28,82,167,193,181,147,185,239,163,51,102,223,101,199,196,19,55,131,185,206,161,
173,86,96,29,44,142,219,242,152,120,211,41,146,212,102,108,114,195,254,231,115,214,236,98,169,40,66,143,77,76,138,121,182,43,145,136,85,108,102,70,56,139,44,130,188,134,137,25,175,157,173,44,208,90,36,
74,152,87,102,54,191,23,101,234,39,42,75,0,70,164,6,178,137,80,181,145,56,188,92,157,41,28,224,40,147,222,147,93,182,200,172,14,177,30,82,112,17,222,219,82,49,106,178,72,10,105,11,182,192,148,211,22,204,
83,14,73,129,33,18,63,92,206,46,103,205,37,228,128,150,70,170,45,190,188,138,24,202,157,191,89,155,85,102,75,129,243,10,92,206,142,42,156,15,25,195,6,169,103,64,186,24,21,5,48,2,225,100,127,113,40,94,
198,36,27,167,96,131,71,67,143,222,58,221,132,154,228,250,249,178,3,51,127,163,1,90,67,67,252,4,110,36,140,1,76,253,4,54,5,96,72,251,221,217,237,189,92,201,124,237,203,151,209,181,237,18,85,30,139,150,
231,189,142,42,45,173,89,13,39,15,169,69,54,3,75,18,98,164,6,189,165,130,133,135,61,70,38,34,41,130,206,208,6,176,3,128,141,121,136,153,15,141,64,223,197,133,177,36,140,231,135,251,100,245,145,100,35,
111,140,147,5,155,128,144,167,206,49,168,174,90,56,157,25,52,19,84,102,10,23,144,247,91,209,114,144,155,11,118,12,156,145,83,69,14,198,83,200,117,149,133,152,225,210,25,206,139,28,245,152,147,7,106,235,
97,18,54,100,116,12,92,99,252,42,106,191,179,76,90,55,136,117,239,63,98,238,98,78,27,18,213,41,163,150,44,86,62,184,228,128,230,20,40,39,93,2,213,171,48,150,51,204,69,11,32,92,6,36,47,196,179,108,54,18,
24,174,93,98,164,173,183,84,144,202,97,206,193,68,228,49,49,38,88,34,165,205,96,24,141,197,87,129,114,85,169,94,75,186,38,59,38,35,140,75,35,49,74,202,211,176,144,86,53,19,128,182,12,33,39,60,33,45,193,
58,33,151,173,46,168,235,183,146,204,212,133,83,133,100,70,69,233,234,1,174,43,179,144,76,88,157,32,98,129,71,174,76,105,71,34,106,183,5,174,122,24,149,135,6,198,251,204,77,160,28,74,91,157,216,89,209,
44,37,192,146,87,12,164,163,28,183,7,83,15,46,25,147,54,80,78,83,9,230,146,43,156,158,200,112,213,1,96,62,163,75,11,202,30,109,188,29,25,234,157,9,241,25,213,68,172,192,10,105,106,22,7,87,70,12,143,137,
151,237,147,171,74,250,107,58,171,191,213,50,53,135,40,210,42,161,230,12,172,112,57,134,158,32,40,229,176,107,73,69,216,99,33,15,9,83,109,180,131,125,175,108,53,70,66,102,31,94,28,169,144,204,168,144,
71,122,84,99,249,80,235,81,147,219,114,66,101,198,218,46,57,171,27,219,28,66,214,96,130,121,148,19,132,48,120,0,11,253,101,136,46,57,115,82,220,91,115,156,150,120,66,54,6,196,140,104,243,99,1,73,127,11,
25,97,235,36,115,164,93,213,182,70,45,149,120,178,253,40,42,45,183,39,46,214,136,42,165,14,149,103,66,130,84,194,164,66,25,34,115,72,191,196,199,236,102,60,189,65,20,139,135,31,159,165,176,158,160,17,
115,56,84,103,76,204,153,107,95,65,47,86,103,29,155,208,51,15,12,217,58,205,122,69,165,16,110,7,38,43,242,66,204,20,8,247,179,36,249,244,96,138,223,209,202,21,24,196,251,55,206,106,216,49,192,237,38,186,
190,74,242,82,3,97,86,199,12,233,81,206,27,194,202,5,172,115,49,94,26,97,172,28,101,37,29,205,163,100,146,54,9,67,115,240,157,37,82,6,39,108,179,22,81,130,60,115,197,41,88,127,76,42,194,93,93,207,202,
240,16,73,133,164,203,113,235,161,136,6,146,15,195,40,202,213,240,215,83,44,34,140,231,33,54,114,48,12,110,107,64,174,228,231,194,152,7,163,18,192,126,50,194,33,193,80,116,191,241,145,80,200,160,82,208,
161,160,53,198,51,73,140,200,136,43,157,142,130,84,82,213,73,96,64,162,48,145,108,181,59,29,34,215,177,108,108,219,44,38,190,44,185,222,239,106,77,206,226,158,200,112,41,9,64,57,228,226,170,223,52,196,
36,240,74,187,4,165,178,243,103,108,137,46,254,193,63,131,36,161,170,18,71,233,173,75,7,6,104,18,115,207,2,90,108,91,28,219,104,104,242,68,64,152,215,202,168,230,133,248,100,22,121,127,236,61,100,176,
216,66,57,146,74,142,210,156,6,51,91,65,100,148,180,49,172,14,37,39,13,13,5,169,1,82,237,200,83,239,228,4,151,3,57,225,156,49,2,134,72,89,191,161,89,22,215,100,75,42,194,214,127,20,216,20,107,140,179,
120,116,60,254,28,7,73,41,111,166,120,22,105,227,203,164,29,252,253,162,236,36,49,203,85,91,84,23,153,130,98,68,92,39,72,219,232,137,115,209,158,162,75,16,29,115,192,248,111,95,143,166,74,196,9,181,18,
21,118,160,190,79,148,56,103,231,103,68,132,119,218,19,131,89,172,40,138,59,201,134,151,49,8,151,147,206,33,78,172,126,129,52,247,44,128,189,20,28,92,12,248,231,175,208,41,81,141,118,152,215,204,104,58,
37,121,200,67,163,50,48,108,130,28,173,217,68,105,209,207,42,0,221,88,178,224,169,201,157,85,188,61,21,10,130,207,1,138,223,166,190,254,217,253,179,103,207,46,198,138,41,192,255,7,87,65,94,104,73,227,
207,81,233,10,126,112,84,43,48,101,14,200,12,7,243,171,177,156,116,42,68,29,134,204,62,103,248,119,224,189,254,51,110,37,168,205,97,40,158,162,231,12,34,217,144,202,70,27,222,36,54,72,74,14,180,205,173,
161,122,205,22,217,69,63,235,214,33,70,248,147,249,146,131,82,76,215,132,80,91,43,228,180,82,42,167,203,207,197,33,76,200,70,7,36,141,33,137,116,156,55,52,66,218,144,199,97,104,69,133,28,70,235,66,80,
55,30,83,18,84,193,63,7,143,93,240,32,187,111,200,80,220,2,132,56,47,107,108,151,39,144,241,142,63,71,27,59,105,185,212,177,153,22,223,253,179,24,217,153,33,111,145,104,99,238,140,231,45,143,162,66,98,
37,24,151,45,111,185,226,12,1,44,155,141,140,160,2,130,110,196,90,145,201,32,97,102,118,190,76,27,28,59,59,75,25,146,7,182,84,213,91,145,156,200,84,203,163,221,27,242,148,81,21,117,79,222,43,6,37,146,
105,185,255,3,221,37,206,216,129,49,107,214,160,33,67,241,53,223,144,190,33,137,112,99,111,116,232,161,250,166,207,13,20,191,131,11,96,108,207,216,76,103,245,207,44,174,79,187,254,226,22,119,205,212,3,
130,198,117,144,200,49,16,133,12,208,57,159,168,162,87,67,97,55,184,183,225,80,103,73,135,12,169,174,35,18,132,137,33,36,77,143,118,166,106,46,68,189,45,100,207,35,34,241,186,155,120,197,77,76,86,255,
172,89,184,3,159,47,220,85,131,253,208,36,25,58,100,104,241,66,31,125,224,229,179,96,111,158,53,179,55,251,41,171,225,243,173,148,225,238,13,120,120,110,25,243,200,58,224,114,231,53,61,44,140,13,57,113,
112,38,4,39,134,152,13,6,95,123,146,51,60,31,100,198,76,78,201,47,109,73,69,254,4,97,8,150,84,141,225,33,248,237,235,137,181,34,214,61,19,175,192,140,81,126,213,37,192,210,0,224,153,10,246,224,161,125,
120,195,26,33,228,108,140,149,233,16,216,63,167,127,232,144,249,164,83,218,169,171,84,249,182,76,240,80,85,191,115,133,75,84,228,146,186,91,9,149,154,216,238,158,129,169,254,179,13,217,118,84,154,211,
183,14,22,83,126,15,99,2,148,78,34,140,129,49,202,120,156,3,56,228,127,49,52,12,9,61,249,106,21,178,21,85,43,176,74,244,31,118,216,182,21,57,120,137,225,197,128,190,73,127,120,104,54,214,11,153,83,61,
96,240,156,65,88,44,35,174,85,103,245,205,74,223,254,7,100,133,195,123,150,154,216,122,41,24,247,251,105,125,102,142,152,51,86,76,12,175,252,124,81,19,94,206,40,228,60,114,40,235,101,73,137,126,114,129,
0,163,198,4,146,217,148,209,65,136,98,232,224,176,109,210,26,239,206,1,74,42,219,85,99,218,11,2,79,34,156,179,152,24,30,69,90,19,208,94,206,64,69,164,203,68,214,142,111,132,7,74,177,197,59,247,155,156,
200,136,55,140,134,36,54,23,113,7,47,47,70,189,45,85,127,126,34,172,89,158,229,225,104,75,79,162,152,28,166,156,7,106,57,60,29,96,248,76,107,85,66,14,152,153,161,138,174,218,72,30,95,187,133,106,115,104,
195,168,1,242,144,254,158,72,234,9,9,202,76,243,116,51,58,64,61,236,140,54,93,8,56,249,124,105,236,73,103,2,122,18,37,215,191,73,216,88,166,25,213,161,19,31,64,73,126,4,24,180,116,25,42,47,70,139,207,
165,138,124,181,237,185,29,226,205,89,53,192,249,230,246,239,176,233,93,158,198,146,48,115,194,18,176,14,216,100,7,61,102,255,170,77,194,230,89,219,211,63,207,170,252,255,82,216,219,98,106,122,46,82,158,
143,52,237,249,41,112,1,201,123,37,246,73,182,211,203,39,250,215,83,145,15,58,244,236,237,35,89,106,126,145,40,166,21,56,93,124,219,22,247,132,141,11,239,121,33,57,242,210,24,214,54,16,157,73,167,254,
79,26,165,54,206,131,243,59,47,55,89,173,189,124,169,233,62,167,71,27,178,224,147,170,238,43,115,63,5,188,188,241,175,63,88,109,124,112,202,113,150,191,235,20,197,97,55,75,167,171,82,61,77,111,179,131,
183,176,240,216,170,101,73,108,204,59,61,133,230,185,163,170,155,197,172,218,5,193,111,139,7,151,74,118,227,97,15,91,20,230,154,59,179,28,230,77,121,252,237,14,72,255,158,222,14,45,255,37,42,241,156,181,
120,156,42,15,203,168,154,8,111,201,138,15,164,206,139,93,176,203,252,175,183,232,64,79,230,75,237,203,141,156,18,223,8,14,231,169,131,144,144,36,199,211,125,34,84,202,36,120,112,201,118,78,246,183,5,
230,63,175,162,134,182,227,49,39,95,110,150,187,98,206,181,170,247,47,81,149,9,196,35,3,71,87,255,61,108,176,109,55,104,106,51,44,207,61,138,235,201,20,134,180,61,36,111,83,223,127,8,182,237,164,164,241,
60,59,105,88,78,239,228,142,150,131,239,57,70,150,32,237,252,68,141,37,112,187,66,206,206,50,134,60,111,23,79,162,21,97,9,29,55,135,223,158,74,109,166,180,79,186,43,209,232,179,84,200,98,186,90,98,228,
9,107,13,8,44,89,121,186,176,244,104,64,156,235,232,33,173,172,5,233,219,50,83,120,219,168,220,58,223,158,184,30,118,163,135,84,111,85,47,27,75,104,4,188,85,202,187,201,203,167,149,89,29,143,34,133,4,
72,187,131,236,89,39,35,254,1,219,248,191,36,198,73,105,159,100,164,251,16,149,187,32,173,112,177,171,220,246,87,169,93,86,206,186,231,5,163,203,90,100,248,219,244,89,91,108,125,55,206,142,250,244,93,
226,211,126,141,84,255,5,160,3,114,34,218,54,4,235,208,12,151,235,179,45,39,19,198,72,8,96,142,154,78,22,144,30,101,88,91,35,65,203,181,244,181,217,238,248,233,104,245,143,251,169,11,82,222,113,219,10,
253,47,62,209,1,158,42,96,232,175,229,8,156,152,221,4,91,56,36,249,229,104,130,63,177,208,37,3,219,141,84,49,36,125,40,18,255,184,33,1,204,143,217,38,200,153,246,255,19,195,156,74,217,31,105,119,208,147,
198,112,22,208,136,164,236,141,176,70,64,7,85,116,28,146,174,142,165,54,127,98,180,188,18,85,255,158,103,113,149,154,255,145,171,142,107,248,111,32,58,192,83,85,116,163,205,103,78,249,18,207,237,72,118,
59,61,126,27,162,189,42,4,75,77,121,116,64,252,56,29,88,141,182,169,58,158,170,103,35,124,106,49,99,186,10,134,13,180,209,40,131,149,55,34,59,147,58,64,180,157,137,233,73,148,92,219,45,170,243,159,147,
42,37,234,74,148,70,197,179,84,117,239,175,162,219,31,242,172,83,104,139,50,218,231,234,109,132,82,62,215,244,155,121,145,157,255,140,10,23,119,3,218,70,38,151,74,216,217,219,38,119,201,38,21,118,60,65,
249,165,169,116,249,129,93,150,25,11,127,203,5,196,132,41,63,250,198,82,223,218,30,178,12,165,48,118,8,181,248,115,39,245,156,180,2,99,171,140,61,26,197,231,82,249,17,0,206,92,10,40,43,247,158,34,212,
143,104,219,188,61,213,182,134,88,109,153,126,53,97,50,170,173,146,182,120,153,171,27,59,154,183,215,23,119,220,171,88,198,152,191,155,234,194,216,70,25,97,8,123,186,87,200,215,254,204,9,35,118,31,208,
125,58,153,165,149,173,116,198,20,182,226,12,193,60,23,225,16,60,29,151,47,3,165,109,102,201,113,74,157,61,33,52,147,86,89,230,212,111,79,137,125,18,17,197,86,25,123,58,234,222,158,18,196,16,26,67,247,
230,223,81,47,115,241,66,201,95,34,220,77,106,37,14,101,79,165,45,170,137,154,44,128,16,249,50,162,140,111,159,129,182,189,226,202,120,10,216,211,49,21,24,186,137,101,1,57,6,205,181,154,98,249,55,239,
252,144,23,255,214,90,14,97,91,12,247,45,179,100,198,35,81,227,63,208,149,35,134,9,99,2,98,254,28,242,142,49,172,138,25,26,101,52,2,152,170,27,131,254,125,62,90,48,188,153,70,119,69,63,147,177,165,2,64,
44,153,20,62,97,238,17,191,95,33,223,169,72,247,75,141,170,195,156,196,114,10,249,110,154,2,165,12,120,50,201,137,48,19,156,163,48,7,35,171,200,151,154,195,12,12,147,155,69,153,206,24,51,168,90,225,99,
60,29,248,185,10,138,165,185,86,219,165,167,45,114,31,192,60,30,184,189,160,88,56,241,135,163,158,39,162,173,149,10,143,48,30,201,245,2,194,33,210,25,134,50,44,28,106,244,116,19,219,72,158,15,8,11,196,
130,225,13,161,237,54,40,158,165,150,18,120,75,198,81,7,27,43,196,101,182,169,130,245,98,185,228,247,206,211,214,139,212,30,97,190,142,238,144,102,210,112,89,32,137,137,76,39,239,32,36,70,216,19,170,252,
21,37,101,232,212,157,206,181,230,145,57,122,97,247,138,95,205,126,199,180,102,160,233,236,69,245,61,224,80,133,131,145,212,134,126,74,102,214,98,56,203,5,67,255,165,20,185,37,166,21,211,230,235,93,165,
114,176,189,49,227,227,108,120,130,144,220,52,13,113,105,21,243,192,40,117,255,237,168,92,54,111,30,212,207,203,58,166,45,167,243,177,88,89,123,166,205,122,24,15,242,28,13,140,159,103,141,30,118,105,158,
173,209,20,22,43,60,230,55,73,210,78,189,25,202,183,241,221,95,76,17,3,237,159,242,237,169,52,115,241,230,23,30,52,245,80,107,67,190,185,53,252,159,87,145,234,156,185,149,40,204,64,28,54,54,54,4,72,169,
225,104,151,34,77,66,211,217,101,162,121,33,92,118,146,244,244,182,210,144,127,32,178,164,59,105,106,232,109,153,161,0,249,193,41,181,219,22,135,115,230,84,87,169,106,44,36,130,167,12,48,71,222,2,167,
249,134,195,91,160,227,237,144,114,160,23,89,15,123,240,54,146,218,195,170,7,130,106,160,59,57,208,252,177,158,208,54,74,217,7,92,131,245,89,127,115,171,228,251,251,226,221,68,19,97,215,35,175,120,109,
196,128,123,249,117,169,39,111,131,14,184,220,46,18,240,7,18,212,251,212,93,80,206,115,161,60,155,80,54,224,167,199,60,87,125,231,130,218,246,77,110,67,157,103,29,224,72,89,148,76,165,22,134,58,148,72,
62,101,200,217,131,19,7,31,37,77,111,122,254,141,63,229,13,254,113,191,210,45,54,221,74,51,118,222,226,138,119,64,62,97,210,226,223,93,173,27,218,233,27,14,85,61,243,228,47,90,85,213,7,122,170,63,221,
196,156,22,255,156,98,93,248,60,166,28,234,58,94,187,29,23,101,158,126,29,179,205,99,29,109,150,211,182,210,182,248,102,5,157,34,228,196,41,85,234,176,131,12,242,83,113,8,239,158,16,31,63,165,219,252,
82,118,253,81,125,254,156,62,95,143,178,129,188,197,63,238,199,199,230,78,202,181,21,176,154,150,221,61,48,122,80,124,15,84,188,245,20,85,31,6,242,213,66,174,105,42,56,108,126,136,145,173,81,120,172,99,
242,80,148,26,149,129,173,236,80,131,100,150,118,130,86,146,196,66,212,165,13,177,117,252,34,145,16,51,239,15,201,118,65,109,172,99,221,20,210,67,78,169,150,104,99,228,18,217,174,46,247,81,255,126,222,
248,248,162,213,186,62,165,206,184,27,255,18,106,46,175,110,58,200,177,168,42,86,48,99,58,51,84,191,136,100,128,114,117,166,112,158,138,202,233,76,14,134,139,98,48,27,60,212,141,209,19,182,24,137,92,51,
234,227,201,164,25,119,6,177,88,2,72,6,120,248,47,5,100,201,252,193,198,52,149,12,121,107,237,121,83,39,183,90,201,83,135,137,214,229,35,57,23,177,185,27,197,154,155,223,155,226,203,208,122,204,89,213,
219,83,4,77,224,28,190,254,205,251,111,206,75,122,126,85,117,130,60,107,224,152,243,242,255,255,142,82,171,16,237,104,156,17,10,105,132,13,92,103,189,212,29,221,19,120,12,16,218,17,73,126,129,232,152,
206,152,31,220,35,164,156,232,185,41,230,45,204,21,190,59,69,59,36,238,230,195,27,122,106,51,0,45,222,241,87,83,195,79,46,100,205,243,194,220,43,157,243,194,161,92,142,172,71,246,141,157,61,55,40,117,
152,75,73,10,1,153,74,58,8,236,32,36,83,204,127,42,172,183,29,83,83,207,77,75,103,73,143,50,137,105,196,22,161,9,110,235,148,229,52,138,100,112,35,178,144,129,61,149,239,244,133,172,250,191,114,34,156,
108,86,159,75,109,117,125,74,193,166,38,211,201,201,76,131,139,148,163,146,39,4,200,81,25,53,247,237,80,27,105,80,10,213,97,207,117,66,70,44,69,91,127,207,181,53,18,202,30,198,212,182,34,145,224,142,9,
37,201,127,152,221,170,39,61,153,157,88,70,73,142,38,199,96,233,254,183,138,106,5,198,141,63,223,233,167,53,200,209,242,89,170,181,19,215,160,248,131,216,26,211,133,213,88,100,35,160,179,228,252,224,2,
225,57,207,46,204,44,3,164,45,204,5,181,9,145,115,77,70,40,172,123,79,79,196,247,132,164,251,90,136,65,237,20,228,156,167,20,230,87,218,129,108,46,191,49,54,1,96,18,72,77,192,242,11,233,0,89,188,31,207,
239,238,167,227,197,22,90,60,129,197,78,156,248,78,83,205,83,163,152,6,245,157,144,135,7,23,67,135,14,161,111,21,197,135,137,240,206,134,70,140,24,209,89,32,212,178,42,54,58,163,234,56,138,243,38,140,
124,242,33,67,134,44,176,192,2,249,248,16,185,226,138,43,236,255,233,255,3,79,56,212,141,135,171,235,152,4,91,64,248,157,207,182,228,146,75,162,174,69,22,89,100,240,224,193,48,86,94,105,165,252,88,137,
220,121,167,157,240,45,61,210,230,50,97,72,127,218,206,137,226,218,211,84,60,106,114,50,9,12,70,154,6,135,155,163,115,199,41,247,207,98,75,53,230,31,117,244,207,166,111,243,105,66,190,208,213,87,91,237,
193,251,167,225,123,234,61,119,93,252,151,11,190,242,229,195,70,142,92,152,187,144,111,228,100,148,211,32,103,98,216,176,97,91,109,181,165,98,40,75,236,199,191,78,132,111,21,200,135,42,164,227,67,236,
29,199,31,119,236,148,171,174,188,227,182,91,166,92,117,197,33,7,127,14,133,31,250,133,207,83,103,110,185,249,198,95,252,236,167,43,173,184,2,156,91,108,190,57,156,75,47,181,20,119,230,218,41,87,29,116,
224,103,89,18,140,201,147,39,223,127,223,212,85,87,93,149,245,92,118,201,197,135,125,233,80,62,76,24,76,107,26,137,64,12,73,13,49,91,49,152,89,86,93,117,149,159,158,126,218,173,55,223,136,110,252,249,
143,231,108,190,217,102,38,12,78,197,166,14,87,94,121,101,116,166,231,91,42,151,166,210,53,30,126,241,11,135,208,132,210,207,173,183,222,170,49,196,4,140,91,114,73,212,181,216,98,139,245,245,245,193,88,
101,149,85,0,227,22,153,33,166,115,183,221,118,197,183,57,4,39,151,9,131,49,156,37,214,252,43,46,191,20,107,143,190,113,70,115,32,12,21,178,233,38,27,47,180,208,66,18,0,155,90,116,220,177,199,72,255,229,
151,93,2,194,205,54,219,76,42,145,0,182,113,175,38,111,46,201,207,133,48,108,46,24,124,129,67,185,228,22,154,248,27,127,111,65,231,94,0,71,170,57,232,115,7,63,242,200,191,87,90,121,165,3,15,248,204,102,
155,189,99,247,119,190,123,230,204,153,17,108,150,155,230,47,61,7,60,138,147,22,187,216,213,87,79,201,162,206,0,169,213,195,137,204,80,156,243,223,251,238,183,215,88,99,141,163,142,58,122,234,180,251,
150,95,110,57,192,16,130,187,138,39,159,124,114,223,79,126,106,165,149,86,252,204,254,159,62,224,51,159,57,224,192,131,10,183,91,238,38,91,151,206,180,212,46,201,195,240,48,221,82,75,45,117,198,105,167,
221,119,223,125,123,125,100,239,87,94,121,101,163,141,54,124,224,193,7,67,24,81,241,249,147,120,232,65,29,11,83,191,37,158,199,31,127,226,83,159,254,52,165,254,247,191,31,237,137,6,94,18,49,182,86,171,
49,70,66,254,216,68,200,168,115,206,249,227,47,206,60,19,30,177,21,23,227,50,22,23,49,63,56,229,228,247,237,249,193,87,95,125,85,198,194,126,241,197,23,119,216,126,187,163,143,58,186,127,118,241,55,44,
107,172,177,250,200,81,163,18,147,200,213,21,159,84,43,174,0,171,63,126,129,33,51,22,3,61,253,226,188,38,107,98,63,172,63,231,207,145,114,199,101,155,71,59,51,254,249,207,127,221,125,207,61,152,140,125,
63,177,223,164,73,147,62,248,129,61,193,115,204,209,71,125,240,131,31,192,11,215,45,55,221,184,222,186,235,194,243,206,61,246,184,228,226,191,224,226,229,23,63,255,233,178,203,46,3,15,246,163,171,174,
188,124,167,29,119,196,229,12,174,107,190,118,220,177,243,205,55,31,252,195,230,159,255,200,35,143,184,254,175,215,222,112,221,95,191,114,248,151,49,133,104,193,30,187,239,126,249,165,151,96,20,95,163,
70,142,68,224,166,155,110,2,230,99,142,57,106,210,164,137,56,60,230,168,175,98,232,224,207,29,132,44,215,253,245,154,83,190,127,210,168,81,163,10,116,203,47,204,165,252,78,71,175,189,246,218,219,110,179,
205,247,191,127,242,101,151,95,241,216,99,143,93,115,237,181,248,166,16,188,174,220,127,255,253,231,159,127,193,153,103,158,181,221,118,219,46,188,240,194,105,170,156,209,229,150,91,238,204,95,254,28,
61,188,228,162,11,119,221,101,103,10,153,60,121,213,239,159,244,221,219,110,185,9,85,163,15,88,238,57,84,3,129,249,216,222,31,93,124,241,197,62,119,200,231,177,30,254,249,175,127,157,253,187,223,63,245,
212,83,52,203,171,77,158,140,121,199,181,60,242,126,248,67,255,115,233,37,23,221,121,199,45,167,158,250,195,245,214,93,155,148,224,117,81,77,92,127,127,255,187,223,245,78,132,156,127,222,159,177,150,6,
66,176,226,196,50,139,125,227,111,109,222,156,249,230,180,105,247,209,55,237,38,239,121,247,187,176,38,209,121,244,159,23,155,233,60,240,179,7,220,120,195,117,0,175,183,222,122,50,233,196,137,203,158,
251,167,63,122,139,127,216,176,239,124,235,155,88,249,215,93,59,5,39,209,130,35,70,96,53,206,63,255,252,71,125,245,200,191,94,123,13,156,234,150,5,23,188,231,252,225,119,184,224,149,180,29,219,207,62,
247,28,21,136,215,69,144,224,212,147,98,112,101,58,124,248,240,159,255,244,12,24,191,252,249,79,177,216,240,248,66,230,186,245,182,219,134,14,29,186,193,134,27,208,25,180,243,206,59,95,125,245,213,140,
193,253,220,177,199,28,125,211,223,174,199,205,217,190,251,236,131,64,192,142,58,234,171,159,248,196,190,184,46,185,249,166,27,126,251,155,95,45,59,113,226,183,190,249,141,27,111,188,1,203,120,133,21,
150,39,114,115,217,203,29,6,187,196,69,23,94,64,187,7,66,126,125,214,153,95,248,252,33,82,152,178,145,151,60,52,223,106,180,62,44,46,141,188,239,62,4,212,195,3,111,225,146,228,239,127,127,24,151,108,72,
181,248,226,139,31,244,217,3,112,9,121,202,15,126,240,247,135,31,94,103,237,181,191,245,205,19,111,191,237,246,195,191,114,196,168,145,163,78,59,245,39,116,79,183,212,132,9,71,124,229,203,191,249,237,
111,127,121,230,89,239,125,207,187,183,217,102,107,196,98,91,220,109,215,93,79,63,227,140,211,78,63,29,39,21,150,35,90,128,39,149,75,45,53,129,138,24,220,215,135,192,225,11,12,127,244,177,199,110,185,
229,22,92,15,126,241,208,47,253,242,172,179,176,94,247,251,228,39,142,63,254,235,95,248,226,161,56,171,95,122,233,165,129,46,26,59,5,82,252,245,175,215,37,18,173,190,250,234,179,103,207,126,253,245,215,
19,24,53,180,229,150,91,236,190,251,110,244,205,143,104,177,88,79,63,245,199,11,47,180,48,122,120,251,237,119,124,247,59,223,198,131,23,4,162,93,175,191,62,125,139,173,182,33,25,7,30,244,57,197,150,121,
152,126,233,206,33,89,109,181,201,247,220,123,111,216,118,76,214,169,167,254,248,229,151,94,254,198,55,191,9,158,39,158,120,242,91,223,254,206,255,238,245,209,249,231,95,224,211,251,255,31,60,152,184,
79,126,98,95,53,113,88,33,123,190,255,253,95,63,241,27,247,222,59,245,200,175,28,30,222,105,230,72,106,133,161,141,192,252,137,19,139,255,202,134,56,199,140,25,115,226,215,79,56,251,119,191,251,244,254,
7,224,145,40,93,73,152,78,60,12,193,157,10,94,116,79,62,229,7,239,127,223,123,164,164,15,126,224,3,88,252,63,255,197,47,177,17,211,226,127,243,205,55,209,195,3,14,60,240,11,135,126,105,183,93,119,217,
113,199,29,128,63,248,224,131,176,24,206,250,213,175,78,56,241,27,88,240,204,128,77,234,212,31,255,8,75,235,7,63,252,17,59,243,13,245,250,129,64,236,98,120,169,198,247,38,27,111,140,195,80,204,172,89,
179,206,191,224,66,12,125,243,91,223,198,73,167,174,64,177,227,92,113,229,85,59,149,15,121,177,147,238,178,243,78,151,94,118,57,235,249,192,158,239,223,122,171,45,81,215,73,223,63,5,23,91,203,44,179,52,
134,176,81,124,254,144,131,241,210,123,228,81,71,227,130,236,162,11,207,159,62,99,198,17,71,124,117,205,53,86,255,240,135,62,4,64,108,217,203,29,230,188,243,207,135,242,119,188,99,83,224,151,95,126,249,
13,54,88,255,134,27,254,198,121,109,163,220,26,233,234,201,6,12,50,222,136,114,127,61,21,139,24,0,255,115,207,63,183,196,232,209,68,140,189,96,219,237,119,124,237,181,215,112,248,174,119,237,241,194,11,
47,124,233,203,135,195,126,241,165,151,240,66,183,238,186,235,220,118,219,237,56,252,203,69,23,225,114,6,6,246,95,76,228,37,151,92,138,109,244,194,191,92,248,211,159,253,28,78,188,64,97,171,197,252,193,
14,191,48,19,79,62,249,212,138,43,172,120,243,205,197,58,91,123,237,181,240,136,10,13,253,201,169,167,93,127,253,13,33,62,223,19,238,47,252,202,38,73,150,91,110,210,211,207,60,243,216,227,143,75,39,217,
184,124,192,43,60,94,96,112,73,126,202,15,126,136,107,174,16,3,15,86,30,229,146,252,216,95,102,205,170,240,11,47,92,61,180,90,127,189,245,150,94,122,105,220,83,255,237,198,27,255,114,209,197,219,109,183,
221,123,223,251,158,123,167,78,221,104,195,13,191,122,212,209,184,110,186,233,230,155,183,223,110,219,88,34,51,187,116,74,1,210,159,111,47,55,105,210,121,231,157,111,226,239,184,227,78,60,250,192,16,138,
189,242,170,171,96,96,247,185,241,198,27,241,122,137,173,179,191,127,150,57,113,223,61,233,164,235,174,187,254,246,59,238,192,26,64,153,87,92,89,92,228,190,85,95,152,199,123,239,190,147,178,111,182,197,
86,216,29,240,40,224,146,75,47,133,231,234,41,215,96,239,195,170,51,157,88,213,88,243,95,57,226,72,32,135,15,47,174,212,184,132,139,46,190,248,183,103,255,14,135,120,206,78,139,31,54,86,62,122,130,11,
8,220,229,108,177,249,102,184,255,195,29,30,144,63,252,209,143,57,16,198,172,89,51,191,113,226,9,56,203,62,190,239,190,157,61,106,11,103,124,211,77,54,93,123,173,181,64,126,199,157,119,222,240,183,98,
87,10,197,224,74,29,254,187,239,185,247,239,127,255,59,12,249,133,171,218,139,47,190,228,107,199,29,115,244,49,199,174,181,230,154,184,184,166,19,147,48,91,111,181,213,149,87,94,245,143,242,235,225,135,
31,222,113,135,29,78,59,253,12,12,61,255,252,243,199,29,127,2,140,157,119,220,113,243,205,55,63,242,171,71,97,13,111,188,49,38,124,3,56,205,101,143,87,29,12,201,29,6,23,200,120,191,14,15,0,119,220,97,
251,103,158,121,150,196,3,19,253,170,174,83,163,227,24,192,134,171,134,237,127,54,165,2,185,75,95,142,193,163,12,251,164,103,68,134,177,228,216,37,111,188,233,38,2,222,122,235,109,180,159,226,16,254,251,
238,191,159,246,142,251,166,21,247,20,184,114,185,163,220,82,31,122,168,154,152,251,31,120,96,205,53,215,192,172,224,253,208,251,238,123,128,72,166,78,157,138,23,55,56,233,144,126,206,55,180,250,43,6,
233,132,125,231,157,119,97,115,57,228,224,131,113,159,120,210,247,79,254,213,89,191,34,64,184,116,84,96,120,152,25,242,220,115,207,141,140,220,209,99,175,156,57,107,22,86,36,118,16,108,253,72,65,47,233,
248,28,2,167,235,27,50,4,206,48,215,135,255,247,35,216,43,9,134,183,167,200,24,59,118,44,12,156,102,85,27,239,155,54,126,220,56,132,95,119,253,245,123,237,245,191,184,16,254,208,255,124,240,79,127,62,
87,93,56,80,44,133,144,77,63,195,164,114,84,225,211,96,14,196,109,35,158,157,241,161,52,166,76,153,66,135,160,194,85,201,206,59,237,136,218,177,17,96,239,192,102,138,137,59,242,171,71,127,254,144,207,
225,170,237,164,147,79,62,243,204,179,8,124,207,221,247,192,192,41,135,159,11,142,88,144,156,189,250,217,182,198,103,158,121,230,136,35,143,162,236,120,1,195,53,209,152,49,75,252,241,15,127,32,15,93,196,
154,78,188,210,79,155,86,108,67,248,194,21,55,25,244,243,193,135,30,34,131,22,63,236,37,150,88,226,152,163,191,138,39,90,88,51,248,120,0,246,98,108,76,139,46,186,232,61,247,20,155,136,252,218,116,211,
77,23,25,53,234,130,11,46,124,249,229,87,164,191,27,251,151,103,158,137,27,8,102,8,197,240,144,105,224,234,224,175,215,93,135,107,231,13,214,95,127,251,237,183,187,228,210,203,240,98,73,72,92,108,98,139,
196,133,212,46,187,236,66,30,122,227,1,246,180,251,238,39,207,11,47,190,248,208,223,31,162,107,2,60,150,93,112,248,112,248,105,217,79,43,31,68,96,109,99,67,199,178,39,188,220,97,240,194,243,165,67,191,
136,123,255,29,182,223,254,130,11,47,84,23,22,60,215,205,43,153,55,70,255,153,6,221,241,23,31,159,162,220,198,79,4,248,223,179,13,144,237,226,55,22,212,240,186,235,172,131,103,67,183,221,118,27,249,103,
188,49,131,1,255,122,228,17,92,194,160,30,124,47,187,236,178,240,227,149,132,50,226,106,159,96,19,151,93,246,129,7,30,196,189,6,110,228,151,91,110,34,57,39,77,154,136,229,11,39,94,147,177,73,97,121,193,
79,239,147,18,64,254,68,199,127,253,155,223,110,179,237,118,231,158,123,30,110,21,241,238,57,101,148,152,142,109,204,138,250,6,21,206,4,44,32,188,1,26,210,98,183,61,244,75,135,225,182,142,246,83,0,158,
122,186,216,88,215,94,171,122,122,136,55,115,198,44,177,196,195,15,255,35,140,165,75,87,74,87,252,153,71,249,245,200,35,143,224,247,196,137,19,169,40,24,216,194,224,249,241,79,78,29,59,102,236,198,27,
109,116,250,233,63,253,86,228,114,158,66,228,79,226,140,253,148,72,216,49,152,242,223,127,255,3,216,83,232,245,143,23,49,97,222,120,227,77,50,214,88,125,117,60,156,57,226,171,71,109,189,205,118,103,150,
175,121,152,53,124,157,125,246,217,219,110,183,195,121,231,23,19,71,15,52,128,199,61,160,74,209,195,67,89,23,219,74,182,76,135,167,43,120,117,164,111,188,24,96,89,62,241,196,19,235,111,184,17,125,111,
176,97,177,6,76,39,158,134,225,99,30,68,53,110,220,146,146,19,107,158,14,113,9,140,197,15,27,207,163,39,175,58,121,155,237,118,192,219,188,15,149,27,238,27,111,188,49,125,250,12,76,183,12,132,253,210,
139,47,125,246,192,207,237,178,203,206,120,38,160,134,58,62,116,107,173,34,8,197,132,204,124,82,208,134,50,243,205,55,113,169,8,85,59,237,180,227,95,254,114,17,227,241,196,0,103,49,158,93,112,199,232,
158,21,128,25,51,166,51,172,223,221,156,177,135,150,61,118,15,242,76,114,203,190,8,20,59,12,238,219,230,155,111,24,90,129,167,79,225,173,18,175,103,166,181,13,44,245,193,110,99,132,45,190,233,35,82,198,
219,83,76,164,183,135,242,185,107,117,14,51,40,98,224,115,148,114,100,185,229,151,91,127,253,245,62,254,177,189,79,253,201,143,239,186,235,174,63,159,123,158,28,37,251,154,107,174,197,141,222,71,63,178,
23,150,206,62,251,124,28,15,1,112,103,65,67,120,123,7,79,90,241,70,33,46,81,233,9,200,148,107,174,221,126,251,237,177,71,224,210,31,6,110,22,128,196,29,4,46,103,222,247,222,247,224,230,247,67,31,250,32,
167,192,29,4,246,38,172,84,92,219,98,171,197,221,19,206,67,60,91,193,89,250,90,246,227,75,94,22,210,224,20,100,240,172,176,1,255,21,87,92,249,240,63,254,113,194,241,199,111,179,245,214,19,198,143,199,
139,202,6,235,175,7,18,76,139,10,199,225,195,128,254,243,159,251,124,124,239,237,182,221,22,200,195,191,252,165,233,211,167,227,110,61,68,66,124,157,197,109,104,120,161,198,67,134,125,247,221,7,231,225,
71,246,218,11,175,222,87,93,117,53,98,63,186,215,94,120,25,195,67,61,180,2,167,186,44,65,218,97,150,158,123,78,63,253,12,60,246,193,123,53,216,55,199,79,152,128,79,26,97,210,85,150,113,227,139,43,107,
60,174,193,172,189,239,61,197,131,69,116,11,19,135,217,126,125,250,244,115,207,107,55,113,138,92,214,75,182,2,168,195,186,201,110,0,30,103,54,252,190,252,242,43,177,20,247,254,232,71,22,92,112,65,84,77,
239,59,153,78,220,132,162,88,60,165,193,211,195,61,247,124,191,228,221,118,219,109,176,18,240,184,102,173,53,215,194,99,16,12,141,27,55,238,217,103,159,233,159,53,107,179,119,188,99,221,242,125,93,56,
175,191,225,122,220,38,227,229,10,15,109,177,120,136,1,47,231,120,26,128,123,103,188,49,59,97,66,245,54,131,36,239,192,30,189,196,18,152,59,124,175,54,121,53,92,57,141,91,114,220,51,207,62,51,107,166,
39,6,111,71,227,26,16,143,215,240,142,28,110,50,184,99,180,3,225,240,162,75,46,121,255,251,222,139,83,64,173,109,60,77,222,125,183,221,112,134,226,138,21,133,96,43,200,81,24,91,246,20,203,51,62,253,245,
215,47,189,236,178,3,246,255,52,206,2,220,218,230,48,23,24,218,52,29,186,248,8,170,99,172,247,86,222,100,113,81,229,144,226,183,219,119,249,163,169,149,49,27,231,112,241,6,28,55,72,196,212,159,155,163,
116,10,131,39,134,103,156,118,234,187,222,185,199,153,103,157,245,225,189,62,138,59,80,25,11,27,81,215,95,127,253,241,39,124,125,191,253,62,137,55,61,87,155,188,234,231,14,62,4,175,231,4,195,222,250,211,
51,78,195,27,124,183,221,126,59,61,44,59,246,184,175,225,142,239,244,211,126,242,203,95,252,236,225,191,63,124,194,137,39,2,137,119,144,127,243,219,179,113,207,136,15,192,98,103,226,75,63,132,60,248,224,
3,215,92,125,213,183,191,245,141,165,151,154,128,55,193,238,186,227,182,31,254,224,20,44,53,60,180,81,74,98,135,84,184,250,25,3,75,63,214,214,199,62,190,15,238,86,78,254,254,247,174,190,234,138,31,254,
224,100,186,52,214,239,101,148,49,248,39,144,62,251,217,131,222,124,115,38,96,191,254,213,153,56,33,63,246,241,125,113,73,46,9,19,246,140,25,51,246,253,196,39,177,16,241,118,57,250,128,119,36,46,191,226,
10,172,123,60,81,193,131,188,95,255,234,172,11,206,63,23,111,250,175,179,238,186,170,16,58,76,48,247,106,8,15,43,62,177,223,167,240,248,27,239,65,95,113,217,37,135,31,118,216,168,81,35,21,249,148,41,215,
220,116,211,205,127,185,224,188,63,157,243,123,122,140,8,64,199,19,167,200,195,194,21,160,135,135,184,92,253,206,119,191,135,183,218,241,1,140,107,175,185,122,219,109,182,2,185,233,196,123,6,120,194,120,
194,215,142,187,224,188,243,110,188,241,38,121,130,224,182,253,140,211,79,197,114,189,227,206,59,46,191,226,74,48,252,234,215,191,198,109,254,237,183,221,242,185,131,62,251,179,159,255,2,30,124,29,123,
220,241,88,240,63,59,227,116,76,241,14,59,108,79,78,250,249,189,147,190,143,143,48,98,241,99,119,147,254,206,108,188,75,246,199,115,126,143,239,223,255,238,55,120,66,245,219,223,158,189,216,162,139,221,
113,59,196,28,248,243,95,252,130,46,20,112,75,142,123,193,35,14,255,50,62,195,48,162,124,26,163,22,216,53,83,174,153,57,115,22,182,123,174,20,155,18,54,129,19,79,252,198,212,169,211,126,246,211,211,241,
161,87,44,215,241,227,198,231,136,52,151,61,7,202,25,255,195,31,206,193,75,23,94,149,225,100,64,218,160,143,241,51,166,190,144,193,63,33,237,246,86,207,88,99,77,239,19,27,136,196,48,199,75,3,92,111,206,
124,131,31,124,200,161,222,218,248,91,0,126,244,131,69,112,223,212,123,14,249,252,23,241,236,3,47,245,188,201,82,70,220,63,226,178,20,13,149,2,224,196,53,14,174,197,164,19,54,94,48,17,78,15,80,240,113,
37,124,40,82,1,186,60,68,123,67,6,57,115,168,101,161,17,35,94,122,249,229,16,22,122,240,172,0,116,29,223,213,226,189,111,188,201,75,235,21,23,56,71,31,117,212,251,247,252,0,222,34,195,211,122,124,116,
12,87,178,120,224,16,38,157,155,30,124,212,6,242,112,15,72,73,101,163,200,3,169,40,1,83,41,85,97,226,94,115,47,180,97,136,68,146,109,78,10,195,98,12,50,42,134,97,146,70,3,151,216,120,31,18,235,13,119,
181,12,54,157,88,225,184,133,87,207,248,16,130,69,30,46,126,76,177,58,29,128,4,12,219,220,171,175,20,215,34,221,43,103,181,141,134,41,6,83,140,75,188,14,214,48,30,119,98,162,177,47,243,134,219,40,128,
0,114,217,155,33,120,127,27,175,79,120,102,242,232,163,209,79,13,211,236,163,123,67,134,12,29,54,95,241,20,177,213,151,241,30,78,113,45,234,190,98,219,171,27,111,253,155,23,107,98,190,121,63,101,118,172,
63,52,55,92,64,114,141,50,216,116,98,84,126,112,167,231,251,41,248,19,21,145,54,156,42,188,159,54,246,65,189,78,112,117,153,6,122,197,143,179,113,75,128,211,12,15,1,240,193,178,201,171,174,130,15,24,224,
83,107,153,60,3,7,195,3,141,52,57,191,111,41,97,109,39,174,113,82,36,57,219,157,69,113,184,50,240,170,128,135,230,57,206,216,167,232,204,197,31,158,14,72,17,99,80,217,123,126,104,138,105,156,226,152,12,
92,15,209,251,141,49,0,251,249,60,34,207,235,229,103,135,224,12,103,112,252,248,113,88,249,95,56,228,16,60,157,79,236,167,224,169,99,113,201,29,191,190,100,13,202,40,223,241,151,62,255,82,11,219,107,140,
84,6,229,219,181,220,236,24,124,12,101,250,244,215,179,225,89,64,179,233,28,169,230,137,252,29,40,103,194,208,232,45,27,241,43,217,252,143,43,227,163,212,103,252,244,103,7,28,176,63,158,228,62,245,212,
211,223,254,246,119,126,115,246,217,161,36,21,78,128,129,208,25,166,254,175,231,191,29,232,172,3,249,235,19,79,162,247,223,255,255,240,44,245,228,147,79,201,204,213,87,94,91,202,75,204,88,160,220,36,7,
175,185,246,250,18,167,227,253,219,46,252,113,72,255,236,234,19,15,50,170,183,118,122,191,235,109,174,255,178,245,182,3,188,47,231,175,245,142,5,80,174,185,144,168,99,133,189,13,156,155,189,101,229,156,
20,158,1,109,181,76,212,125,46,197,198,229,180,98,30,210,55,116,216,176,246,55,254,120,235,73,230,211,118,121,209,90,239,193,3,190,157,22,249,205,153,11,123,100,194,180,126,119,140,240,86,120,23,55,87,
127,227,86,221,124,191,80,138,8,251,128,209,204,210,84,108,102,148,204,222,104,15,4,103,44,233,220,204,21,211,48,55,253,249,245,210,68,227,205,103,188,151,12,133,249,129,97,57,102,172,90,72,97,84,232,
49,121,36,172,17,0,48,231,109,4,55,2,100,234,152,141,205,175,222,250,2,144,190,250,116,128,226,63,231,231,236,232,239,58,120,142,241,14,76,52,172,167,3,137,30,81,163,19,0,8,73,143,242,84,73,201,233,16,
137,236,149,141,79,158,53,38,109,4,36,196,116,19,155,160,149,67,102,39,1,200,79,45,25,58,139,98,61,233,112,153,40,29,2,164,162,162,88,229,100,146,208,48,115,49,44,135,71,50,152,120,126,116,14,218,217,
213,45,107,247,127,151,195,26,61,195,20,224,33,186,56,144,149,130,70,230,146,118,199,25,152,191,145,109,206,156,193,245,214,231,242,241,38,203,134,27,169,126,183,251,131,212,190,62,188,131,87,237,170,
141,130,84,166,156,67,94,22,141,23,107,146,45,95,9,186,105,130,77,39,167,200,159,3,14,233,204,72,203,232,140,115,46,71,117,95,66,103,12,29,68,229,135,132,200,208,147,238,115,91,124,200,214,200,32,63,9,
222,8,14,249,67,79,236,100,9,145,49,15,157,56,109,197,228,224,249,148,84,169,205,216,24,56,93,32,70,177,221,133,95,225,38,171,48,198,59,254,10,33,15,241,119,3,166,104,137,233,198,230,101,49,64,89,58,163,
237,44,42,209,7,154,227,158,211,38,50,210,80,184,182,230,190,134,70,145,93,2,194,26,137,240,45,175,84,10,75,139,97,100,26,134,186,24,153,83,35,93,175,228,95,172,52,102,111,156,169,14,24,32,50,71,97,43,
230,86,96,46,10,81,125,214,31,227,48,128,13,186,92,229,173,54,216,82,253,247,163,138,63,15,16,95,248,124,156,56,234,189,217,89,241,189,215,81,50,182,90,175,173,52,132,101,82,174,208,223,138,150,192,44,
59,100,83,30,32,25,140,88,53,202,169,123,168,141,57,123,101,132,218,98,85,132,25,101,237,52,170,98,67,128,9,11,153,77,143,34,103,76,55,37,196,56,153,92,26,116,189,210,42,68,134,207,29,59,253,236,139,239,
98,73,76,206,230,219,141,108,108,119,234,238,158,247,77,73,171,156,122,75,85,143,86,37,26,236,67,251,134,206,233,31,74,255,12,190,36,237,149,45,23,241,91,62,247,115,83,64,15,115,229,83,101,34,51,97,177,
53,144,121,221,17,11,79,251,187,209,214,24,219,8,72,107,203,28,157,59,89,32,38,157,72,158,122,105,229,105,158,116,108,227,168,34,87,170,248,115,129,221,191,237,214,168,4,255,13,37,124,201,13,176,14,81,
215,157,60,80,94,128,122,91,170,186,130,101,36,25,96,7,160,111,190,249,250,223,196,127,175,160,254,115,0,5,235,230,80,53,148,168,84,91,67,126,51,74,194,26,207,106,149,162,145,80,146,255,215,78,119,32,
125,221,145,142,125,203,71,213,194,128,158,46,215,6,17,118,73,50,16,109,25,32,73,97,3,211,61,4,94,42,145,118,81,245,156,206,223,112,99,37,154,211,234,38,30,163,226,19,84,246,126,138,191,47,77,190,165,
95,108,169,188,147,198,40,56,41,0,248,143,21,12,29,58,12,127,150,202,127,153,202,90,9,150,163,152,9,115,140,238,9,27,207,234,238,83,228,20,50,208,24,57,17,221,87,36,217,164,242,86,204,68,194,84,173,98,
101,210,124,155,115,169,144,206,82,247,247,235,75,135,46,111,54,19,50,160,60,54,26,22,21,67,170,170,91,29,202,44,189,226,79,243,80,70,137,145,118,66,60,75,205,196,131,74,34,57,92,166,96,64,121,125,58,
223,144,190,232,191,135,144,222,39,139,45,53,141,144,89,201,198,127,172,19,127,252,218,223,55,164,252,11,92,250,35,108,172,60,250,7,19,6,69,133,132,68,228,241,158,214,66,141,198,21,143,111,75,76,253,1,
218,0,83,196,40,30,120,4,172,181,42,60,251,199,52,20,188,61,253,10,69,130,94,232,212,201,76,188,2,201,112,135,31,34,157,10,207,135,14,92,57,204,16,133,193,127,186,134,208,38,152,153,97,200,64,7,238,96,
22,36,101,109,19,185,163,173,253,161,229,100,20,169,5,62,250,158,0,240,37,140,166,62,60,173,210,75,130,105,211,176,80,38,121,116,127,156,248,26,239,74,32,36,167,171,1,206,234,76,128,139,118,179,204,199,
3,105,232,170,219,228,234,38,182,202,131,150,22,147,142,135,10,120,247,29,143,79,113,125,90,176,182,218,21,249,170,20,129,246,63,65,77,8,74,25,82,211,117,239,208,224,234,215,64,138,191,144,13,71,171,146,
122,241,75,10,6,95,126,46,21,40,181,152,36,9,60,199,154,129,60,90,24,234,177,137,255,30,160,135,236,201,129,74,7,206,54,25,195,146,211,5,74,188,137,148,0,170,207,131,133,106,85,19,218,136,87,161,124,168,
52,72,1,106,136,67,230,130,33,101,204,133,116,153,41,194,134,136,211,26,87,127,53,141,169,95,134,135,129,102,72,205,24,179,210,139,36,189,66,210,177,200,8,64,154,33,80,37,171,40,62,234,47,143,9,28,122,
36,73,122,180,51,36,162,100,235,115,100,120,137,210,127,3,38,161,108,151,93,227,90,194,236,12,100,67,98,56,144,71,165,33,145,236,231,16,122,77,226,195,14,166,144,57,155,141,96,125,64,91,157,186,57,222,
122,125,138,45,74,191,165,49,238,116,246,244,131,42,112,166,195,85,82,53,17,28,91,24,97,21,121,250,85,10,227,48,100,54,64,17,87,226,100,14,105,9,44,253,137,240,72,66,184,85,151,224,225,70,41,155,56,90,
61,209,148,84,173,2,41,151,249,179,113,145,152,81,206,89,95,252,151,79,0,138,215,4,249,194,128,67,169,217,69,229,254,142,62,130,205,37,200,198,53,158,201,185,101,200,5,68,217,241,15,85,5,151,204,172,203,
164,13,197,152,48,38,33,35,7,67,39,170,250,180,135,201,35,214,113,61,199,118,10,46,185,253,9,147,232,140,82,149,127,152,207,105,151,147,204,212,42,68,244,176,38,149,12,210,174,17,165,21,86,145,0,171,216,
244,97,200,12,188,188,64,163,240,240,65,109,225,199,92,251,179,44,106,172,215,9,49,144,96,153,174,42,129,23,12,225,248,167,207,12,183,32,175,64,157,52,65,166,203,72,129,76,141,89,66,97,92,4,98,19,225,
137,64,98,144,177,253,242,97,16,39,232,206,24,10,5,50,71,197,38,123,36,19,4,253,146,131,105,27,89,194,106,141,212,105,22,44,130,96,247,4,137,226,145,137,164,205,220,21,158,203,76,212,197,24,10,78,32,75,
0,201,83,122,56,175,52,114,48,85,78,87,50,135,152,69,17,152,49,230,161,20,208,96,171,194,129,118,181,83,10,83,131,202,30,166,48,163,36,172,145,161,99,176,12,132,221,42,145,138,77,31,154,204,225,5,90,164,
21,250,124,52,216,252,169,153,19,188,135,198,51,165,117,114,160,63,149,26,214,242,88,158,146,161,218,218,195,217,51,248,211,23,37,76,192,61,228,44,108,48,198,48,218,40,41,194,93,187,12,170,210,197,50,
112,100,95,165,202,30,73,150,80,174,228,146,72,105,115,20,27,114,180,173,93,145,132,77,17,101,103,38,226,50,19,120,198,208,85,134,186,65,128,120,21,139,67,244,68,181,69,97,184,100,130,197,70,25,22,2,200,
163,178,16,62,198,105,130,41,36,228,135,159,11,103,25,10,108,70,17,70,230,82,48,117,40,145,50,86,193,148,6,227,144,215,131,88,6,128,133,252,112,230,144,83,160,141,228,92,69,2,125,229,104,104,139,184,108,
114,7,150,202,21,146,167,134,175,124,195,101,233,104,212,239,74,173,34,84,160,182,135,153,108,44,91,242,115,9,228,228,66,50,57,51,97,50,35,108,83,137,194,200,67,47,139,156,125,7,146,47,0,226,115,169,2,
106,188,238,185,224,250,119,185,152,188,100,245,88,143,45,185,188,28,181,94,202,29,40,201,9,97,76,120,149,65,74,44,109,197,8,7,58,193,213,111,121,174,106,140,152,2,21,101,158,186,58,188,200,42,222,44,
240,207,118,3,172,115,120,199,109,241,85,112,41,64,175,31,95,137,76,211,34,139,44,77,82,148,228,124,146,40,66,117,40,227,210,118,34,144,115,129,65,193,218,46,6,214,16,11,36,128,26,229,164,198,154,140,
117,169,206,164,79,28,30,233,161,97,10,102,217,50,145,81,130,27,86,36,112,27,12,177,122,227,75,206,224,105,67,34,103,223,41,245,132,213,91,170,9,229,152,208,48,202,43,196,234,39,65,97,96,7,30,59,23,17,
113,59,146,77,108,76,26,206,95,69,207,175,155,56,230,92,130,174,218,62,18,217,253,158,168,90,252,188,169,229,174,2,133,132,218,148,147,216,140,183,202,169,185,76,43,81,102,137,151,2,152,192,86,162,178,
119,196,140,20,68,110,167,96,5,202,80,169,105,180,73,0,115,36,114,37,134,56,220,52,188,64,83,30,194,50,20,202,254,227,2,80,46,94,202,203,137,252,133,231,137,98,140,231,245,47,249,21,70,177,169,81,197,
147,121,8,18,166,53,9,203,81,251,148,241,240,212,79,179,123,214,80,157,84,189,233,93,50,120,204,126,37,20,88,60,75,149,126,51,64,97,36,190,178,121,17,32,171,165,18,176,4,137,153,180,222,191,204,94,56,
17,188,134,10,18,150,225,70,171,223,62,67,76,137,45,67,80,113,46,242,53,226,9,134,168,4,18,67,166,158,68,72,162,204,48,42,65,174,202,17,133,70,205,144,95,66,205,92,0,144,223,139,197,76,185,73,49,70,203,
16,15,239,182,206,58,93,222,92,215,248,210,114,10,189,53,79,24,149,78,5,230,31,186,20,58,34,205,239,71,85,242,212,158,72,12,62,50,149,165,186,0,52,27,53,88,63,177,149,180,176,149,90,57,138,148,106,212,
244,176,50,21,203,126,73,18,98,104,84,98,56,144,141,244,40,195,104,157,155,96,243,20,96,164,14,228,78,186,165,203,41,200,160,64,252,205,126,242,67,193,101,48,231,160,72,170,223,239,130,92,163,133,141,
16,31,224,101,87,132,222,152,59,224,106,211,96,57,202,33,196,81,15,81,47,92,35,106,191,203,149,249,91,5,170,2,213,40,115,198,252,81,0,207,28,35,156,114,114,168,50,25,101,38,42,156,138,208,177,153,120,
102,235,192,200,39,148,37,84,81,190,200,250,225,148,239,47,84,149,250,37,131,148,170,52,168,57,98,164,130,177,223,235,149,107,84,61,234,94,30,164,135,109,226,140,50,51,142,12,170,203,165,48,163,204,155,
98,19,169,184,229,33,55,202,11,228,174,38,5,48,143,23,203,222,60,35,39,54,7,147,151,205,64,37,200,19,67,32,162,81,177,132,170,93,46,29,53,20,11,148,98,66,28,252,161,147,50,113,26,19,64,101,37,134,10,0,
79,42,108,55,175,133,233,95,53,75,79,3,97,176,143,11,170,106,151,7,155,151,183,96,151,47,6,197,120,254,87,163,158,124,42,137,228,115,64,58,187,177,21,97,174,108,57,65,156,190,169,93,162,231,28,99,24,161,
6,18,89,251,57,123,152,177,28,242,30,215,134,24,151,179,38,116,158,244,111,217,43,51,214,116,166,57,195,209,178,75,222,194,235,9,45,18,153,253,39,114,127,40,107,119,8,149,183,246,240,60,182,138,140,79,
104,43,26,2,251,133,123,4,117,219,77,157,165,140,26,227,133,150,7,86,84,125,227,47,19,19,75,130,43,49,20,230,53,61,222,218,21,87,202,233,83,133,68,38,178,243,16,151,195,30,146,33,243,194,163,70,43,169,
86,167,186,217,124,85,7,88,155,242,211,161,41,41,29,130,64,29,37,74,48,159,246,130,80,135,84,233,221,27,92,230,178,22,180,158,120,7,174,56,155,96,94,108,121,64,129,162,76,241,42,232,208,110,212,219,140,
48,104,23,226,162,98,191,29,91,53,78,36,9,42,133,151,180,58,74,150,239,58,147,194,203,177,238,108,79,137,148,129,46,225,179,86,150,152,198,132,45,10,39,46,145,87,157,110,141,185,42,130,240,25,176,25,41,
18,121,227,126,153,94,79,60,92,125,96,234,212,129,97,186,242,122,148,47,2,73,117,228,67,84,140,170,147,86,150,78,19,0,224,224,57,72,128,229,144,89,15,120,36,134,242,132,30,43,127,225,139,33,99,126,201,
99,234,161,64,46,77,226,115,56,59,199,151,19,153,126,165,169,201,121,214,197,170,34,205,74,164,58,172,25,68,96,237,172,231,84,111,103,132,81,108,102,3,129,84,48,201,111,243,248,235,80,135,115,177,33,81,
164,10,9,212,108,114,204,178,243,241,178,252,252,40,43,103,147,47,209,1,132,134,77,0,62,116,54,38,201,220,224,192,67,122,68,10,179,124,243,36,106,82,81,140,7,129,89,171,49,135,57,79,167,145,14,15,78,213,
243,153,250,29,127,121,71,108,94,215,228,40,35,140,214,23,52,90,81,21,248,216,226,16,211,163,162,6,238,80,235,23,153,82,82,9,214,19,193,178,27,37,161,92,76,149,188,0,131,252,242,100,102,213,6,158,199,
138,24,111,161,200,68,18,229,61,115,247,67,36,140,236,68,3,43,176,20,31,198,59,79,253,68,213,121,124,121,158,114,7,41,126,55,11,144,232,14,108,83,191,107,11,101,247,165,250,57,204,112,64,28,131,143,246,
143,100,172,123,106,231,35,140,163,170,33,224,151,225,6,176,116,133,50,204,168,0,102,46,63,149,4,74,140,217,49,249,85,100,49,173,129,171,149,67,102,17,226,83,51,229,243,135,202,195,146,235,45,85,142,85,
145,82,1,83,11,41,236,75,27,196,28,170,145,81,50,187,244,147,173,99,77,97,128,182,215,22,230,106,244,72,169,242,42,138,94,203,181,84,166,139,105,86,178,75,152,76,65,4,33,45,48,181,211,145,123,23,179,156,
186,76,17,114,122,204,146,193,106,163,12,175,243,202,20,109,108,201,150,136,203,79,148,143,76,164,203,31,234,82,127,44,188,170,194,205,133,169,71,197,102,22,46,118,141,232,235,16,167,11,57,85,82,66,134,
176,208,83,32,85,57,77,171,139,101,72,163,98,150,84,22,143,12,9,109,89,133,45,213,143,9,49,162,141,53,84,193,234,45,85,14,184,72,163,251,18,86,179,58,203,5,186,99,247,59,29,5,84,35,192,49,21,191,101,107,
164,191,21,137,12,236,216,14,111,137,98,29,128,234,88,22,150,93,198,214,48,246,83,96,200,44,60,149,201,122,40,150,1,56,84,30,22,227,48,209,188,132,244,196,200,149,205,68,108,4,107,221,165,168,103,217,
99,67,96,154,144,153,1,164,63,190,12,82,8,200,220,48,181,254,150,57,195,185,144,132,177,229,77,73,10,100,216,174,166,134,72,126,22,27,206,11,13,177,159,145,202,48,217,20,134,15,85,57,50,54,76,36,71,153,
1,134,67,54,172,210,58,68,181,168,236,143,65,94,194,162,23,34,76,231,218,107,48,48,198,25,245,150,234,60,197,239,156,200,26,47,212,107,113,78,10,192,174,41,121,228,130,51,231,218,179,157,224,90,122,97,
145,48,155,129,101,136,66,108,164,207,217,217,81,205,204,121,137,72,44,8,110,163,74,193,155,105,21,81,94,63,215,132,14,29,122,220,72,139,223,234,36,65,164,71,171,196,243,62,104,102,40,75,11,9,25,203,247,
1,178,64,47,93,9,141,181,133,121,216,8,99,121,200,48,184,22,177,0,12,88,142,139,169,28,56,118,178,144,194,88,69,165,191,222,89,136,44,85,84,144,183,202,31,124,52,213,233,242,103,147,189,157,26,9,109,137,
33,149,141,145,220,22,54,24,201,24,120,212,138,146,67,140,15,97,114,72,218,85,184,217,201,96,97,216,91,170,164,107,180,149,122,137,151,149,176,173,122,193,126,25,152,224,148,48,182,37,167,73,88,33,173,
166,212,43,59,232,14,203,72,113,178,136,76,195,210,160,66,57,47,249,101,246,218,150,60,129,114,69,216,219,67,104,80,13,151,135,88,207,44,210,247,27,42,8,201,248,16,161,158,253,135,0,242,36,24,98,33,240,
155,242,36,149,156,8,233,79,112,214,67,152,32,49,47,146,170,198,8,171,226,119,211,90,47,75,129,105,54,69,70,2,199,242,182,46,167,57,183,129,48,59,108,224,34,174,80,164,234,82,36,46,245,241,134,152,164,
48,23,35,97,96,212,236,100,24,213,131,45,53,36,181,235,76,172,149,96,29,152,156,92,33,248,77,128,157,87,120,205,166,136,241,202,100,114,54,66,12,60,82,15,14,211,96,102,200,209,80,83,185,166,85,225,162,
81,224,33,24,205,55,243,195,96,97,53,143,112,74,164,180,37,88,250,77,187,0,11,109,245,249,95,42,52,5,152,60,153,78,38,204,196,75,152,170,171,145,42,6,48,253,138,92,230,229,9,34,103,2,169,162,232,144,254,
99,30,120,96,35,71,165,109,19,6,248,122,106,16,44,214,143,164,74,217,68,24,6,6,137,60,18,135,183,69,122,208,78,14,218,157,68,126,134,124,73,10,169,14,11,86,217,4,87,114,253,185,84,206,107,68,242,88,7,
6,103,117,41,137,67,46,80,206,40,157,156,138,71,217,224,161,182,70,247,12,50,99,3,27,23,206,49,101,7,26,162,24,92,26,106,233,212,111,187,151,119,109,212,174,144,48,244,128,76,59,67,121,0,249,115,228,107,
209,71,74,27,13,83,22,157,75,135,182,62,110,65,104,214,133,132,174,52,166,74,47,182,214,18,131,128,42,145,210,227,100,4,240,202,193,242,26,255,41,79,83,63,234,140,49,195,207,228,245,94,208,164,135,102,
185,14,116,236,230,236,187,65,145,136,93,49,67,245,135,96,77,170,66,61,85,28,63,39,66,35,194,79,94,155,185,88,88,83,82,6,178,33,155,192,146,236,207,165,114,76,109,72,53,86,238,216,233,29,155,18,185,59,
112,22,150,5,143,209,17,198,101,24,195,135,15,127,227,141,55,202,255,58,214,160,29,118,216,14,255,105,215,139,47,185,52,35,46,5,9,23,177,20,172,34,101,187,105,40,1,86,177,124,168,66,152,147,252,106,148,
162,66,145,204,230,27,198,185,103,18,250,81,245,81,43,112,29,150,105,201,245,134,16,107,201,153,76,220,34,53,170,212,102,119,73,209,100,29,250,228,94,159,149,140,24,157,207,160,81,68,146,73,165,131,203,
99,238,82,35,73,12,16,243,203,116,84,69,26,201,74,100,96,58,68,34,149,157,14,228,92,188,241,242,3,250,34,80,45,57,69,205,135,98,41,154,233,178,111,252,5,81,157,91,56,77,118,200,32,191,181,68,170,165,150,
10,52,139,20,73,193,31,50,191,239,125,239,121,223,123,222,189,242,202,43,189,254,250,244,187,239,190,231,144,207,31,186,243,206,59,14,233,75,109,169,76,18,19,67,253,76,143,154,98,26,67,136,57,243,103,
14,91,14,70,167,51,251,204,32,191,225,149,219,12,177,144,220,91,230,179,21,42,66,71,69,225,118,8,51,10,35,138,244,249,205,79,56,34,87,174,90,145,49,12,225,65,83,140,196,155,0,132,199,252,204,220,165,81,
241,83,79,92,171,59,227,148,229,40,6,163,10,127,22,128,239,246,185,132,74,153,60,100,61,225,3,250,178,138,250,197,143,255,3,42,224,227,109,151,184,65,18,150,204,204,192,228,110,169,146,133,158,242,132,
201,224,145,212,164,128,246,95,175,113,213,64,243,165,7,191,170,112,68,152,162,190,218,45,65,123,236,177,219,225,135,29,250,163,31,253,228,11,95,56,108,161,133,70,172,190,250,106,175,190,242,138,12,55,
109,146,141,26,101,153,18,105,212,37,135,157,93,192,130,69,227,6,155,235,173,145,49,146,142,86,63,23,21,171,130,251,108,3,32,38,200,203,33,181,102,115,246,139,115,198,125,62,59,32,145,177,38,33,1,108,
85,50,184,194,185,199,142,86,34,197,111,114,154,206,48,143,244,112,111,165,179,146,163,206,69,135,232,32,139,11,109,249,59,182,138,152,166,252,75,129,124,61,178,88,142,98,131,89,19,134,154,5,133,44,168,
164,102,107,30,85,72,39,135,50,5,226,203,44,170,138,234,169,139,66,186,100,197,110,22,211,54,103,206,224,53,214,92,207,33,203,223,17,22,15,211,234,32,150,27,36,141,185,18,177,78,131,156,102,248,174,184,
236,226,7,31,122,232,83,255,247,25,55,94,252,254,238,183,191,137,159,175,189,254,218,22,155,111,126,199,29,119,254,228,180,211,239,189,119,42,60,31,216,243,125,31,254,208,255,140,30,61,250,150,91,110,
61,253,140,159,221,117,247,221,112,78,154,56,241,240,47,31,58,121,242,228,167,159,126,250,71,63,58,149,30,23,108,185,197,230,123,239,189,215,74,43,173,120,223,125,15,156,126,198,79,111,184,225,70,32,229,
151,146,33,135,26,109,53,157,192,199,216,8,25,27,109,76,196,128,48,35,13,49,51,94,92,228,27,35,6,62,156,187,200,100,49,167,65,194,130,154,12,38,97,96,200,22,98,18,96,30,154,215,140,68,21,36,181,85,225,
20,194,215,64,92,44,79,110,200,198,152,183,196,144,229,87,218,194,149,70,202,34,235,173,81,182,76,1,112,162,3,10,233,129,149,42,39,6,33,125,197,190,38,190,241,50,146,249,61,100,104,31,127,167,66,202,75,
63,100,146,223,85,217,208,129,215,201,120,70,217,29,25,78,54,141,162,35,252,61,122,177,197,71,143,94,252,250,235,255,198,158,202,24,52,103,235,173,183,124,243,141,55,143,58,234,216,241,227,199,125,242,
19,251,144,255,137,39,158,250,222,73,167,236,179,239,126,243,207,63,255,126,159,44,156,248,79,120,159,114,242,247,22,90,104,161,163,143,62,238,206,59,239,58,241,196,175,77,158,188,234,144,33,67,14,63,
252,75,247,78,157,186,223,255,125,102,202,53,215,60,254,196,19,161,24,157,81,168,50,135,114,74,147,24,178,185,112,147,51,223,9,182,176,4,56,153,161,191,127,54,219,48,56,47,75,10,103,141,135,60,99,206,
28,92,165,210,119,243,43,168,140,20,107,18,129,5,131,223,82,137,37,91,1,228,97,8,238,177,199,87,43,79,168,202,142,229,11,2,165,236,218,118,61,44,46,249,101,72,73,91,195,252,22,113,231,251,103,245,99,66,
229,55,135,84,186,36,39,236,156,47,21,66,135,145,192,112,177,193,227,97,29,91,165,185,44,132,0,225,74,35,143,23,110,30,56,78,175,99,98,65,82,19,170,80,11,44,197,16,184,46,196,223,181,56,63,96,197,127,
116,154,143,97,192,37,15,107,27,41,253,175,250,121,132,219,161,253,241,212,145,108,104,52,35,19,148,169,83,23,219,132,156,51,103,226,196,101,96,222,117,231,157,69,19,249,171,148,247,234,171,175,30,115,
236,241,232,231,248,9,227,62,123,192,254,125,125,125,120,231,106,202,148,107,128,90,98,137,37,110,186,249,150,253,63,189,31,156,235,172,179,246,82,75,77,216,103,223,79,221,124,243,45,151,92,122,217,54,
219,108,245,174,119,238,126,194,215,139,139,220,201,171,78,254,211,159,206,251,229,47,206,98,98,109,180,233,67,115,213,154,189,71,199,212,153,248,199,188,205,52,164,86,206,154,9,51,156,170,39,200,174,
60,28,35,167,12,206,24,140,241,9,67,81,41,164,197,76,165,117,60,41,124,18,169,141,130,79,166,24,51,7,178,198,26,41,171,240,53,243,68,212,96,142,23,134,36,207,71,130,128,193,137,68,146,156,115,114,32,123,
200,40,94,9,232,203,47,132,97,204,86,49,136,218,59,123,102,8,102,230,228,44,202,144,106,19,224,90,60,58,147,241,95,78,204,125,199,159,83,122,58,202,21,36,61,74,116,236,208,11,17,237,179,241,60,13,10,201,
126,10,27,60,248,185,231,95,128,57,114,228,40,239,132,68,212,156,65,83,167,78,155,51,187,152,215,23,95,120,17,215,164,184,56,134,125,224,129,159,217,97,251,237,134,12,233,155,57,115,38,46,69,241,53,118,
204,24,248,31,120,224,1,252,196,254,123,223,253,15,44,57,110,73,24,7,31,252,133,35,143,60,252,156,63,252,22,207,1,142,251,218,9,175,189,246,58,0,234,203,43,138,198,72,176,210,169,194,212,161,170,17,163,
173,194,21,155,127,88,158,33,254,213,129,15,192,145,81,133,195,20,67,161,60,55,202,58,249,60,228,17,97,212,127,5,32,156,133,201,11,76,249,249,48,33,140,49,100,164,169,20,143,84,203,182,194,120,85,139,
233,96,60,11,176,247,80,213,52,193,64,129,58,29,188,8,241,97,50,151,129,103,5,165,33,193,52,34,61,97,120,232,161,168,152,31,163,137,33,138,149,63,105,70,194,16,169,138,240,206,227,126,11,22,238,45,124,
33,149,0,86,38,99,12,174,18,98,250,57,170,128,208,196,197,39,162,128,72,89,37,173,119,137,90,122,188,31,200,74,223,236,101,15,11,146,30,118,50,190,209,64,187,27,190,75,13,5,15,106,147,223,62,53,82,227,
150,252,245,215,95,223,98,203,205,61,73,224,31,60,120,250,140,25,148,133,131,86,91,109,242,62,31,223,251,216,227,142,223,105,231,61,126,243,219,223,151,252,131,30,125,236,81,24,19,39,78,36,216,196,101,
151,121,254,185,231,97,223,115,239,212,15,254,207,94,135,125,249,136,45,183,216,98,223,143,127,172,186,35,224,219,49,113,159,66,129,244,83,101,44,156,152,164,216,119,25,99,180,130,203,39,210,246,63,185,
27,28,138,117,16,251,102,140,105,24,242,112,151,67,147,226,2,98,204,228,119,40,253,187,24,165,126,70,180,233,39,222,94,231,0,0,64,0,73,68,65,84,128,240,216,53,214,156,29,86,165,226,66,63,60,10,35,171,
150,67,28,27,26,18,38,195,97,203,33,10,148,30,178,139,16,119,234,145,33,83,24,120,7,166,33,9,14,237,48,28,30,149,46,243,208,164,170,157,254,140,20,126,120,50,190,160,185,191,95,127,203,66,42,42,199,175,
207,41,63,133,12,84,182,4,210,144,244,84,19,231,122,27,78,4,66,36,158,108,227,163,254,18,100,198,72,64,101,171,78,225,28,203,254,146,215,213,70,144,163,66,61,198,104,233,34,145,248,57,99,250,140,95,255,
230,236,143,237,253,145,199,30,125,236,242,43,174,154,111,232,208,229,87,88,238,210,75,47,47,46,83,113,169,41,234,7,219,184,241,197,229,231,83,79,61,61,97,194,120,220,221,23,76,115,6,77,155,118,255,51,
207,60,139,119,162,190,251,221,147,55,219,108,211,49,99,198,76,185,230,218,5,22,88,96,171,173,182,184,233,166,91,174,185,246,175,79,61,245,212,235,211,167,243,137,65,162,4,177,161,209,87,222,92,133,65,
209,157,75,22,222,204,36,167,210,53,159,163,76,42,42,80,13,249,85,51,129,241,170,206,99,212,85,197,83,140,66,82,160,132,163,216,224,73,97,15,25,6,161,66,148,135,9,88,116,72,246,202,226,172,4,152,255,212,
75,34,182,229,99,25,100,81,10,99,205,87,26,41,42,13,86,204,138,33,125,104,205,72,177,254,153,179,50,204,86,52,205,184,69,94,201,97,254,6,121,254,150,162,250,0,146,102,30,75,185,241,33,42,131,200,138,44,
228,186,178,85,121,6,67,188,56,21,171,128,76,197,134,2,168,243,237,135,63,252,9,0,31,251,216,71,15,58,232,128,25,51,102,220,118,219,237,151,93,126,5,46,110,33,181,106,89,169,25,108,215,94,243,215,91,110,
185,237,79,127,252,221,203,47,191,114,202,41,63,252,202,87,14,67,32,254,58,224,211,251,127,246,248,175,29,115,254,121,231,192,62,245,180,211,175,158,114,13,222,173,250,212,126,159,56,225,248,99,225,185,
235,238,123,126,247,251,63,0,73,122,234,7,202,90,150,247,174,125,45,62,214,73,25,238,186,42,125,100,243,172,215,132,33,72,121,100,198,56,51,7,201,233,144,89,56,53,35,121,148,13,30,130,97,58,37,128,236,
144,54,196,20,203,204,172,66,58,145,81,62,231,10,42,85,137,50,229,25,98,132,75,246,74,184,11,83,241,35,59,123,156,146,232,139,107,154,74,141,154,135,156,139,71,93,82,45,12,128,16,12,39,227,217,48,97,204,
111,26,153,33,102,27,205,88,22,99,166,107,235,52,83,20,36,254,186,170,104,131,21,5,63,41,231,157,153,46,173,130,15,81,85,4,222,175,116,37,134,50,165,201,82,227,37,72,28,40,42,32,125,54,104,171,4,248,200,
81,163,70,190,242,234,107,244,215,83,9,250,17,35,22,196,95,4,224,114,85,97,70,140,24,49,125,250,244,42,188,28,197,19,88,188,110,225,169,171,66,182,58,76,119,146,168,140,126,182,202,81,177,184,138,100,
187,184,76,233,52,201,25,41,71,131,168,176,156,206,196,51,143,25,206,163,85,101,229,202,85,78,41,51,211,54,115,101,198,54,194,114,228,245,94,128,57,107,208,26,76,92,173,95,133,36,144,136,81,96,98,73,135,
212,153,58,183,114,154,25,99,79,53,153,202,9,244,135,233,10,18,89,123,16,34,179,15,94,99,141,117,229,177,217,253,48,135,23,18,188,208,41,124,117,107,159,212,161,8,249,80,81,193,31,235,17,33,189,209,236,
46,20,233,36,184,78,95,92,74,176,6,38,103,79,17,39,111,251,77,146,130,162,249,146,68,114,114,126,105,120,137,228,0,217,42,117,153,49,198,201,84,18,192,78,240,73,127,152,170,74,40,11,151,32,165,68,14,145,
157,209,141,48,168,10,229,75,130,24,34,226,151,213,21,16,41,178,51,61,146,65,38,245,217,204,78,106,49,50,92,216,102,44,141,155,12,49,188,9,174,58,32,212,34,188,66,38,75,83,89,236,16,65,43,10,234,208,84,
25,37,139,93,154,68,72,219,175,139,174,49,115,24,18,2,36,61,217,89,31,162,202,201,42,169,21,62,38,157,132,42,112,197,227,138,55,255,112,80,230,98,155,120,192,89,19,150,243,154,202,194,193,216,68,252,247,
13,104,132,168,106,194,38,85,76,194,39,126,108,219,17,153,115,77,175,180,32,136,83,203,145,90,185,244,10,187,0,184,162,106,183,245,44,143,218,88,99,220,182,27,166,8,149,80,55,184,21,97,136,164,77,219,
149,224,174,207,88,41,210,110,130,210,17,100,148,12,18,171,170,43,174,39,130,88,137,79,216,138,170,66,98,190,50,8,189,216,112,138,193,197,143,194,132,2,55,203,169,43,128,138,89,113,150,146,92,184,127,
157,33,248,155,77,69,91,6,52,127,128,82,242,90,12,197,56,234,245,207,113,175,69,196,32,99,69,147,107,100,4,192,133,131,38,247,67,84,148,177,179,159,182,32,92,40,240,195,47,161,158,82,112,241,28,43,69,
39,100,0,175,144,204,144,136,194,80,14,44,84,165,56,153,132,158,177,178,18,246,215,120,57,55,240,6,29,168,145,206,2,27,19,58,159,254,109,36,210,16,125,204,69,241,128,73,98,58,57,68,26,33,50,241,196,89,
6,146,221,88,35,154,21,166,8,121,210,30,197,208,220,132,96,190,20,67,44,29,152,53,82,81,169,72,127,37,80,55,36,131,65,232,24,36,204,249,138,223,97,117,52,218,240,206,48,129,124,61,228,139,113,198,4,24,
47,219,5,133,177,113,199,164,114,94,105,152,233,98,12,0,155,120,73,40,99,77,112,12,32,193,198,219,83,50,71,111,109,41,72,50,23,130,252,117,150,190,56,149,5,72,30,178,141,81,159,60,12,169,61,214,52,243,
168,193,204,99,206,48,119,132,240,196,208,235,9,10,93,106,147,193,209,87,191,13,37,137,26,29,179,34,161,195,138,138,195,147,96,147,161,173,179,177,64,163,186,116,14,18,239,43,71,150,124,158,4,210,169,
173,126,211,181,118,2,175,148,134,200,216,89,64,129,10,175,14,129,169,60,60,95,112,249,133,43,1,117,72,48,144,86,34,225,89,50,100,128,144,84,54,206,216,61,77,97,97,34,201,154,99,119,195,96,244,150,83,
150,21,217,0,81,44,224,213,150,234,214,13,19,184,153,171,29,133,21,194,224,236,166,6,14,87,179,171,57,241,254,17,95,210,22,66,220,151,95,140,243,234,223,138,92,13,123,185,120,165,250,204,170,112,47,196,
167,11,135,56,150,12,2,176,211,69,215,231,191,98,8,144,69,4,156,26,230,223,212,56,218,226,183,66,202,33,182,185,69,33,88,10,8,71,153,129,13,137,39,167,138,162,195,16,102,130,153,182,54,120,142,216,229,
79,86,22,79,72,194,108,100,56,78,22,223,47,67,220,168,10,170,14,37,82,33,196,67,21,179,3,112,114,70,117,157,81,48,185,188,60,95,240,213,120,149,139,15,77,61,66,9,3,99,134,146,202,25,165,12,25,91,0,92,
82,125,230,186,18,24,175,200,201,207,41,24,22,53,144,40,224,140,130,51,6,204,162,164,30,5,144,67,160,247,62,151,170,198,194,236,141,128,48,68,122,18,225,209,161,114,98,84,13,204,153,142,18,48,54,13,195,
159,209,234,229,84,49,171,67,201,226,135,87,35,18,47,109,14,52,157,188,10,25,134,181,34,145,50,151,180,129,145,48,14,39,12,126,154,163,12,131,145,0,36,134,36,3,219,209,219,73,127,221,55,210,202,2,137,
156,66,90,47,6,86,38,12,147,36,38,105,200,16,90,21,197,207,156,171,84,147,188,42,129,255,52,19,61,55,63,175,154,20,201,10,217,16,240,168,105,234,201,98,80,219,162,63,131,200,7,18,57,77,30,103,0,142,233,
243,162,36,200,101,151,190,208,70,117,81,134,16,29,247,200,66,8,21,163,141,249,41,202,123,150,218,64,202,21,102,55,43,174,63,57,194,137,128,42,115,181,253,204,128,90,67,104,129,44,77,117,164,56,148,25,
89,90,94,153,138,173,144,156,241,208,147,147,144,65,36,74,54,134,20,185,58,172,73,66,253,212,55,218,0,106,92,97,201,86,200,145,40,185,4,9,91,241,112,120,116,137,135,34,5,91,120,161,193,132,18,5,91,249,
89,6,27,10,31,134,104,15,11,139,204,120,255,44,239,45,38,36,10,115,73,85,210,86,98,162,83,204,26,68,128,122,252,37,243,38,82,8,130,202,204,124,145,83,69,33,133,82,91,36,85,58,253,151,124,153,90,177,201,
33,178,101,9,17,176,253,184,64,82,129,68,87,23,153,68,25,101,218,154,71,129,136,150,203,143,103,137,222,248,19,33,149,74,197,115,127,101,47,56,111,164,41,250,4,96,124,97,176,62,216,66,34,39,18,224,162,
185,102,94,129,169,205,16,25,122,106,52,146,91,119,205,233,144,34,92,234,23,116,234,76,16,35,13,102,115,198,8,65,168,63,65,101,47,29,209,255,72,18,237,142,165,128,63,178,24,162,23,203,192,19,91,36,176,
78,29,38,13,61,53,58,207,10,187,23,196,121,202,171,140,145,217,175,99,173,150,198,212,134,26,10,164,159,162,241,170,182,78,93,90,162,153,169,189,137,37,177,193,60,161,71,233,212,0,8,118,85,235,33,38,181,
12,9,22,178,155,79,249,18,236,85,71,84,146,196,74,88,249,188,188,214,38,16,196,26,185,20,166,218,82,43,106,127,10,21,180,152,81,215,47,111,168,140,210,79,76,128,48,193,34,82,78,143,172,77,64,10,51,49,
164,144,173,15,169,94,235,149,22,83,130,111,157,90,245,199,250,24,74,40,216,156,93,205,220,90,186,23,16,178,169,164,18,32,219,206,44,18,192,78,211,80,204,132,81,225,234,144,121,204,88,140,50,158,13,14,
41,12,110,123,211,138,242,162,202,3,153,209,38,23,217,195,240,132,199,108,163,196,199,210,73,12,108,169,16,135,28,5,191,253,218,204,221,208,68,222,217,46,169,20,176,155,67,150,103,146,160,39,105,128,25,
69,206,88,31,138,81,85,178,91,6,42,132,121,160,33,95,134,73,82,228,180,238,240,40,5,126,198,162,48,228,189,227,47,87,9,127,178,18,32,38,55,211,200,40,78,25,26,97,172,244,40,137,114,40,164,234,149,135,
148,155,185,76,103,88,169,13,115,189,163,81,19,99,150,32,155,144,27,165,86,155,227,53,94,225,48,84,174,69,147,153,82,155,67,142,210,88,70,105,60,7,178,17,226,41,111,186,112,110,123,24,206,204,204,160,
48,234,144,241,41,67,182,212,157,189,41,124,119,99,49,133,240,115,81,126,134,98,235,140,69,249,200,54,71,168,186,235,98,155,85,201,222,250,234,188,21,235,43,225,5,64,17,156,133,141,138,41,78,238,167,18,
71,238,114,42,108,53,60,30,191,223,31,111,72,240,193,244,182,84,137,203,255,44,33,162,66,65,156,69,114,178,51,52,50,97,97,96,55,30,251,22,152,25,253,121,133,219,22,41,39,178,12,9,97,220,159,112,168,200,
230,24,170,85,21,228,101,69,161,161,86,91,8,144,30,59,123,137,168,135,156,24,25,72,118,33,47,174,141,107,12,3,171,112,126,101,198,177,203,82,159,72,113,230,90,91,73,196,137,164,95,218,49,1,153,126,217,
210,4,109,98,40,43,145,235,64,2,108,95,165,150,1,220,4,14,239,82,143,172,154,56,187,36,100,97,210,8,179,200,81,182,85,106,117,200,48,101,100,146,203,40,102,102,67,142,74,27,228,141,24,194,123,91,106,77,
193,243,29,95,232,124,86,224,52,203,76,86,240,51,51,39,75,164,96,140,101,240,170,106,145,221,231,73,207,65,140,150,243,58,178,250,134,171,14,241,203,76,111,28,74,134,65,34,90,20,100,47,84,212,33,78,83,
245,219,151,161,6,205,67,37,70,97,236,68,101,150,196,249,95,147,176,30,81,81,61,154,103,217,26,194,88,206,165,134,68,106,179,153,18,78,128,68,198,144,193,3,135,26,92,246,116,159,73,131,71,37,101,209,140,
135,228,192,48,191,187,85,242,227,26,142,18,25,27,34,213,48,180,57,37,114,164,145,31,253,108,196,72,66,105,27,129,201,22,201,216,202,150,120,95,191,65,110,196,23,46,123,75,229,249,102,162,112,233,96,246,
136,147,49,145,20,98,27,13,254,38,12,33,205,225,17,222,142,3,153,143,25,172,234,138,251,92,6,112,72,166,96,110,160,12,140,197,170,44,66,76,189,89,19,15,144,10,172,248,213,97,76,134,132,41,194,134,43,119,
25,9,187,92,118,148,69,241,40,32,29,38,244,68,195,229,42,87,164,254,162,215,131,145,119,27,100,34,105,171,240,230,195,82,88,253,98,137,128,64,79,88,47,103,100,163,57,81,4,17,146,3,200,180,108,68,162,75,
183,236,109,32,158,3,197,130,100,95,97,36,82,64,155,26,13,73,20,128,168,171,229,23,136,9,195,43,188,188,245,33,151,248,153,110,145,190,188,243,119,39,41,15,217,229,161,200,80,153,82,158,189,165,134,241,
158,135,103,34,168,60,76,6,15,23,6,18,143,199,68,119,227,100,97,49,146,12,193,61,81,216,49,137,156,27,42,162,29,149,223,129,234,132,23,85,135,252,129,199,219,199,145,61,0,24,205,245,68,250,26,42,116,169,
193,131,9,26,164,136,101,193,72,236,172,137,105,163,44,177,92,34,109,87,38,175,106,102,9,51,134,158,2,108,246,135,88,196,76,49,109,204,176,201,25,29,203,34,82,200,18,18,108,137,33,93,139,35,15,67,42,15,
169,114,176,170,104,239,130,186,88,126,209,112,174,46,195,136,173,40,225,47,114,113,114,181,204,0,99,25,108,168,180,130,170,30,177,183,212,122,220,178,120,38,26,174,104,92,227,32,136,114,211,207,152,62,
43,85,210,199,139,198,37,98,97,20,134,179,177,52,234,132,133,197,81,204,29,123,112,17,34,57,132,12,151,23,71,102,115,225,175,115,171,216,200,161,173,48,2,54,220,214,135,16,192,153,37,47,172,183,100,107,
91,2,102,65,133,32,187,242,64,121,76,18,134,36,56,253,76,95,34,141,110,116,231,82,10,85,46,117,216,152,74,176,121,47,90,141,129,0,168,92,130,170,136,86,163,68,168,206,5,114,210,79,198,179,33,71,13,91,
45,12,185,236,253,91,129,138,144,241,2,73,180,164,10,48,85,130,18,86,105,96,30,169,41,224,148,131,210,86,89,98,197,170,5,70,194,98,96,201,15,219,132,89,91,42,42,73,234,102,162,196,180,113,110,2,115,136,
183,163,37,179,48,67,204,224,236,68,30,78,18,174,137,195,178,57,138,105,107,109,5,218,253,51,163,176,197,246,100,190,148,201,64,105,51,115,109,72,90,246,70,202,15,21,114,68,142,97,42,169,157,172,36,200,
30,230,69,84,29,104,229,14,123,78,40,252,185,145,124,205,55,73,76,167,149,164,19,159,41,76,103,228,86,32,67,208,13,248,42,188,132,73,45,86,136,28,39,91,41,209,26,194,128,12,79,77,18,106,115,170,106,76,
6,97,26,162,22,134,100,150,54,147,48,62,28,101,15,27,28,21,26,204,35,135,98,129,102,159,107,112,216,40,34,117,237,226,20,28,162,8,25,160,12,198,179,127,104,189,137,56,118,84,18,226,56,0,6,39,75,195,100,
8,219,178,77,29,132,51,15,12,21,174,14,37,18,54,107,86,254,96,200,187,130,96,78,245,82,22,146,164,61,178,106,70,50,57,123,200,136,249,107,152,92,31,110,214,234,81,103,69,74,174,10,12,179,176,135,3,217,
0,37,143,22,244,78,64,236,73,162,247,231,240,78,79,253,187,181,230,58,148,44,79,140,30,44,142,27,1,192,200,73,145,120,85,181,132,81,170,10,236,154,64,206,250,167,95,157,100,174,49,77,150,212,16,98,153,
51,170,45,140,233,200,99,202,128,147,5,152,172,60,106,134,203,16,70,74,39,219,233,81,134,145,145,6,135,141,170,163,104,30,253,89,195,168,73,24,86,20,122,234,127,47,149,41,216,80,162,249,80,3,98,107,139,
3,96,56,197,58,86,98,186,176,195,194,152,140,50,230,230,205,169,133,169,149,225,106,84,110,28,230,102,47,35,185,150,88,148,92,31,49,76,58,41,82,112,22,86,203,84,108,240,144,50,164,0,30,146,81,10,64,215,
248,124,221,10,36,178,75,188,36,97,97,38,128,145,221,27,49,126,229,47,14,121,85,148,83,236,20,122,175,190,172,71,133,179,191,149,145,69,210,230,223,18,114,154,181,10,59,145,171,55,246,41,14,201,102,51,
148,121,18,67,90,135,121,236,100,120,131,241,179,204,131,137,3,169,22,110,165,138,214,170,114,114,116,58,150,97,210,240,254,198,95,14,68,109,85,167,255,54,153,25,85,200,165,168,246,237,48,9,67,103,172,
35,33,50,237,81,123,65,26,172,70,123,163,33,118,158,136,100,197,181,97,94,39,229,130,144,242,164,45,136,43,83,70,133,163,240,164,195,67,64,120,141,95,51,200,229,84,22,69,67,208,16,147,81,199,154,226,6,
192,201,171,130,82,103,9,144,117,145,164,188,41,203,151,207,170,84,136,41,207,116,170,64,62,140,49,51,64,26,177,105,146,24,216,173,4,80,172,41,163,3,158,116,72,55,163,133,206,96,162,173,103,169,84,80,
228,39,213,41,117,72,155,131,168,209,52,84,218,197,75,122,133,12,68,20,81,189,94,112,172,164,193,240,197,196,94,150,137,36,182,122,234,14,248,108,117,81,49,127,32,14,237,5,91,44,17,195,51,49,181,48,142,
204,48,40,170,81,67,6,83,51,68,157,54,44,184,50,84,223,26,249,120,21,117,28,200,41,4,67,236,249,6,99,209,43,86,78,78,85,23,156,30,64,144,23,120,150,77,193,112,240,195,123,231,193,111,143,193,63,148,248,
80,12,113,16,70,145,8,250,218,212,24,165,22,192,64,112,21,28,34,105,32,192,75,193,4,209,73,81,160,248,87,187,42,254,216,175,128,63,6,36,127,78,246,52,3,143,134,19,93,253,227,126,97,61,28,163,12,66,178,
166,88,160,244,75,187,216,212,131,250,193,230,97,84,202,166,67,22,99,2,211,204,170,35,33,56,65,110,128,205,55,64,177,2,35,254,80,48,113,26,139,201,53,141,244,176,170,80,67,200,169,61,188,238,29,167,6,
148,199,157,48,155,68,165,147,5,227,72,50,75,59,140,86,125,11,1,202,195,108,29,7,50,161,201,128,141,142,31,95,48,18,70,157,215,218,10,37,146,108,69,206,225,140,12,61,60,84,25,60,137,229,113,227,166,15,
84,51,167,206,81,29,43,181,68,37,39,84,196,229,62,12,41,196,248,37,24,219,130,127,214,136,44,218,108,91,90,91,188,206,39,142,195,83,181,195,27,255,106,10,205,115,82,117,10,233,5,44,156,30,140,27,253,37,
209,34,80,84,161,77,132,71,38,184,64,134,67,178,161,210,6,146,192,210,89,217,97,81,164,194,87,72,96,206,200,6,176,146,147,66,99,63,203,40,123,105,114,72,140,77,102,100,112,96,84,228,49,18,137,151,132,
13,248,88,139,74,186,212,130,145,249,124,91,102,108,161,164,77,183,253,132,245,81,157,90,212,85,61,193,240,39,189,142,9,243,138,216,10,86,198,50,57,21,37,75,147,108,176,25,169,252,230,121,68,152,88,136,
98,40,14,67,121,6,200,253,187,174,52,228,106,71,22,41,187,69,82,151,66,149,16,50,212,30,169,211,9,0,13,11,96,195,113,23,191,235,112,207,43,62,210,35,253,176,5,179,26,73,28,170,42,128,236,240,198,159,114,
152,162,195,28,18,38,109,41,52,140,194,104,12,44,3,19,74,66,152,231,9,230,137,211,169,25,130,95,202,99,88,193,70,36,254,100,24,0,78,236,35,217,45,13,47,92,14,192,150,154,213,80,121,232,93,173,88,128,6,
159,144,167,154,128,64,120,180,54,169,71,124,230,44,145,197,99,144,225,50,70,200,96,183,23,200,222,184,161,244,171,112,53,106,210,80,136,156,122,130,41,42,51,214,241,71,95,26,137,196,160,10,123,146,221,
13,74,234,82,107,93,97,174,176,52,25,195,23,220,242,194,92,146,72,187,14,204,211,15,188,29,78,68,138,68,118,64,12,21,171,93,14,213,34,162,86,162,228,148,30,159,79,117,88,5,38,183,84,82,239,139,86,241,
126,174,226,156,247,206,106,63,86,131,197,113,3,173,64,70,77,75,109,20,140,13,66,220,86,168,236,234,16,36,210,227,55,180,56,103,228,168,202,40,179,20,200,240,241,80,118,139,16,174,216,84,174,238,15,101,
33,210,142,49,43,61,97,8,247,42,28,82,229,208,9,76,103,175,9,150,26,152,86,58,85,148,58,148,72,216,233,81,9,206,71,34,202,20,38,217,216,38,100,72,174,90,10,124,136,97,18,54,194,188,57,81,105,76,248,166,
34,167,99,35,204,139,30,240,40,25,233,44,246,85,66,234,229,217,227,111,32,87,82,204,102,138,61,58,115,131,78,39,117,91,170,228,101,29,233,179,93,134,56,164,90,16,58,183,12,225,44,48,92,184,244,145,109,
205,153,189,200,40,117,157,49,150,203,165,171,145,97,214,164,167,85,96,1,150,74,252,74,81,93,107,182,164,182,22,131,82,21,133,249,218,114,168,88,60,77,147,57,89,21,119,83,165,124,41,196,156,149,0,169,
211,41,4,38,204,21,122,136,65,19,230,20,38,49,82,128,244,59,49,210,167,236,198,212,161,102,35,36,20,224,82,135,225,44,128,134,12,54,70,144,17,146,43,0,31,186,164,236,128,209,204,47,209,150,173,118,12,
5,49,248,165,96,95,146,234,134,17,235,179,59,124,87,123,52,81,58,170,226,168,252,168,127,242,131,80,49,101,178,23,140,97,35,204,132,33,25,66,0,250,169,162,50,135,36,12,182,34,137,229,170,144,60,49,254,
172,40,78,251,144,99,229,112,156,71,41,145,58,171,139,86,21,107,242,35,151,131,201,249,147,18,96,75,242,106,40,206,166,120,56,86,249,57,5,3,216,195,41,26,31,149,130,147,105,153,135,141,144,176,242,248,
43,83,226,165,237,189,104,105,174,200,177,107,102,100,184,118,171,233,227,1,83,128,250,196,8,151,204,81,161,225,241,132,195,152,118,113,59,69,227,28,194,134,21,151,229,3,185,36,73,8,54,215,42,227,37,73,
86,98,7,66,32,147,144,207,163,10,87,111,57,113,20,194,72,197,64,60,112,50,192,101,179,111,35,66,24,227,155,141,82,161,188,53,47,62,234,15,198,14,72,115,66,60,12,61,19,136,44,101,179,41,84,143,71,18,148,
24,11,108,136,114,203,212,128,133,179,72,73,157,242,112,137,99,220,224,113,82,49,36,69,74,155,239,146,100,184,228,111,117,59,44,73,92,114,227,132,228,33,19,159,174,133,99,165,193,130,99,132,237,56,209,
127,215,234,244,115,36,209,73,239,66,67,106,131,141,205,156,61,244,55,202,124,40,141,152,120,219,175,22,73,153,2,122,20,88,29,86,233,84,172,20,1,91,168,165,17,77,98,134,7,81,138,53,118,8,114,209,198,212,
50,166,89,102,49,50,170,80,93,174,84,30,141,165,51,253,137,40,94,90,42,80,133,168,67,5,150,135,249,72,25,85,216,170,237,174,225,161,194,226,198,95,117,39,51,107,171,168,18,92,172,108,155,92,61,129,45,
42,40,191,156,110,119,92,72,85,12,234,144,145,105,35,21,21,36,77,83,209,104,40,76,70,201,116,105,36,162,36,56,241,60,75,194,100,46,101,167,97,229,188,212,17,10,172,70,107,156,47,210,139,146,43,175,179,
78,186,87,187,50,93,189,27,226,208,75,20,28,86,242,164,128,210,85,244,176,35,37,21,33,126,5,156,38,161,146,87,164,229,183,120,106,174,194,237,29,249,7,33,137,63,158,122,141,84,72,62,76,115,22,163,97,129,
20,44,250,166,72,212,33,231,234,149,17,105,157,191,6,148,108,161,182,87,50,152,71,109,157,92,62,27,140,108,248,16,149,44,76,5,171,67,102,52,141,52,88,201,77,48,164,121,204,192,182,78,89,178,140,229,212,
133,209,197,92,50,143,36,111,97,243,203,79,98,1,41,121,146,221,143,74,139,49,42,149,84,166,45,249,19,50,84,172,136,74,75,82,179,19,130,205,181,84,193,114,244,8,37,208,232,210,165,54,65,89,138,210,131,
67,199,32,81,149,173,192,30,130,165,250,122,128,73,69,57,10,149,148,15,189,88,78,129,40,255,237,160,26,38,49,142,220,124,57,225,193,148,209,134,173,214,16,103,84,115,157,8,225,14,132,100,137,168,2,236,
52,231,127,186,192,189,61,21,166,42,61,198,59,212,140,12,38,155,71,218,26,209,170,92,61,54,33,4,164,1,8,107,47,82,137,49,39,35,127,46,61,229,9,181,78,167,153,14,36,172,138,83,179,199,75,81,30,48,38,28,
210,81,9,73,20,92,10,35,85,242,146,139,223,77,10,83,8,79,135,59,145,96,208,102,161,63,161,217,255,119,26,185,153,206,104,214,227,245,39,231,213,75,11,44,142,93,58,111,204,99,246,70,140,3,158,193,198,122,
141,96,177,90,170,81,179,99,254,146,147,143,74,133,254,186,99,181,126,147,205,212,161,156,98,45,241,72,77,11,151,100,118,242,24,25,26,198,238,20,137,242,178,132,68,113,15,79,4,32,153,36,198,150,74,13,
165,248,144,145,219,157,153,128,241,161,236,4,131,139,170,103,212,12,15,229,133,48,233,113,180,149,207,22,32,231,21,125,180,62,251,102,7,202,76,176,37,15,45,38,239,150,214,67,51,33,27,245,176,228,33,61,
245,88,96,149,137,12,146,0,72,14,217,192,8,164,112,19,97,226,41,68,52,214,23,95,195,34,75,191,6,88,150,155,190,232,170,80,133,211,33,69,169,161,144,222,145,139,17,22,25,171,66,96,11,211,225,27,115,169,
184,240,80,50,36,230,72,194,66,18,246,36,24,128,33,18,194,144,109,210,138,254,68,251,207,25,201,48,121,244,62,232,154,134,144,180,78,150,202,89,66,124,145,81,78,150,32,231,40,109,72,60,198,16,34,60,242,
125,39,158,95,205,224,31,187,45,85,177,56,41,178,41,153,75,179,224,103,54,255,170,193,79,157,58,146,121,19,184,102,24,43,41,89,212,27,178,38,115,195,60,185,206,152,177,210,41,121,72,103,173,86,170,138,
16,166,87,48,168,4,160,78,91,167,168,125,41,171,17,143,44,141,24,51,129,147,103,159,126,153,156,142,164,206,144,25,88,175,64,126,17,242,251,204,204,76,200,6,39,99,140,124,131,139,71,97,228,93,170,203,
136,194,246,18,201,149,160,128,78,176,135,87,152,188,67,147,129,171,99,3,100,100,155,120,211,105,231,231,162,92,9,30,76,57,25,204,51,85,232,176,151,141,199,163,58,233,198,194,243,206,141,216,191,37,30,
8,148,41,61,94,213,66,106,197,197,58,197,80,181,165,50,75,69,33,16,44,196,219,176,225,101,186,18,33,39,6,99,20,229,9,98,162,110,12,37,76,104,32,1,242,230,20,121,208,159,110,178,81,108,201,172,121,18,165,
249,173,40,56,216,67,81,220,109,169,77,17,170,67,137,36,194,52,64,225,99,135,44,204,4,32,133,151,69,53,191,208,161,219,194,60,250,98,132,7,146,81,18,5,219,203,174,199,226,127,89,88,166,80,165,41,42,117,
168,184,233,144,49,205,151,231,170,51,65,91,164,24,182,193,111,174,4,149,221,212,214,165,147,53,72,30,174,87,58,163,182,42,25,56,87,53,21,21,178,153,73,17,166,144,128,177,39,18,82,136,98,140,82,24,243,
75,152,76,161,241,252,180,135,2,92,81,56,10,39,171,142,21,176,234,159,160,174,182,203,250,41,117,252,84,137,188,52,215,236,82,123,175,109,84,229,37,18,243,74,87,160,213,234,23,254,66,130,40,216,86,164,
240,18,20,196,210,52,39,38,91,70,75,155,149,179,33,71,217,78,48,115,32,27,4,230,195,138,36,86,142,171,37,145,130,101,192,8,96,122,85,232,188,34,56,92,127,98,48,203,4,121,32,64,6,106,49,114,12,118,66,91,
129,12,91,228,154,67,60,201,212,4,169,126,22,58,227,143,116,60,104,160,74,138,84,25,213,161,68,42,206,14,14,219,177,113,175,68,139,168,100,143,199,193,232,89,153,210,15,145,30,88,136,86,72,9,147,182,136,
232,214,76,208,170,29,70,106,75,69,137,75,185,250,159,160,166,154,19,97,84,7,231,72,32,115,48,153,93,97,42,198,251,158,250,188,242,46,139,196,220,115,160,50,98,60,10,166,203,84,47,98,10,157,145,87,69,
132,135,69,70,183,58,189,81,139,220,6,91,200,130,202,209,214,55,28,22,146,58,163,11,247,164,52,31,84,225,46,99,29,96,101,172,71,125,171,27,13,254,252,122,188,160,13,55,65,149,75,29,122,241,193,65,11,176,
106,136,232,70,11,146,64,64,7,142,88,127,66,25,220,43,57,68,182,79,34,78,70,117,127,147,212,39,105,147,192,236,193,120,147,27,41,32,70,22,197,218,224,148,126,226,225,81,54,224,111,248,16,85,66,1,18,72,
34,137,84,254,80,10,131,21,146,253,108,52,2,24,201,19,207,30,54,66,146,80,82,136,225,112,105,52,100,81,115,201,145,226,204,97,95,194,48,179,196,20,154,224,8,121,48,101,82,176,19,25,75,84,236,200,14,19,
225,215,238,80,91,148,92,135,214,47,0,222,72,182,0,149,72,205,184,26,245,82,148,7,109,241,33,67,237,9,154,204,228,141,50,106,146,46,44,78,39,57,242,83,123,23,43,76,81,78,132,38,145,149,18,50,115,190,194,
64,63,17,31,105,131,3,69,34,181,234,10,145,12,83,241,34,138,71,128,15,59,166,43,101,116,96,184,183,167,104,32,150,88,132,213,23,56,236,180,100,241,32,140,124,53,50,170,173,109,100,49,203,41,213,26,224,
188,124,118,32,37,2,115,253,228,196,163,179,163,60,136,119,208,10,223,10,28,172,21,239,202,194,19,17,28,96,165,218,103,23,33,173,101,16,213,22,159,26,78,171,78,12,242,167,4,112,36,140,64,76,84,137,140,
18,118,91,188,8,213,38,21,34,9,237,42,2,205,154,168,211,99,153,186,3,14,115,34,20,15,165,8,145,94,106,53,233,162,94,25,72,247,208,197,54,72,207,24,85,148,76,44,254,94,89,38,170,109,142,21,185,36,65,204,
54,24,76,168,160,229,51,203,219,82,101,97,38,131,233,172,211,155,195,150,147,211,135,131,54,27,183,134,3,68,49,236,83,134,89,14,248,85,118,157,177,49,87,4,64,180,154,77,105,74,30,74,97,105,30,137,100,
202,116,8,193,114,48,76,168,12,196,198,90,90,32,195,182,112,188,63,89,165,248,122,43,103,148,210,166,14,9,166,4,240,233,39,73,192,111,198,50,166,217,224,90,124,229,58,16,48,11,160,102,135,196,176,179,
56,180,162,58,184,9,168,245,176,96,184,76,242,26,218,218,202,108,38,23,136,4,102,136,154,59,96,100,8,203,162,141,20,135,110,20,191,245,106,161,63,44,6,131,153,136,169,84,70,246,179,17,11,119,169,11,21,
12,14,13,25,206,182,183,165,146,151,233,24,20,114,245,220,147,206,149,110,77,44,214,244,115,117,177,18,194,92,138,39,4,16,149,130,197,248,19,126,155,65,158,45,46,152,223,78,116,142,118,191,27,155,192,
116,74,146,58,36,152,99,43,22,95,184,199,193,201,81,14,89,209,179,191,58,206,248,165,66,138,119,35,131,125,205,190,6,100,242,224,252,228,17,54,194,41,86,121,11,228,156,226,5,198,240,139,122,153,176,128,
187,173,66,53,65,96,90,190,18,208,194,40,203,145,130,57,145,96,46,204,120,222,98,52,22,85,140,225,75,45,66,171,135,54,131,8,164,183,173,136,15,63,19,122,20,85,255,32,255,206,221,202,206,180,181,17,123,
219,35,35,92,10,80,58,229,80,157,75,88,222,150,74,126,138,1,17,190,27,227,107,42,238,93,75,197,53,67,220,98,25,84,30,31,198,35,220,8,171,98,199,108,103,69,126,55,146,55,2,34,196,81,183,154,51,194,113,
22,121,182,40,10,198,40,127,227,97,52,80,181,43,99,42,145,75,178,165,63,111,36,145,105,145,97,79,98,177,97,127,194,139,26,228,114,27,154,167,54,166,33,150,75,226,41,175,210,153,19,216,128,201,158,2,18,
64,108,13,156,165,238,28,140,44,80,218,170,201,154,74,105,246,34,253,171,60,66,150,235,74,147,200,168,192,150,2,234,192,68,94,48,148,89,212,4,193,93,135,7,89,12,71,184,47,203,147,194,18,80,125,136,202,
187,89,40,113,198,51,83,74,40,25,165,4,246,203,52,236,148,200,76,91,242,32,164,164,50,219,17,118,141,50,0,44,103,130,157,48,38,78,92,182,175,175,239,225,135,255,65,78,250,105,242,24,25,149,48,73,81,17,
249,203,40,4,248,30,35,133,0,164,71,5,48,195,84,202,131,217,81,237,42,26,40,62,29,194,9,164,164,16,32,71,57,68,25,141,81,205,36,174,150,240,130,29,219,186,228,111,166,82,226,242,14,187,162,117,226,189,
243,174,204,27,78,129,150,67,177,157,254,17,141,205,166,189,213,233,86,184,203,116,246,110,224,214,143,210,28,146,9,79,214,169,17,246,22,30,158,83,54,160,82,48,215,166,12,47,110,89,156,206,26,193,22,79,
4,123,124,112,88,154,36,15,71,65,227,125,136,202,209,218,66,105,84,50,58,124,241,219,172,51,6,150,129,49,219,148,11,48,56,63,119,208,1,31,251,216,71,97,191,252,242,203,83,167,222,119,226,137,223,250,251,
195,15,155,60,49,1,159,254,244,126,67,135,14,61,248,224,47,202,40,27,220,212,116,48,136,218,37,159,103,123,228,25,156,94,112,228,128,242,122,204,17,36,185,85,75,195,64,233,1,121,88,151,4,16,103,232,73,
72,80,132,173,98,21,173,170,5,163,146,173,178,209,103,255,12,41,72,178,155,175,212,74,1,50,151,244,103,218,44,62,228,209,30,165,214,189,33,163,97,42,49,69,133,181,43,24,150,110,228,19,181,204,31,3,128,
137,49,108,152,29,227,209,32,185,118,112,56,27,132,32,134,14,120,202,240,212,173,118,88,157,202,162,14,149,98,115,180,243,15,81,217,236,106,5,0,148,49,175,138,138,14,77,185,140,124,234,169,167,247,255,
204,129,43,172,176,252,167,246,251,4,246,199,67,62,127,40,15,213,70,40,198,141,125,249,176,35,176,56,141,179,203,1,234,223,78,191,154,230,26,224,91,105,217,132,109,156,200,168,48,39,134,120,18,185,18,
106,141,40,171,81,205,127,188,27,70,249,242,32,50,38,195,208,224,183,177,241,40,197,192,194,212,20,151,242,154,155,239,114,27,41,152,217,97,234,223,121,181,19,103,197,28,99,19,84,161,218,58,163,180,152,
42,82,163,135,229,135,32,98,91,148,0,105,27,77,144,195,190,13,48,207,184,14,100,133,126,136,220,31,154,67,184,51,73,54,226,97,37,108,80,102,153,69,218,74,87,206,161,98,166,16,227,89,42,6,24,154,159,210,
133,232,43,92,201,224,48,90,173,196,200,236,176,189,33,209,199,153,51,103,62,240,192,131,248,30,57,114,228,23,191,112,240,66,11,45,244,230,155,111,30,115,244,145,27,109,180,225,236,217,253,87,95,125,237,
119,190,123,210,235,211,95,223,106,203,45,62,176,231,251,166,92,115,237,222,123,127,228,181,87,95,251,237,217,191,255,253,31,206,1,237,97,95,62,116,200,144,190,163,143,249,26,236,61,118,223,109,159,143,
239,61,122,137,209,247,221,119,255,33,135,124,241,197,151,94,82,55,187,180,2,61,37,8,75,126,153,149,50,67,97,136,90,42,38,94,46,254,181,3,196,20,240,114,177,50,67,50,121,49,88,35,101,34,145,162,98,40,
71,205,243,182,102,32,168,228,33,15,157,189,162,89,20,194,181,227,80,147,84,89,203,95,32,12,245,56,0,145,164,194,29,50,252,237,151,83,47,72,176,177,182,48,170,246,200,74,125,133,62,115,29,1,43,148,26,
122,188,0,127,150,229,144,12,148,118,133,97,121,66,27,11,35,124,21,69,72,1,147,89,106,155,9,107,23,196,213,125,35,119,216,58,67,155,213,135,42,188,233,114,216,60,35,84,82,206,200,245,74,201,176,25,224,
217,102,129,64,4,53,42,182,198,67,74,39,69,194,99,111,169,82,89,35,47,1,114,66,114,48,96,139,193,234,62,138,94,172,54,121,213,217,179,103,79,159,62,189,191,191,127,234,212,105,191,251,253,57,195,134,205,
247,157,111,127,227,238,187,239,254,243,185,231,47,176,192,2,155,110,186,201,194,35,71,126,235,91,223,221,98,243,205,14,253,226,33,23,94,120,209,107,175,189,182,216,98,139,14,233,43,222,174,93,123,237,
53,143,61,230,171,23,93,116,201,37,39,93,182,204,50,203,188,240,194,139,16,144,120,143,69,182,79,118,70,105,230,67,137,151,54,230,147,247,34,190,104,224,40,54,88,12,208,133,51,182,56,128,19,61,145,194,
234,166,89,141,165,81,153,78,198,74,91,242,72,63,197,82,49,117,73,37,66,29,82,20,231,2,33,219,146,16,54,7,146,17,131,169,40,62,76,224,139,161,68,15,137,162,236,164,153,58,193,92,101,103,242,200,116,176,
72,24,13,98,34,12,60,17,8,231,70,49,173,239,209,219,162,169,159,9,153,196,212,22,62,179,150,248,70,91,167,230,70,113,164,95,47,247,95,86,196,182,199,38,169,124,18,226,142,174,52,4,134,120,201,134,248,
16,192,130,157,225,137,9,255,163,211,44,154,240,10,237,72,218,255,86,66,77,130,164,122,37,108,209,69,23,253,250,215,143,91,109,181,201,203,44,189,244,143,127,114,26,246,83,80,254,242,204,95,225,77,167,
165,38,76,192,213,235,59,222,177,41,182,84,202,115,202,41,63,188,225,134,27,239,190,231,158,119,190,115,247,13,55,92,255,234,41,215,112,254,93,119,221,229,149,87,94,57,236,203,71,96,95,102,167,50,144,
154,251,192,70,244,204,244,171,168,241,138,52,185,113,7,216,226,244,43,59,160,79,18,70,114,34,110,20,121,216,207,200,218,144,239,102,250,178,153,164,6,91,59,50,55,33,253,246,133,36,129,205,228,108,16,
128,165,22,70,184,96,124,133,138,51,255,208,220,65,194,112,22,19,14,37,60,76,110,135,103,20,197,61,177,25,252,89,48,62,46,230,119,137,217,72,51,14,107,90,39,166,158,59,23,11,88,25,88,71,243,171,62,120,
106,134,226,32,254,143,215,56,54,163,93,136,114,163,156,131,174,48,56,17,103,97,35,228,113,177,246,73,193,129,48,28,82,113,136,110,184,17,61,131,177,2,157,126,23,87,255,214,87,169,172,3,16,232,192,183,
244,212,113,148,41,206,91,35,75,139,133,42,191,60,172,18,169,26,92,10,79,6,62,18,56,120,208,172,153,179,206,252,229,175,174,158,114,237,211,79,63,13,158,37,70,143,254,202,87,14,91,123,157,181,158,126,
234,233,177,99,199,190,244,210,203,76,126,239,189,211,96,63,255,220,11,248,185,224,130,11,226,39,254,206,9,147,138,234,198,45,57,118,218,125,247,39,246,83,128,189,212,56,46,191,184,34,61,42,245,59,241,
46,40,248,13,112,128,225,233,87,204,213,33,243,151,129,75,44,177,196,82,75,77,120,242,201,167,158,120,226,9,98,7,108,233,165,151,66,121,143,252,251,223,240,44,181,212,82,207,61,247,28,174,226,131,220,
222,91,19,118,174,48,134,61,115,230,12,31,62,124,226,164,137,211,166,221,71,190,73,19,39,46,178,200,168,127,252,235,159,220,121,104,192,195,238,103,158,121,246,133,23,138,206,175,184,226,10,15,62,248,
16,12,149,139,41,165,193,237,101,103,78,84,5,230,22,113,176,48,138,29,36,187,231,209,45,35,96,160,12,105,145,97,81,66,87,101,166,25,20,222,36,148,12,137,61,55,140,229,64,54,102,187,59,41,246,228,8,80,
152,48,54,76,141,144,254,126,111,227,227,179,0,67,33,3,165,96,191,4,115,118,211,201,33,12,147,134,12,113,182,189,95,35,42,70,213,39,25,149,141,152,88,24,154,98,246,69,49,84,135,197,213,208,236,226,187,
36,140,253,44,150,47,109,49,88,175,252,29,57,61,158,127,254,133,175,28,113,20,110,243,105,63,69,162,189,62,242,225,85,86,93,121,215,221,222,181,231,7,63,252,176,255,1,128,25,51,102,176,48,104,41,4,148,
31,30,134,241,226,139,47,77,92,118,25,30,205,55,184,10,180,222,251,46,59,147,217,31,179,135,204,92,139,161,206,208,207,242,61,95,10,92,116,209,69,118,217,101,71,60,20,222,118,219,173,39,44,53,158,100,
44,186,216,34,235,172,179,214,228,213,86,29,51,102,9,236,122,235,173,183,142,44,191,224,116,108,213,164,148,83,195,206,194,200,248,154,176,244,132,119,190,107,143,77,54,217,136,146,174,58,121,149,141,
54,222,112,216,252,195,118,223,109,183,97,243,205,87,148,208,63,123,149,149,87,26,189,248,226,219,109,187,53,86,229,50,75,47,53,118,204,152,12,226,10,194,77,96,35,63,150,154,143,159,99,150,28,187,238,
250,235,142,95,106,194,144,161,125,244,77,67,104,203,170,171,174,34,9,145,101,177,69,22,93,99,245,213,151,91,110,210,252,243,207,95,12,185,110,215,75,209,117,158,154,15,8,213,62,100,200,144,149,86,90,
113,141,53,86,95,120,225,133,136,115,210,196,101,215,89,123,205,81,35,23,150,93,29,177,224,240,85,87,94,121,165,21,86,92,120,196,66,92,84,97,208,169,225,78,16,98,96,114,111,105,185,13,142,49,30,143,59,
185,120,180,32,17,171,145,108,30,165,216,209,139,143,94,123,173,181,150,28,187,36,14,121,8,6,181,136,249,105,104,241,197,22,91,115,205,53,234,22,149,219,10,99,98,6,98,85,139,128,156,184,204,178,107,175,
185,198,200,133,234,86,0,182,32,230,101,149,85,86,90,81,183,136,178,199,126,162,69,177,161,208,79,253,12,253,228,137,149,96,250,99,36,125,233,28,177,48,202,17,27,85,254,122,94,221,238,163,0,116,88,193,
28,166,90,76,120,170,237,182,128,218,176,226,113,101,250,236,179,207,225,9,192,38,155,108,188,246,218,107,225,50,84,127,209,102,81,177,149,131,115,230,252,237,111,55,142,25,51,230,163,31,249,223,113,227,
198,237,190,219,46,213,233,68,145,97,94,98,240,121,99,173,128,223,7,26,71,6,198,76,42,78,102,180,133,51,46,191,252,114,143,60,242,239,91,111,187,125,218,180,105,88,136,148,96,145,81,139,60,241,196,83,
143,63,246,248,226,139,47,190,193,250,235,221,122,203,173,115,240,76,131,104,75,4,79,135,220,101,170,243,173,76,100,8,13,92,195,23,24,126,197,21,87,21,47,76,229,153,188,194,242,203,223,118,219,237,55,
222,120,51,46,72,151,93,118,89,192,65,184,216,232,197,31,121,244,223,175,190,246,218,168,69,22,89,119,189,117,111,185,229,214,122,6,205,50,133,200,32,97,11,7,73,90,100,228,200,157,119,220,161,111,208,
224,109,182,218,114,236,152,177,184,8,194,55,134,198,45,185,228,59,247,216,109,147,141,55,146,140,216,44,118,222,101,39,120,198,143,27,183,240,66,35,10,157,212,115,127,53,18,51,126,82,44,29,174,179,206,
218,163,71,47,142,93,227,189,239,121,247,124,243,205,183,202,42,43,111,180,241,70,195,230,159,31,47,57,11,12,95,128,26,59,116,216,124,239,121,239,187,135,143,88,112,145,197,22,25,187,228,216,42,53,213,
235,174,30,128,148,146,84,46,26,194,236,75,76,163,205,82,25,89,157,86,101,93,139,45,190,232,174,187,238,52,116,232,144,237,182,219,122,252,248,113,140,129,93,182,104,67,57,95,139,47,182,232,206,59,239,
8,204,248,241,227,249,197,131,67,210,134,110,209,202,43,109,180,209,6,243,13,27,182,199,59,247,152,127,216,124,148,5,13,124,207,187,223,53,124,129,5,22,25,53,10,45,146,58,165,29,38,226,70,229,27,33,73,
194,35,179,147,157,0,99,40,250,33,42,4,115,100,56,49,197,16,22,68,227,23,150,75,249,82,70,64,230,100,67,18,216,89,202,147,83,194,10,187,164,85,206,179,207,254,253,113,199,30,117,195,117,83,238,157,58,
237,204,179,126,141,103,172,10,64,75,118,112,95,113,125,141,243,133,206,153,139,46,185,20,47,188,159,253,236,254,135,28,114,16,182,131,43,174,188,154,163,0,131,36,37,53,38,50,230,103,54,54,136,48,134,
151,231,21,99,16,194,54,243,192,192,165,4,238,178,49,132,107,237,113,75,142,35,12,94,87,80,209,204,153,51,31,122,232,239,35,70,140,88,126,133,229,177,157,253,245,186,235,240,206,27,1,152,138,222,133,147,
5,198,18,201,164,100,151,228,197,35,20,250,194,227,20,124,70,24,246,203,47,189,140,164,48,144,229,153,167,159,193,211,128,133,23,94,24,167,232,147,79,62,185,205,182,91,227,5,239,242,203,175,196,207,42,
204,252,37,215,149,53,209,20,36,101,147,135,235,162,67,20,142,71,31,183,222,126,59,182,253,149,87,89,249,137,167,158,130,31,24,72,197,44,227,229,147,96,244,115,241,209,139,99,246,239,185,247,94,220,195,
192,131,89,88,127,253,245,112,101,253,234,171,175,93,127,195,223,94,121,249,21,188,56,129,16,47,78,231,252,241,207,179,102,205,146,177,197,75,69,249,133,171,242,69,22,89,4,207,55,110,191,253,142,7,30,
124,16,47,213,120,117,129,129,193,5,230,95,160,175,111,200,221,119,221,131,207,165,16,24,143,68,86,91,125,50,244,220,122,219,109,143,63,254,4,30,224,172,183,238,58,120,21,188,243,206,187,238,190,251,30,
170,142,42,82,117,81,120,230,79,238,146,73,50,105,226,164,127,254,243,95,55,223,124,43,102,4,23,218,144,65,180,104,209,149,87,79,217,109,215,157,229,106,28,61,102,9,124,24,6,218,168,69,64,110,176,254,
186,75,47,189,116,209,162,235,111,120,245,213,87,55,216,96,189,229,151,95,30,163,141,45,90,105,229,149,110,191,227,78,116,6,151,65,19,39,77,162,22,97,49,247,13,25,114,247,61,247,122,45,194,155,207,115,
230,220,122,107,213,162,245,215,95,151,91,148,217,129,238,97,102,235,18,180,250,89,42,67,27,137,100,187,163,81,124,122,68,246,214,230,44,98,103,231,44,223,59,233,100,124,171,243,31,87,73,187,236,250,78,
156,207,120,67,159,145,120,43,31,223,197,225,156,57,111,76,159,177,230,154,235,209,208,65,7,29,66,70,127,255,236,227,79,248,198,137,223,248,246,168,81,163,94,124,241,69,249,80,21,119,100,216,118,139,159,
248,138,159,219,196,163,126,242,82,86,126,28,162,100,140,42,0,247,161,50,168,111,46,105,165,33,224,194,254,133,133,8,55,46,174,249,60,127,245,181,87,111,186,249,230,33,67,134,174,190,218,228,59,238,188,
11,171,16,103,233,114,147,150,187,229,185,234,204,87,52,156,90,249,139,67,158,62,99,140,70,177,95,21,123,16,148,12,27,54,12,6,238,253,103,189,88,237,56,120,147,16,207,187,241,209,180,205,55,223,12,239,
13,66,33,174,221,150,28,55,150,78,93,158,88,119,205,199,57,154,94,203,25,40,12,175,138,82,18,174,119,94,122,241,37,180,238,197,23,240,122,83,223,216,170,23,3,226,248,199,63,254,137,251,217,61,223,255,
190,155,110,186,249,225,135,255,129,221,112,220,216,37,207,57,231,207,120,113,90,101,165,149,254,245,200,191,39,78,154,120,206,57,127,194,126,193,125,46,2,69,127,240,247,120,216,152,158,125,230,25,220,
189,190,244,210,75,208,131,236,216,155,72,24,118,28,124,28,229,127,254,103,207,187,238,188,251,174,114,87,194,51,147,179,127,247,135,81,163,70,190,99,211,77,206,61,239,130,13,55,88,239,193,7,255,126,241,
37,151,226,182,177,32,230,166,136,20,36,85,255,116,139,68,251,203,192,250,173,39,57,236,66,22,92,112,248,203,47,191,130,17,188,48,143,31,55,158,33,85,139,48,183,180,248,203,129,135,31,122,120,210,178,
19,241,145,196,170,69,99,199,142,155,48,254,79,231,158,135,22,173,186,218,170,143,60,242,200,164,229,38,253,241,207,231,162,69,253,179,251,105,121,215,85,148,12,85,139,158,125,182,156,154,23,129,123,233,
197,23,209,46,202,242,234,43,175,232,22,109,188,17,62,245,136,19,243,29,239,216,228,220,115,207,199,27,203,120,22,143,211,25,215,179,44,181,209,80,39,26,240,74,149,156,68,155,205,181,203,30,13,188,145,
45,53,49,145,46,65,165,76,33,221,168,171,164,58,61,168,107,156,189,249,99,228,14,170,235,39,127,36,41,6,229,126,234,56,202,223,78,152,231,116,7,56,25,158,127,254,121,119,84,253,118,175,25,222,133,182,
194,196,14,11,217,74,36,65,75,25,233,81,0,93,106,166,175,119,25,118,193,120,234,153,103,54,218,112,3,124,200,97,201,37,199,62,231,244,131,252,137,199,159,196,221,25,222,146,162,23,9,188,78,12,77,175,66,
41,85,52,42,144,33,147,151,34,221,131,130,167,159,41,222,18,44,175,182,138,143,247,98,246,33,3,95,248,171,54,92,223,225,234,12,207,209,241,234,53,123,86,63,182,140,162,252,200,7,30,220,178,169,18,241,
33,133,200,244,161,135,71,73,246,43,175,190,58,124,193,225,176,113,247,61,107,118,242,186,120,208,32,92,212,95,124,241,165,203,46,187,204,150,91,108,142,251,151,145,163,70,142,90,100,20,62,31,130,250,
240,230,222,132,241,227,158,120,252,137,153,238,2,147,19,241,11,237,216,177,99,54,222,100,227,11,255,114,17,254,217,24,228,85,175,46,84,197,45,183,222,250,240,63,30,222,98,139,205,23,30,185,240,253,15,
60,136,87,193,157,119,42,238,163,139,61,116,206,32,60,119,186,252,242,171,80,84,191,255,17,190,244,20,32,156,250,16,54,42,17,200,173,195,126,170,94,146,137,135,1,146,4,61,196,142,95,181,104,112,223,200,
145,11,143,90,120,36,62,211,77,45,194,142,252,248,99,79,188,57,227,141,162,57,98,9,21,135,112,244,13,46,90,180,241,70,69,139,6,15,66,139,230,47,31,137,204,191,192,2,47,190,252,50,103,185,249,230,91,100,
139,48,113,187,238,186,51,194,177,194,251,134,244,77,152,48,254,138,43,174,194,33,206,214,130,180,233,11,73,81,8,215,18,131,115,246,24,192,102,144,167,140,31,105,111,169,137,52,42,65,12,153,134,169,209,
66,82,92,162,49,67,193,83,39,191,40,227,136,215,156,49,38,92,82,152,180,5,36,215,52,59,83,191,180,136,101,199,218,56,35,27,209,100,101,187,158,126,242,169,89,51,103,226,65,48,94,72,240,41,49,9,198,93,
216,101,151,93,129,93,245,205,55,222,92,111,189,117,111,184,254,111,114,180,182,169,237,56,45,220,69,163,76,45,237,58,196,89,197,40,254,87,238,143,15,60,240,208,238,187,239,186,218,106,147,241,12,247,
209,71,31,115,144,226,243,21,184,235,191,249,150,91,135,15,95,96,245,213,87,67,209,183,221,113,7,231,98,24,12,226,41,57,139,13,55,250,37,250,22,195,16,21,30,40,227,129,29,246,71,156,204,207,61,251,60,
206,74,104,120,237,181,215,205,40,12,77,159,62,227,95,184,28,125,244,49,216,79,60,241,36,222,180,196,149,17,192,232,205,82,75,79,152,184,220,196,62,188,46,245,13,150,247,49,101,233,131,198,44,177,196,
150,91,110,241,151,11,47,122,229,149,226,138,15,143,56,232,213,101,244,232,209,244,113,8,232,193,38,139,141,0,50,166,222,59,13,187,210,115,207,62,55,115,230,172,139,47,190,228,141,55,222,4,63,94,123,158,
125,230,89,240,224,73,5,46,193,228,150,65,181,152,29,163,66,48,4,12,193,100,105,210,35,195,165,31,31,20,65,139,248,37,57,108,145,4,163,45,51,222,120,3,10,31,125,236,177,225,35,134,63,249,244,83,19,95,
159,120,222,249,23,80,139,240,12,122,226,134,235,163,69,40,167,127,150,222,242,240,105,156,45,54,219,76,182,104,204,18,99,30,123,180,120,220,207,159,24,161,22,225,109,103,120,150,93,102,25,92,226,148,
175,115,151,188,129,87,178,255,215,222,151,0,218,85,20,105,191,151,247,66,34,56,4,29,252,13,16,150,17,55,28,33,192,184,32,42,75,100,81,6,145,69,192,125,27,134,81,64,12,46,32,160,248,35,155,184,13,42,40,
24,197,81,100,115,64,182,64,8,132,4,8,75,100,196,65,148,37,44,50,8,196,133,125,51,9,121,203,124,213,117,186,186,186,186,251,156,115,95,2,132,255,63,55,47,247,86,87,87,125,181,156,62,117,250,44,183,47,
205,79,232,58,82,54,69,146,7,9,159,221,174,156,175,41,44,206,117,29,163,32,52,18,217,189,155,181,250,55,246,231,194,141,40,121,129,122,143,69,167,105,79,208,91,93,148,152,168,139,185,222,122,147,81,99,
168,135,102,214,110,108,206,68,196,81,24,102,106,81,7,43,194,154,201,42,210,133,230,192,184,129,232,108,84,129,178,24,118,21,46,4,53,56,105,87,128,105,17,44,11,135,114,144,83,225,218,81,193,198,185,10,
182,220,140,6,77,174,240,92,179,184,183,242,48,135,156,197,68,212,184,157,130,157,16,199,155,139,102,94,178,214,90,147,55,223,108,211,115,206,61,15,194,171,173,182,234,222,123,237,121,234,79,126,90,41,
246,245,77,221,100,99,28,15,144,37,156,161,207,158,125,249,178,161,161,183,189,109,75,92,46,64,177,90,120,251,194,91,111,187,125,155,109,182,154,252,242,151,143,95,101,252,233,167,159,101,178,189,247,
222,123,226,118,13,46,113,0,237,166,223,254,246,238,187,239,193,209,5,5,2,71,151,203,46,159,195,38,96,125,219,109,182,6,26,46,20,206,191,250,154,7,31,122,232,117,27,189,246,117,175,219,8,19,119,92,37,
152,59,247,202,245,214,91,23,39,28,184,99,179,112,225,29,184,116,40,142,165,132,222,244,117,91,205,104,74,222,84,230,7,6,7,222,245,206,29,112,25,23,71,154,153,23,83,138,54,155,58,181,152,162,169,155,84,
41,122,242,169,217,151,93,142,122,87,165,104,100,4,62,227,156,157,82,52,121,50,110,208,157,126,250,153,148,34,101,168,77,138,214,94,103,173,109,182,222,26,7,7,164,232,234,249,215,62,244,208,67,120,42,
227,117,175,125,109,203,20,233,180,112,232,156,156,148,175,19,211,42,129,146,58,173,169,162,211,108,208,253,155,108,250,6,195,66,179,149,37,167,86,239,177,32,23,1,141,187,101,71,5,10,68,189,209,96,203,
128,107,8,67,183,179,43,74,112,32,88,241,254,8,71,220,99,14,55,165,87,64,86,36,193,145,246,24,69,43,7,128,140,90,232,231,176,162,82,31,78,42,47,138,76,100,103,235,145,140,108,187,166,160,196,150,113,137,
249,88,28,71,42,32,211,145,152,178,2,121,57,36,176,12,138,50,205,185,252,105,38,122,49,87,210,179,84,49,45,158,11,56,65,233,187,88,46,10,193,23,121,20,32,212,166,82,83,248,45,137,212,159,84,81,60,148,
174,52,69,212,37,153,17,57,71,80,8,234,75,49,40,202,146,34,140,17,215,91,165,40,53,20,35,57,97,159,91,233,202,164,104,112,176,46,69,201,240,72,147,208,232,137,88,207,18,41,32,196,50,152,62,99,189,204,
82,189,78,198,112,18,24,100,140,43,25,39,106,100,96,43,135,25,153,78,253,113,42,198,110,164,210,99,35,235,51,99,176,149,74,32,245,36,107,168,49,162,172,150,99,182,12,170,198,225,50,118,185,71,182,2,7,
216,147,255,181,57,145,243,166,146,195,18,175,8,8,199,184,43,2,134,223,166,169,49,45,78,173,255,22,92,50,163,181,212,161,72,131,107,163,22,199,236,171,26,77,139,138,57,205,76,232,146,33,237,76,162,84,
49,68,183,120,186,80,210,20,126,201,121,17,200,18,73,104,226,9,196,245,145,157,207,96,218,196,194,118,52,14,56,141,138,70,158,65,82,173,84,204,175,151,202,26,250,61,141,45,190,130,169,101,83,75,232,205,
50,181,86,144,209,217,119,118,177,203,213,168,251,48,236,77,27,168,248,46,99,167,149,51,86,135,252,75,174,235,249,180,176,123,222,156,245,36,3,37,9,73,49,89,218,35,107,93,198,135,173,76,54,4,39,167,168,
65,198,76,75,225,195,177,15,32,113,200,17,106,228,30,59,198,219,209,237,4,178,39,200,110,16,102,169,17,140,107,56,197,8,208,177,83,78,80,149,84,128,165,178,225,183,78,16,44,81,41,184,138,157,148,36,4,
208,250,114,68,2,24,141,132,20,22,242,204,52,190,101,37,217,7,45,95,137,33,94,21,38,249,160,51,224,125,138,110,247,27,121,47,163,63,181,75,226,143,190,44,202,2,90,76,171,51,45,138,38,129,169,100,61,71,
112,132,128,60,156,49,214,209,212,2,25,76,159,153,94,179,81,130,53,14,164,22,195,122,169,22,194,187,66,58,133,81,158,194,21,57,26,205,8,225,96,174,138,53,187,97,157,137,85,106,122,107,186,98,140,92,43,
113,82,59,198,10,6,223,52,115,160,150,151,98,102,145,107,152,220,37,56,173,124,72,66,171,220,202,238,105,94,56,251,221,205,70,115,226,24,76,176,176,222,45,193,116,131,50,42,61,149,51,238,163,136,239,189,
210,194,76,167,22,153,95,132,74,33,18,142,209,53,33,36,226,45,24,240,95,101,219,224,103,244,113,149,1,223,157,197,43,221,251,192,137,209,36,3,186,244,67,85,170,127,179,57,191,177,50,158,120,86,27,16,47,
155,76,98,244,230,83,121,16,121,41,85,245,86,234,123,5,77,8,201,140,112,64,244,10,66,186,222,127,189,81,192,22,183,73,198,189,6,105,190,224,34,76,250,170,65,79,230,61,156,215,82,159,185,236,168,238,138,
228,192,242,145,200,208,73,213,152,163,76,36,78,86,58,121,228,18,96,129,15,39,13,142,157,76,41,79,10,24,33,245,37,129,108,157,178,194,53,9,247,162,197,7,209,178,186,222,115,147,64,29,175,234,202,212,59,
45,233,93,200,124,42,16,234,69,51,85,76,57,6,72,64,180,100,118,223,208,138,90,88,243,199,66,75,14,125,222,198,2,18,235,164,163,43,238,183,173,166,120,51,137,5,132,156,7,88,56,180,37,168,76,159,99,153,
96,27,229,25,199,104,197,224,178,41,49,22,184,7,69,95,10,61,56,178,213,132,136,1,66,75,65,5,102,163,22,9,164,129,36,62,103,7,106,48,3,239,213,180,15,124,177,107,75,4,175,234,207,221,34,164,129,64,187,
72,50,251,152,17,227,102,9,132,249,58,41,234,112,218,175,83,156,194,106,76,77,167,146,121,78,154,208,188,28,30,108,142,230,17,144,42,229,177,0,64,108,81,25,139,171,30,87,64,60,35,243,153,110,203,74,40,
25,46,224,75,230,217,171,29,118,216,14,143,67,226,49,67,141,155,117,120,195,13,95,177,221,59,166,205,248,209,169,24,152,90,248,141,111,124,3,30,118,193,253,113,129,194,109,244,215,191,254,245,191,250,
213,13,90,44,208,216,10,57,199,130,128,162,34,79,252,230,203,108,29,53,134,160,45,49,42,164,34,201,38,178,42,232,146,252,71,158,20,193,90,117,228,161,202,105,201,203,59,83,236,182,118,190,70,88,156,147,
160,132,211,68,100,246,122,78,185,222,97,235,77,135,94,191,29,237,124,191,215,81,225,113,26,156,87,176,245,129,179,135,252,46,41,13,110,123,51,41,135,123,82,112,55,47,131,151,165,63,87,143,1,199,127,30,
63,124,74,87,73,32,136,198,80,252,157,107,249,230,181,193,209,205,202,117,247,141,35,196,172,255,52,120,137,70,204,61,252,197,248,218,13,208,193,68,54,93,174,91,84,180,159,154,38,169,172,58,152,254,37,
32,53,196,65,159,253,204,205,55,223,136,191,107,174,153,55,99,198,15,94,245,234,13,171,239,236,199,33,176,233,10,7,103,36,206,52,30,50,199,122,43,69,55,196,189,190,62,124,79,113,255,253,63,137,155,194,
222,53,250,196,125,234,239,159,244,93,60,67,3,26,15,42,17,84,95,31,150,86,248,254,73,223,225,69,18,240,8,17,86,167,213,81,167,35,143,128,90,188,244,182,51,226,53,201,209,93,89,45,102,106,49,161,209,165,
105,163,94,223,196,23,132,240,45,172,122,25,221,59,182,180,224,104,106,254,242,155,82,91,82,65,73,116,41,129,47,206,226,73,222,148,47,156,116,135,101,35,56,178,190,115,199,29,98,131,125,120,34,248,223,
246,221,7,235,147,129,175,183,35,211,116,136,197,159,12,182,18,17,131,166,56,89,14,41,121,64,202,149,175,96,41,161,225,165,87,51,235,105,81,17,130,118,21,248,84,82,131,156,238,170,154,240,213,188,212,
49,1,61,216,151,76,63,154,26,74,4,52,83,171,136,128,48,75,146,34,64,25,196,43,246,4,140,102,69,129,48,113,37,80,236,21,0,179,25,51,134,76,83,140,56,144,42,63,34,35,200,34,6,66,146,32,98,186,23,241,234,
95,139,249,228,191,185,95,139,49,33,136,130,139,69,220,198,229,107,36,138,155,122,91,197,91,59,164,14,207,197,232,244,226,161,150,173,182,126,199,146,165,75,224,33,128,8,106,92,255,21,115,231,189,237,
237,211,150,46,165,239,207,108,185,229,22,159,57,240,128,171,231,95,35,246,91,18,18,50,203,35,240,124,236,53,112,58,3,46,106,65,152,117,201,5,235,172,179,14,174,51,253,245,175,15,222,190,112,225,137,39,
254,0,207,156,214,32,133,46,135,19,154,49,181,197,22,111,250,253,45,183,226,233,87,176,247,223,143,14,63,159,253,124,248,77,51,177,206,74,38,192,24,41,106,105,73,11,146,219,97,123,157,63,70,198,250,250,
246,124,239,238,239,125,239,238,175,121,205,171,255,182,120,49,190,200,255,185,207,29,130,83,16,35,83,211,196,145,21,107,186,155,243,30,60,166,138,227,241,229,115,174,120,252,9,90,137,194,168,251,0,163,
90,193,98,190,139,52,82,142,224,68,152,122,187,179,132,223,106,64,139,36,69,127,12,68,106,69,131,56,139,213,23,138,97,146,255,180,0,104,120,163,195,227,94,236,138,230,47,210,162,107,163,246,40,106,66,
18,115,140,159,154,16,1,33,34,19,174,97,116,217,165,32,134,224,205,95,232,203,83,84,98,144,20,249,51,234,62,46,192,70,1,214,166,78,156,20,66,219,22,38,133,233,167,144,226,182,88,209,42,160,89,11,126,162,
180,221,113,199,157,151,92,114,233,25,103,158,189,237,182,91,227,215,98,182,157,182,205,119,191,247,239,91,109,253,246,153,23,159,127,240,33,159,71,68,175,216,240,21,63,254,241,41,215,95,119,245,5,231,
159,179,227,246,219,85,152,20,90,223,113,199,28,117,237,252,121,63,251,233,79,214,89,123,10,102,31,3,3,227,193,153,59,103,246,156,203,46,249,210,97,135,174,250,162,106,85,20,132,187,251,30,187,206,153,
131,21,102,46,230,213,70,240,192,230,121,191,60,27,207,174,147,219,252,213,150,145,81,124,149,19,76,76,96,55,219,116,234,151,191,116,24,190,35,116,233,172,11,177,130,237,41,39,159,116,240,193,213,138,
10,175,124,213,134,96,110,190,249,102,38,34,105,202,230,102,66,248,154,144,164,25,130,101,162,145,25,79,216,145,185,243,207,191,112,175,189,63,120,244,177,199,225,155,80,103,159,245,243,141,167,110,172,
229,101,13,64,179,70,151,182,46,52,91,159,48,113,194,183,191,253,13,89,183,16,107,153,31,124,200,97,58,10,145,103,66,119,213,196,8,97,45,217,8,2,225,210,252,209,232,82,51,25,216,187,188,251,159,15,63,
252,139,115,231,206,219,101,151,61,246,217,231,147,87,92,49,175,167,122,154,49,161,88,24,63,112,79,49,42,82,2,212,93,3,3,120,58,56,42,178,200,51,4,68,88,19,65,17,17,201,110,43,132,239,206,90,247,157,189,
125,234,209,146,210,140,229,150,206,83,176,218,99,161,85,63,145,194,23,66,11,164,150,192,209,2,154,142,16,144,151,250,87,60,20,168,58,184,114,198,74,76,135,221,44,173,251,177,122,53,176,148,69,32,4,117,
236,141,49,130,222,102,186,75,1,68,131,85,10,98,27,130,156,145,161,144,18,145,141,42,255,164,194,175,209,81,249,181,152,137,19,39,110,241,230,55,29,126,216,23,241,109,212,75,102,93,138,25,211,137,223,
59,1,165,246,200,163,142,198,10,71,199,31,127,236,63,226,91,161,136,171,191,31,223,117,193,154,85,199,30,251,117,252,102,204,167,63,189,31,144,240,173,21,124,7,6,63,140,120,248,151,190,242,174,119,237,
176,253,118,211,24,30,194,59,238,176,253,215,190,246,205,59,239,184,235,136,35,14,199,114,168,48,141,53,4,176,224,133,203,161,147,194,138,212,19,95,4,38,132,31,88,244,39,44,97,243,151,191,252,229,240,
47,253,223,51,207,56,27,223,70,197,74,113,40,181,144,219,110,218,52,124,69,21,75,168,68,121,182,133,143,205,230,222,221,22,204,228,51,25,6,50,174,52,129,205,131,149,16,240,85,159,171,174,156,191,255,1,
211,239,190,251,15,159,157,126,32,208,94,188,234,106,179,46,190,224,45,111,126,211,48,190,199,62,52,114,236,49,71,125,246,160,233,168,80,56,174,188,119,247,221,166,31,120,192,53,243,231,226,56,129,171,
25,95,59,238,232,121,115,47,187,98,206,44,28,51,86,197,87,208,87,153,112,242,247,191,247,226,213,86,251,225,41,39,1,1,7,151,67,191,120,240,225,135,29,194,174,239,252,207,59,93,120,193,185,56,152,205,248,
225,247,121,93,52,28,138,112,68,121,199,59,166,157,117,230,105,87,206,187,12,146,216,52,18,167,201,137,240,87,56,161,71,47,211,211,167,31,248,171,27,254,235,135,63,58,245,190,7,238,199,24,248,197,47,206,
241,33,188,75,133,48,197,109,238,81,172,6,251,163,31,157,204,7,233,232,100,223,157,172,32,10,204,76,175,186,242,242,153,23,157,135,53,253,42,231,71,157,214,12,209,218,30,80,187,190,231,221,56,6,35,39,
216,70,159,59,104,58,18,184,230,75,255,30,105,223,107,207,61,79,251,233,169,152,218,128,51,109,219,109,207,60,253,103,85,174,176,194,25,143,121,55,12,216,25,198,167,40,226,81,164,155,99,78,160,6,97,90,
15,167,148,102,67,52,223,52,38,83,32,205,49,194,105,51,59,226,83,177,148,147,122,98,100,120,243,235,119,43,160,79,98,147,210,175,21,133,54,8,33,77,201,68,27,146,146,135,32,102,14,191,170,26,138,137,26,
34,154,13,245,62,38,232,215,98,142,59,122,230,204,243,118,217,101,103,124,189,18,71,24,140,106,84,85,44,211,245,157,239,156,248,251,223,221,130,213,133,167,76,89,231,155,223,58,225,210,89,151,125,229,
136,35,241,37,116,84,55,114,190,111,20,245,244,91,255,126,194,197,179,102,157,121,214,127,98,65,0,206,3,126,105,230,166,155,126,139,245,47,48,249,125,235,91,183,116,163,150,122,78,60,233,228,57,87,204,
197,228,14,151,74,167,110,186,9,34,34,46,28,118,213,217,31,12,136,7,21,44,10,142,43,18,75,150,44,197,23,43,177,108,202,69,23,205,196,242,96,111,217,130,22,223,220,110,187,105,179,103,95,190,108,233,51,
217,65,194,89,117,40,249,183,82,38,243,210,122,199,227,93,81,201,225,75,80,115,230,204,197,55,44,233,155,251,227,7,112,48,120,209,170,171,50,62,190,155,255,210,151,190,20,178,88,78,20,213,1,191,93,118,
242,201,51,238,185,231,158,103,150,46,165,67,206,231,14,174,14,57,59,110,55,60,58,50,235,82,186,197,119,194,9,223,195,241,3,179,49,168,224,16,5,206,212,169,155,28,123,236,87,145,204,35,143,60,26,191,56,
121,210,73,39,224,123,65,224,195,208,17,71,28,54,243,226,89,223,59,241,7,123,236,177,219,182,219,108,5,38,191,244,160,2,237,217,117,159,50,32,179,68,73,211,24,66,33,91,115,205,191,191,238,186,5,38,255,
46,132,163,176,152,25,142,199,46,132,239,98,213,215,241,19,86,57,233,164,239,254,29,14,210,71,30,133,21,206,142,63,254,24,124,179,182,26,39,136,127,120,4,107,108,227,250,41,190,98,139,164,237,182,235,
46,236,67,165,245,119,209,161,253,182,133,11,177,24,224,171,95,67,235,252,110,191,253,59,198,143,95,229,77,111,126,35,232,183,191,253,173,247,221,119,63,8,206,21,86,90,57,241,36,151,171,105,219,240,192,
211,195,128,241,201,243,100,135,21,142,115,207,157,179,178,180,127,79,147,230,123,170,79,147,40,52,181,64,170,206,156,204,122,169,70,83,163,52,208,60,112,81,86,212,11,102,154,1,157,98,245,192,151,210,
165,125,85,189,26,113,234,5,234,123,149,29,34,121,227,25,102,35,2,130,21,149,70,97,72,218,187,159,162,220,72,184,140,33,61,248,182,229,207,240,107,49,87,94,77,191,110,224,22,224,128,234,252,249,215,226,
29,206,188,124,50,45,164,127,231,93,119,178,99,152,160,77,94,107,50,99,223,125,247,221,236,225,157,119,222,137,10,130,225,139,149,150,162,95,154,113,75,4,177,34,214,7,2,241,231,63,253,5,231,131,88,253,
228,198,27,255,155,64,112,125,213,85,103,12,89,244,226,5,30,229,45,124,193,146,164,80,94,23,252,234,134,29,223,185,195,61,247,222,139,155,93,71,31,115,28,100,50,201,201,13,30,210,119,129,48,129,247,140,
162,244,197,132,217,130,149,34,118,10,54,212,215,135,37,166,112,248,193,100,19,251,30,33,251,243,83,18,193,63,247,194,193,96,231,93,118,227,197,86,0,120,218,233,103,96,86,181,206,90,107,223,129,67,206,
91,222,114,254,121,23,98,217,45,8,98,137,222,63,252,225,30,86,225,247,157,119,222,233,209,199,30,59,226,43,95,69,243,241,39,30,199,213,15,44,139,142,117,84,209,156,123,197,188,159,255,252,12,16,168,56,
111,217,114,11,172,63,192,42,99,120,151,108,240,102,18,4,225,11,167,134,192,45,53,244,222,252,219,155,141,76,21,194,17,71,130,143,133,10,17,194,212,77,54,65,248,83,166,172,179,207,190,159,194,170,81,151,
205,185,98,218,180,109,118,221,237,61,40,142,180,245,241,127,96,28,126,220,1,75,5,242,111,15,79,156,56,1,167,53,80,231,67,251,191,236,243,73,104,205,190,244,242,105,219,110,141,67,251,113,95,251,6,214,
168,221,124,179,205,22,255,109,49,110,97,157,117,214,47,176,202,1,214,238,219,116,211,77,143,255,250,55,217,25,228,234,180,211,40,87,187,190,135,126,66,226,162,139,46,6,205,219,139,5,194,123,92,43,76,
66,88,204,164,197,52,33,147,213,10,38,28,37,90,66,24,1,255,237,169,216,33,35,100,154,169,97,70,55,131,152,181,74,134,169,215,15,110,83,58,131,57,8,244,226,88,80,244,84,234,170,239,169,62,75,238,149,248,
193,103,3,228,154,197,103,69,115,194,203,195,163,84,247,247,99,217,158,47,127,133,70,60,94,224,136,207,56,133,7,7,205,251,254,72,71,251,245,215,91,31,19,10,34,214,95,239,154,107,174,3,129,23,126,14,150,
99,89,119,10,45,180,252,231,63,253,105,250,244,79,99,69,250,157,118,122,15,238,180,252,199,79,102,80,93,65,197,116,219,104,202,58,83,30,52,163,148,29,0,0,37,18,73,68,65,84,123,244,22,172,175,140,19,213,
187,238,186,155,17,244,187,72,130,73,57,119,71,22,73,254,5,23,92,116,232,161,7,163,12,97,246,113,211,77,228,137,116,41,16,210,145,16,20,63,102,54,142,25,175,153,131,194,141,129,112,176,196,210,241,79,
62,249,36,253,232,192,164,213,73,9,200,110,188,141,87,143,55,252,230,55,55,61,245,100,181,252,46,150,83,138,14,57,234,199,205,188,205,240,137,171,171,119,222,113,39,103,248,182,91,233,231,185,214,94,107,
242,127,187,35,209,45,183,220,202,114,143,60,250,168,92,176,102,201,160,111,168,250,189,0,27,137,191,20,96,180,208,172,87,116,242,188,44,36,230,161,102,163,96,153,24,132,192,204,219,23,222,1,89,132,192,
233,199,109,61,218,226,125,163,224,99,97,73,166,17,2,136,77,54,126,253,194,133,116,152,129,34,238,1,58,23,50,135,118,44,102,136,65,114,195,13,191,222,124,243,77,161,134,53,100,127,125,227,111,144,94,252,
214,209,139,95,188,26,126,107,195,185,214,71,185,114,38,49,212,41,87,142,206,214,25,150,151,247,220,214,151,78,34,36,88,45,169,105,17,136,212,188,162,150,52,2,213,141,38,195,37,215,157,247,150,239,218,
128,51,127,90,44,219,5,255,228,79,132,145,154,234,79,245,138,24,17,238,18,137,200,247,64,176,255,52,212,226,27,101,181,158,71,248,30,193,228,33,248,44,206,43,34,66,120,54,27,180,69,221,6,146,108,195,26,
101,44,222,133,48,135,122,240,193,135,62,246,177,15,163,128,126,224,3,239,195,202,202,87,93,61,159,253,194,178,67,248,233,142,87,190,250,149,187,237,246,30,156,161,143,246,247,97,2,139,137,27,86,9,217,
146,127,105,70,249,255,161,15,190,31,63,17,184,239,191,126,2,189,213,20,21,189,40,79,176,232,239,248,179,105,246,7,43,58,99,117,75,148,149,73,171,175,14,14,238,123,224,118,240,251,246,222,19,151,119,25,
85,220,54,132,216,212,195,64,152,32,36,255,213,16,213,155,169,158,38,20,62,64,16,133,107,187,59,189,235,157,88,91,30,134,120,29,144,85,87,115,39,254,253,253,175,122,213,43,73,194,189,150,46,93,226,201,
190,15,127,248,3,124,200,217,115,175,15,252,33,254,113,51,145,17,226,190,251,239,199,236,143,189,253,135,87,108,0,254,195,143,62,10,91,32,150,60,179,148,9,17,6,33,113,101,137,134,96,221,244,48,175,168,
109,48,157,100,233,129,251,31,248,219,223,254,182,213,86,111,51,59,11,86,149,70,8,188,129,214,95,111,93,104,63,252,240,35,136,11,196,6,27,108,192,96,88,2,241,145,135,163,133,134,255,112,207,61,216,244,
232,133,34,126,159,134,197,238,119,39,242,27,184,95,208,1,159,150,55,124,248,97,16,215,95,191,224,181,175,121,13,38,170,11,174,95,112,227,175,127,131,131,214,180,109,182,193,15,13,224,204,134,21,145,43,
58,42,184,81,70,28,71,27,63,109,211,237,227,172,94,243,14,235,252,87,146,17,129,12,145,220,73,214,32,52,181,193,159,102,129,174,54,79,92,233,140,76,218,204,64,249,237,87,133,29,219,202,248,234,227,212,
93,169,161,70,78,118,120,129,153,42,202,174,107,186,52,66,232,74,107,180,46,217,73,26,131,34,83,62,27,118,15,177,114,77,109,198,209,152,110,4,83,210,208,165,94,120,164,105,191,253,15,196,189,145,139,46,
60,119,250,103,14,56,229,148,25,243,230,94,233,172,247,225,28,234,253,239,219,235,151,231,156,141,58,251,227,83,127,2,221,179,206,250,79,204,67,23,92,127,245,254,7,124,10,191,52,35,48,247,254,241,143,
248,65,192,139,46,252,37,150,104,59,249,228,25,216,253,170,46,117,226,111,76,95,121,229,85,119,222,117,247,101,179,47,62,238,216,163,32,140,85,65,47,153,53,27,15,48,205,156,121,137,36,60,37,196,34,136,
210,0,16,190,108,32,115,155,94,55,69,70,54,61,126,99,234,31,55,218,104,199,237,183,255,143,83,103,188,236,101,107,126,251,91,39,96,100,62,245,196,147,184,36,130,251,113,184,170,136,131,7,102,226,218,19,
161,95,62,121,242,67,201,33,7,117,7,151,101,241,27,39,152,234,226,164,88,132,175,189,230,58,44,154,247,129,247,191,111,221,117,166,124,228,35,31,194,69,128,223,222,116,51,156,39,1,151,55,145,100,66,226,
170,100,124,55,243,117,32,25,218,93,91,211,8,66,123,152,240,153,170,63,51,180,236,204,179,126,177,251,238,187,126,98,159,143,175,255,15,235,111,248,170,13,113,149,6,98,215,94,191,0,33,124,232,67,239,95,
111,253,245,62,246,209,143,96,57,243,155,127,255,251,133,119,220,129,149,9,63,254,177,143,172,191,129,61,72,179,13,172,249,143,13,141,91,79,56,6,239,177,199,174,96,98,76,222,118,27,29,218,63,250,209,15,
175,59,101,93,125,104,191,225,215,191,134,24,46,137,44,248,213,127,241,195,91,88,23,49,90,249,23,95,237,228,42,68,71,110,44,94,69,207,3,232,77,44,180,196,21,66,93,129,84,188,91,137,45,33,180,169,65,221,
0,141,0,12,199,108,99,211,91,223,132,73,45,208,19,148,241,36,175,27,135,74,182,112,28,115,59,164,182,27,232,68,62,253,78,14,11,103,204,65,215,129,7,52,67,37,224,85,191,215,50,217,16,237,140,45,233,203,
17,140,115,194,119,79,196,31,211,130,128,75,81,248,211,74,40,22,123,236,177,55,174,9,46,94,188,24,37,151,67,56,232,179,95,96,25,252,48,20,126,88,133,213,113,155,94,126,105,134,147,143,119,60,105,200,15,
27,30,255,141,111,97,138,186,108,217,50,48,49,67,158,186,217,27,89,235,160,131,42,40,109,26,211,153,15,126,240,163,168,50,56,177,38,67,163,163,184,177,241,187,223,221,114,239,255,220,155,230,208,108,232,
202,249,52,153,62,141,44,80,133,140,243,144,74,161,213,199,174,187,238,130,157,246,129,69,139,112,163,233,139,135,125,249,190,251,238,227,4,226,230,222,1,251,127,10,15,138,225,134,18,30,74,203,98,157,
237,126,220,12,135,28,253,227,102,248,213,175,179,207,62,231,144,67,62,127,216,97,135,108,189,237,246,180,223,187,23,126,177,234,235,223,248,246,191,124,226,99,135,28,252,185,69,139,22,29,252,133,67,159,
126,234,41,252,182,82,22,153,14,114,234,85,157,197,171,120,101,251,42,41,79,198,186,196,85,138,94,40,124,10,148,78,251,247,127,112,10,10,223,199,63,250,17,60,222,128,195,39,126,32,114,246,236,203,175,
187,246,122,14,225,224,47,80,8,95,248,194,161,56,246,0,104,191,253,14,60,246,152,175,94,120,254,185,56,96,159,242,195,31,205,155,119,85,64,199,138,177,55,221,140,7,81,143,60,242,8,244,158,124,202,12,220,
220,195,28,250,153,101,207,236,255,233,207,28,115,212,145,56,180,7,173,209,209,251,255,136,245,172,23,97,112,222,234,46,134,224,154,251,167,62,185,239,130,5,11,220,81,159,115,66,39,154,136,8,67,14,255,
240,60,128,182,181,194,232,166,28,98,144,72,222,96,84,211,169,15,253,27,111,188,121,253,54,72,117,204,8,200,168,55,185,152,193,172,103,165,128,78,158,247,7,173,218,16,109,114,192,88,81,186,26,39,165,235,
189,74,229,123,224,20,50,163,55,138,222,121,218,32,175,88,111,177,208,50,126,255,234,160,233,7,254,235,190,159,194,190,10,112,241,167,198,144,200,136,195,89,97,35,198,155,183,230,108,65,91,23,100,33,240,
157,90,185,114,42,204,64,184,84,99,255,231,167,250,43,190,171,95,248,185,17,148,36,251,227,222,78,2,7,45,92,177,53,126,178,174,68,84,234,205,242,27,117,5,182,242,80,125,48,96,141,0,31,5,195,154,176,8,
185,191,159,67,8,48,62,15,139,151,44,9,146,161,155,40,60,42,135,210,137,99,112,204,198,226,223,238,208,238,86,92,173,137,206,104,213,56,108,36,91,54,27,77,47,143,69,183,94,106,186,91,234,3,93,174,87,251,
148,154,215,189,28,100,42,211,50,120,22,75,1,151,23,214,4,165,227,205,122,38,242,57,73,237,94,62,82,81,7,120,14,33,107,179,13,83,155,214,242,198,13,136,25,142,22,46,129,136,76,164,171,99,129,68,26,78,
44,128,9,11,174,157,157,123,238,121,245,183,182,181,15,145,57,113,162,119,66,48,243,128,177,159,4,159,198,226,140,10,14,90,168,218,186,100,231,145,33,7,240,2,154,131,124,22,223,180,183,198,76,209,91,35,
231,155,53,80,16,201,160,37,81,103,17,50,138,222,226,138,249,108,189,101,87,140,185,24,37,191,170,127,44,147,105,45,103,82,36,209,89,28,233,205,24,246,172,172,162,239,108,254,52,38,52,154,233,98,44,179,
35,49,83,107,213,155,212,152,237,181,234,49,87,124,111,58,16,97,35,169,11,58,22,244,167,225,24,129,172,204,242,59,159,90,201,98,166,238,137,88,138,80,35,92,163,133,174,84,17,224,116,198,106,94,42,153,
218,122,170,110,244,86,146,166,248,156,58,44,93,226,106,36,99,134,150,202,131,200,47,15,145,90,55,104,145,51,166,47,215,100,192,94,181,24,41,243,92,106,206,196,10,226,249,204,22,159,249,112,118,108,111,
187,13,128,44,20,83,224,237,86,97,224,210,140,158,105,196,193,101,187,236,9,76,172,18,90,198,16,119,212,154,171,116,179,138,1,55,83,218,116,231,10,161,211,171,40,128,77,179,145,114,140,245,70,1,200,151,
246,129,54,186,108,46,35,217,152,67,50,28,110,21,100,16,76,36,185,102,75,45,136,165,249,212,186,154,182,118,56,16,229,170,21,240,237,108,26,235,144,189,98,243,103,46,153,209,142,25,187,87,111,52,77,133,
118,160,78,55,231,6,233,246,98,93,219,106,73,7,151,140,3,177,221,44,90,117,123,202,108,155,128,8,37,3,202,48,45,160,35,123,14,164,62,179,145,188,106,68,206,40,190,33,107,196,140,221,26,73,198,172,203,
134,177,234,155,94,37,236,177,190,39,83,149,208,229,229,69,42,163,40,125,32,224,115,162,162,251,243,86,34,137,166,6,167,69,91,177,137,202,142,4,13,155,140,10,141,6,65,1,20,66,107,47,39,109,182,114,22,
77,236,26,199,68,88,4,132,19,8,132,223,58,64,104,213,207,82,3,108,66,113,32,169,39,198,103,8,164,50,6,204,168,72,111,73,81,201,55,15,72,65,203,19,106,180,164,55,220,242,42,9,183,113,155,150,2,97,36,21,
78,4,93,175,165,69,197,129,74,69,5,69,98,201,120,0,175,42,169,89,27,222,161,76,114,179,242,218,21,67,139,103,194,239,21,161,82,52,33,9,28,136,92,120,220,175,109,33,40,31,151,86,14,123,59,184,34,159,149,
140,212,124,3,42,90,88,16,124,191,253,20,1,214,146,166,149,107,221,214,214,161,84,4,108,74,160,40,2,208,96,34,197,245,238,136,174,136,165,28,233,2,161,241,235,37,89,75,203,131,99,84,168,89,19,157,24,118,
227,36,232,166,42,133,129,132,49,28,180,148,243,154,89,25,97,76,135,163,125,206,72,82,24,246,46,118,233,11,35,121,117,137,43,71,244,160,226,220,168,153,135,2,158,99,201,96,38,33,144,47,62,141,146,129,
140,162,248,12,4,47,47,60,16,90,69,112,180,64,202,212,42,154,214,90,25,58,27,2,28,144,103,12,216,61,227,100,78,107,176,198,167,30,28,202,248,24,177,90,65,177,127,198,233,8,38,124,245,5,236,244,246,110,
27,43,109,100,196,230,10,23,78,179,205,182,74,124,244,138,15,66,136,123,169,86,42,35,194,149,161,248,177,54,221,11,221,20,80,11,48,157,55,33,99,171,176,249,128,156,42,70,28,65,72,77,122,78,24,223,158,
99,63,241,192,142,27,22,60,54,164,87,95,230,137,140,98,199,79,18,98,4,42,16,220,209,231,189,203,7,152,23,115,210,130,9,153,204,92,21,50,30,132,200,196,129,202,98,225,163,198,110,65,163,21,59,117,67,12,
153,81,145,110,202,84,87,155,20,28,205,12,180,236,245,50,0,84,114,130,152,218,17,192,52,46,105,177,154,46,45,150,208,65,79,143,22,136,213,249,239,92,13,154,78,216,253,80,138,129,47,132,68,82,18,54,232,
26,49,3,152,109,106,40,135,198,27,166,46,0,14,207,43,218,235,155,203,233,15,59,201,224,203,9,229,61,140,226,118,152,28,157,222,6,90,38,141,29,146,53,194,86,62,107,87,27,104,186,170,91,1,106,28,149,10,
246,196,248,83,69,228,235,2,53,181,58,91,143,237,214,35,104,127,199,64,179,63,50,54,178,182,52,108,21,178,102,49,109,162,240,197,186,40,175,180,164,248,58,235,61,79,237,43,95,140,3,218,67,181,81,50,217,
102,73,45,163,116,77,66,208,195,17,213,196,165,187,88,157,223,133,47,68,101,57,62,160,137,69,35,86,9,251,145,131,130,194,28,136,137,10,115,244,59,131,100,161,180,216,24,104,30,51,98,90,76,8,71,194,50,
53,87,219,130,112,248,57,63,233,16,44,225,8,161,15,71,53,98,34,95,67,104,40,136,1,173,37,160,81,20,19,45,213,69,62,75,132,178,206,3,186,48,46,179,186,194,204,122,168,103,43,13,179,45,101,180,167,160,196,
110,79,90,226,118,32,148,3,122,143,13,110,107,1,167,166,45,138,27,2,200,189,50,52,133,207,4,243,53,2,241,75,5,37,49,109,208,140,98,240,185,50,214,80,224,130,122,98,72,111,65,107,84,218,190,242,130,129,
136,108,80,34,214,134,72,28,8,74,72,142,239,77,179,205,98,145,105,149,76,74,136,215,13,128,173,169,8,54,213,114,142,53,200,184,57,166,200,8,161,193,178,76,17,208,3,169,94,82,84,218,19,41,160,112,228,56,
93,143,86,184,227,47,219,32,206,190,160,231,65,89,43,86,201,75,250,99,99,169,55,140,236,68,34,26,19,226,103,34,70,140,118,158,104,213,16,32,235,246,18,145,224,4,16,97,193,151,248,74,28,247,232,193,33,
178,89,245,26,121,238,130,150,40,102,97,33,38,2,37,52,22,208,234,233,117,61,244,26,28,70,147,247,82,111,137,47,138,154,104,85,41,180,130,167,75,138,190,159,62,107,60,169,85,71,232,120,245,225,75,200,26,
45,165,107,240,181,176,206,179,230,179,122,169,215,73,134,77,208,198,86,54,168,54,138,236,85,214,147,172,58,12,129,175,229,179,98,89,166,206,64,61,173,213,181,45,209,210,2,194,28,51,33,38,154,97,93,185,
40,125,33,181,120,48,175,193,205,110,57,142,164,164,37,238,26,49,13,5,221,54,98,105,202,74,70,35,73,93,148,85,9,246,22,41,15,25,28,173,165,225,20,130,102,51,136,199,52,61,161,153,49,20,58,137,34,129,146,
105,116,39,214,235,1,75,189,154,159,250,172,123,99,239,10,45,237,176,242,48,69,206,234,247,106,46,200,107,187,26,90,249,160,217,76,7,117,233,99,28,167,53,236,23,253,67,103,141,255,105,87,6,54,59,174,196,
104,83,175,18,108,38,179,214,155,213,202,18,1,48,78,50,159,19,164,135,225,50,82,207,61,105,110,219,66,168,237,216,86,197,201,133,96,155,212,184,106,185,197,253,212,32,107,175,159,226,67,55,13,184,30,176,
212,171,249,192,212,77,109,87,243,181,105,205,215,242,66,43,225,204,193,3,234,245,8,186,226,11,38,136,84,75,25,210,130,121,154,133,83,16,45,109,76,227,250,142,204,153,68,145,136,120,172,7,4,181,173,3,
179,76,9,102,89,164,161,71,59,172,207,157,237,41,121,3,76,187,110,21,157,182,107,148,123,11,138,49,147,124,70,254,43,187,198,214,179,213,76,252,137,12,173,80,127,106,210,149,77,114,144,175,119,50,242,
88,53,82,231,21,78,72,123,42,166,48,82,146,93,13,190,165,18,194,81,230,210,105,138,72,153,93,27,200,12,78,215,82,155,205,104,27,2,9,34,137,170,25,74,171,231,104,227,40,139,128,41,200,89,1,22,19,153,28,
112,196,51,146,6,211,52,69,83,180,132,144,46,38,178,138,37,97,163,107,155,38,231,73,170,89,62,179,144,4,43,198,242,226,88,189,51,34,102,156,169,215,50,194,212,84,206,87,251,128,243,135,135,181,92,230,
23,69,57,42,8,167,39,34,184,103,236,198,73,168,48,149,12,113,178,50,202,60,231,68,102,94,165,20,177,70,240,68,33,52,147,198,165,102,133,224,118,214,31,125,232,10,96,77,145,6,73,69,101,241,85,63,145,249,
168,17,84,108,177,13,84,64,211,57,137,113,42,235,90,160,98,185,143,172,112,201,73,173,232,105,125,156,200,135,230,36,185,75,130,18,162,112,45,213,163,243,167,182,161,123,70,134,233,151,57,120,154,135,
252,233,174,49,211,50,118,43,211,126,255,19,143,53,178,13,24,215,184,10,9,213,90,41,109,140,166,2,158,211,16,99,1,167,78,75,226,50,177,148,114,238,61,169,62,161,158,42,26,14,68,85,93,171,115,166,224,63,
0,234,180,180,75,18,142,102,26,186,84,64,157,219,209,210,101,145,98,105,23,130,16,86,150,230,151,113,51,171,210,227,8,225,156,248,97,94,40,31,226,168,181,152,124,39,181,242,51,114,20,219,154,55,89,155,
236,137,41,38,210,109,13,62,150,192,19,177,32,160,125,107,157,132,48,43,20,68,67,16,148,251,237,104,230,123,228,116,0,7,79,20,66,26,114,202,81,226,21,73,80,216,36,190,56,104,1,107,69,71,205,114,222,67,
173,133,0,208,196,127,60,44,135,213,23,243,175,20,138,247,172,24,208,94,75,205,98,89,47,157,208,234,147,86,223,96,163,13,39,175,63,101,149,9,19,188,86,52,80,136,9,6,251,1,171,57,135,188,98,242,169,189,
244,138,250,166,64,98,9,182,98,158,215,74,160,217,45,229,91,44,145,177,210,132,172,85,24,44,118,69,90,177,160,129,133,102,206,103,214,17,136,216,89,106,197,160,190,248,105,240,28,108,192,129,100,157,128,
172,87,231,44,213,248,193,136,117,80,193,102,137,202,199,82,146,70,172,236,79,206,168,134,34,41,157,16,6,76,180,180,10,105,88,187,149,177,132,29,11,38,176,144,23,228,88,52,32,137,128,176,72,210,248,156,
67,22,121,18,46,9,88,156,76,108,1,135,169,18,148,149,107,110,115,104,249,192,35,159,181,72,156,15,37,134,14,45,23,204,235,24,123,116,94,140,45,91,186,116,209,189,247,255,241,246,187,159,120,236,137,128,
236,169,244,32,193,61,166,60,186,149,168,68,39,87,245,125,39,125,138,242,255,89,123,242,219,118,222,110,181,23,175,54,48,56,160,99,209,194,29,221,101,160,203,64,151,129,23,80,6,80,138,135,135,134,159,
126,250,169,249,23,93,254,224,3,127,177,135,180,198,72,92,41,175,74,106,118,10,93,66,152,240,162,137,59,125,112,247,213,39,77,114,7,82,119,208,232,202,106,41,89,29,191,203,64,151,129,23,68,6,232,156,159,
78,40,240,239,137,199,30,191,228,140,243,150,60,189,216,56,46,117,82,38,151,90,128,123,171,47,164,102,36,100,242,108,202,101,127,223,26,47,89,99,210,75,38,97,161,237,254,113,120,80,15,37,21,255,242,147,
113,109,175,163,187,12,116,25,232,50,176,242,102,128,74,170,251,63,50,178,198,75,215,152,180,198,26,139,159,124,90,174,161,179,219,245,87,150,185,183,120,123,138,47,28,80,169,229,218,42,69,115,180,111,
245,53,214,192,175,72,142,224,145,41,186,64,236,94,43,111,158,58,207,186,12,116,25,232,50,208,156,1,76,81,81,80,241,40,20,234,26,230,138,147,94,178,198,95,23,253,153,90,77,151,67,1,173,167,164,246,246,
20,244,185,155,223,29,28,205,64,69,7,141,193,241,3,171,140,95,5,191,145,128,122,58,224,138,42,46,25,227,39,54,49,111,237,94,93,6,186,12,116,25,120,97,101,192,215,46,212,79,76,52,49,87,28,197,47,51,14,
142,167,103,246,169,30,166,75,137,155,240,220,212,82,120,182,164,74,233,100,9,211,100,230,192,192,224,4,220,229,199,19,84,248,189,229,126,250,237,225,234,26,4,185,36,200,29,209,101,160,203,64,151,129,
149,61,3,116,233,146,254,211,61,33,252,118,45,157,252,163,134,226,71,210,233,247,110,169,196,150,110,244,75,96,40,146,186,78,218,146,42,114,37,194,61,127,138,42,222,63,130,213,245,232,5,193,113,48,237,
234,42,26,240,168,164,218,241,187,12,116,25,232,50,176,50,101,0,21,203,213,83,122,52,139,138,25,61,146,58,74,245,212,85,182,113,3,244,96,90,233,57,234,56,14,119,66,79,172,158,75,42,116,232,82,3,61,75,
60,60,206,221,159,162,250,238,174,65,160,198,187,82,223,205,85,227,100,119,173,46,3,93,6,86,190,12,208,116,144,78,179,233,218,165,251,164,59,238,152,113,226,42,39,234,27,120,174,152,230,102,136,233,201,
184,90,190,178,183,146,234,42,49,149,208,1,170,169,236,12,82,69,223,51,135,253,126,42,172,184,105,5,78,87,85,87,190,17,212,121,212,101,160,203,128,207,0,149,82,247,194,188,144,63,93,121,29,69,89,29,192,
23,230,170,105,170,151,246,159,174,0,162,65,53,78,191,244,76,54,87,82,77,13,166,98,30,189,224,1,158,240,31,29,166,111,1,226,110,24,254,161,154,142,140,96,174,58,50,142,190,205,69,255,186,170,26,165,172,
107,116,25,232,50,176,210,100,160,170,167,116,150,205,51,84,250,4,69,19,84,154,149,142,195,109,119,158,49,234,90,137,14,211,172,2,138,11,38,149,84,95,122,43,1,83,131,53,10,211,176,70,215,110,221,77,126,
87,111,251,251,135,112,107,12,119,202,96,146,174,172,118,85,85,82,217,17,93,6,186,12,172,84,25,208,245,148,10,169,43,167,68,12,98,238,136,179,109,119,59,136,106,162,90,61,3,69,51,153,89,74,80,184,127,
37,69,146,96,208,33,109,17,170,39,80,209,113,211,223,205,75,157,32,140,15,246,227,118,21,254,104,201,112,148,100,250,143,226,74,5,63,174,224,245,192,93,111,151,129,46,3,93,6,158,197,12,184,122,202,167,
252,213,252,212,221,219,167,194,138,185,96,31,61,106,79,101,139,234,44,221,241,175,94,166,104,154,130,73,79,8,184,130,139,122,138,174,220,137,191,7,42,125,162,132,162,164,142,244,15,147,127,174,150,143,
142,195,12,21,120,112,165,175,127,120,20,206,98,137,42,60,212,197,85,181,132,211,241,187,12,116,25,232,50,240,156,103,128,174,157,162,70,161,118,161,116,226,63,93,57,165,54,157,239,99,146,138,89,32,205,
92,149,91,186,134,106,154,69,228,41,43,238,42,127,33,85,33,70,228,232,48,93,106,88,101,96,220,50,87,80,81,53,49,237,29,194,249,254,8,106,53,42,42,218,252,197,42,242,185,187,79,21,229,174,107,116,25,232,
50,240,124,102,192,213,81,84,38,122,185,153,168,251,182,18,85,84,60,220,143,187,252,40,169,52,15,236,31,239,230,173,116,138,77,140,186,151,186,215,207,98,213,44,21,144,169,90,90,143,33,131,59,83,40,232,
227,199,13,14,143,31,162,154,138,162,137,82,138,127,67,67,244,104,42,112,112,211,140,230,207,116,12,112,19,233,238,238,127,154,218,142,211,101,160,203,192,115,157,1,154,227,81,173,170,94,52,55,165,98,
74,245,116,96,112,112,28,190,184,68,231,250,52,81,29,24,135,75,153,244,123,113,141,37,53,45,146,197,239,248,151,194,29,29,25,38,159,224,192,144,43,199,40,152,238,138,238,8,46,61,80,113,117,149,212,213,
88,42,183,37,148,142,223,101,160,203,64,151,129,231,35,3,92,87,185,182,114,189,226,249,42,157,236,87,229,11,55,135,168,210,186,114,73,87,2,172,155,174,54,7,102,44,96,127,123,42,200,149,41,170,168,88,54,
101,20,103,251,116,107,203,157,230,211,183,98,241,28,149,188,104,126,74,94,119,85,181,156,199,174,167,203,64,151,129,231,54,3,92,148,80,153,244,139,139,169,187,18,64,83,86,120,52,110,176,186,34,10,90,
46,149,138,167,102,102,106,4,218,253,246,148,128,57,130,167,202,152,28,115,253,198,51,255,56,249,167,27,82,120,145,179,238,15,204,174,168,198,121,235,90,93,6,186,12,60,223,25,112,39,254,84,82,185,76,17,
69,47,220,31,114,55,253,169,164,82,43,92,9,53,5,52,245,31,2,74,220,125,33,85,218,141,202,14,14,183,160,104,166,140,231,250,81,54,233,235,82,238,138,41,121,229,203,40,104,119,201,194,29,12,48,81,77,38,
206,169,91,29,167,203,64,151,129,46,3,207,106,6,220,28,143,138,19,95,80,117,229,137,170,22,191,96,26,4,42,27,62,121,222,234,42,87,92,188,72,57,243,210,149,115,48,44,93,85,144,38,75,161,100,163,229,108,
144,23,100,17,31,40,169,100,196,221,139,34,162,123,117,25,232,50,208,101,224,5,146,1,58,153,246,117,146,138,26,21,86,250,143,162,214,79,63,138,24,30,227,167,128,90,76,15,233,196,159,68,33,236,190,138,
197,180,121,143,187,232,122,45,56,12,206,31,160,169,89,241,244,245,83,87,109,13,92,215,236,50,208,101,160,203,192,243,147,1,42,149,176,204,133,137,222,81,181,184,124,57,18,245,149,154,116,238,141,149,
253,232,185,208,120,66,73,186,209,12,211,69,161,107,103,187,59,254,84,47,229,197,30,12,99,9,106,231,13,247,57,15,224,39,181,220,187,34,69,179,35,186,12,116,25,232,50,240,124,101,0,197,9,21,145,222,169,
74,85,149,10,133,138,105,170,113,152,43,186,175,66,245,143,27,166,126,55,105,141,39,148,228,251,112,54,0,82,160,87,171,111,79,201,76,214,169,64,21,229,219,149,112,242,1,119,252,233,174,63,189,83,177,37,
247,232,207,59,234,84,186,183,46,3,93,6,186,12,172,12,25,160,242,228,255,163,72,85,21,108,28,221,95,199,66,80,184,178,10,39,177,36,20,61,25,234,230,167,234,155,254,181,238,75,145,116,15,81,165,162,174,
60,11,59,174,211,116,13,117,120,104,104,100,184,122,212,159,42,42,236,115,73,165,178,202,23,5,232,251,168,85,221,22,160,142,232,50,208,101,160,203,192,243,151,1,170,161,116,237,148,234,148,171,84,56,205,
231,89,225,64,31,78,187,169,98,209,205,33,58,181,7,31,211,81,154,208,182,122,185,34,72,55,151,6,121,114,11,37,125,201,32,174,161,22,145,102,168,67,195,152,33,115,225,197,3,254,35,195,152,39,187,74,138,
55,190,30,192,117,149,252,178,234,93,187,203,64,151,129,46,3,207,125,6,80,139,112,219,137,230,168,168,78,227,168,82,209,133,83,226,140,160,130,245,97,161,84,55,9,36,1,252,12,20,122,176,196,20,241,147,
87,60,227,148,110,146,199,178,41,82,73,235,203,168,168,129,128,228,208,48,74,234,16,30,80,165,38,149,83,180,241,142,127,228,31,22,77,229,207,174,158,234,188,117,116,151,129,46,3,207,111,6,168,34,161,56,
225,145,122,250,192,26,254,88,148,20,147,81,112,135,80,178,104,153,212,170,223,157,118,143,12,203,233,188,118,155,42,92,238,197,252,204,237,41,41,178,90,75,163,192,44,149,80,20,81,150,64,81,167,63,87,
82,249,7,6,171,14,28,5,186,87,151,129,46,3,93,6,86,170,12,160,46,13,160,100,225,82,37,38,132,116,121,146,174,151,98,245,60,250,165,39,188,220,27,79,78,227,39,168,218,5,145,185,61,165,171,103,22,228,153,
101,203,158,126,242,73,76,150,221,195,169,238,141,74,42,205,76,221,236,148,170,171,43,177,89,237,142,217,101,160,203,64,151,129,231,45,3,174,152,210,213,73,186,35,133,185,33,214,40,165,23,221,152,146,
202,133,103,253,135,134,168,170,54,204,47,129,149,188,50,37,53,145,177,12,184,241,244,83,79,163,200,195,48,123,67,211,101,247,66,211,147,221,103,151,129,46,3,93,6,86,174,12,112,13,164,57,31,79,70,241,
225,203,34,177,120,78,136,233,42,149,212,33,234,163,69,245,139,53,45,123,89,96,44,37,21,182,201,10,254,227,31,191,86,174,188,117,222,116,25,232,50,208,101,160,85,6,226,89,32,221,238,39,142,171,162,174,
98,102,230,161,192,229,83,121,126,55,51,217,168,164,154,62,227,17,235,59,102,222,140,145,239,154,93,6,186,12,116,25,120,129,102,0,117,213,125,89,191,182,214,209,212,178,42,175,18,102,84,82,85,209,20,1,
75,192,80,92,215,173,64,215,238,50,208,101,160,203,192,11,61,3,116,61,0,203,252,243,124,181,16,76,182,96,70,37,21,138,165,137,170,86,246,23,31,10,118,58,118,151,129,46,3,93,6,94,248,25,192,51,86,181,115,
212,124,132,170,164,58,117,186,28,203,47,55,167,181,74,238,90,238,208,48,158,225,170,173,222,86,173,107,119,25,232,50,208,101,224,5,147,1,212,55,170,114,218,223,214,213,53,148,84,115,247,74,79,75,5,25,
50,40,170,79,60,242,216,210,103,150,76,28,63,65,248,29,209,101,160,203,64,151,129,255,103,50,176,116,233,146,199,31,121,20,181,78,46,114,82,233,243,15,226,151,78,229,57,252,106,101,63,52,160,64,127,120,
128,31,127,94,217,228,136,248,163,125,143,60,248,240,159,239,251,51,150,162,170,122,91,215,111,131,214,53,187,12,116,25,232,50,176,178,100,192,215,49,84,182,69,247,45,122,244,161,71,221,15,252,225,137,
85,250,131,147,76,224,189,42,149,92,48,227,119,136,133,89,42,7,198,115,213,170,164,178,141,228,10,192,210,37,75,175,154,121,217,182,239,222,113,202,250,83,198,79,28,143,135,83,233,137,170,68,204,103,74,
166,207,238,193,4,207,93,161,159,98,2,168,207,158,149,21,234,178,5,227,16,94,160,206,219,96,254,63,110,119,219,113,197,110,252,231,40,159,238,138,38,45,253,52,180,100,217,162,123,239,159,63,115,206,210,
197,75,26,35,225,82,107,196,250,55,217,244,13,154,165,231,167,172,144,114,88,126,194,196,137,107,190,252,101,147,214,152,52,126,252,120,154,187,186,103,85,53,148,43,110,133,26,225,15,8,149,146,52,35,253,
208,32,116,223,98,91,104,17,199,213,241,48,211,198,55,101,89,172,12,200,155,136,165,24,51,128,203,81,161,172,206,138,165,119,13,14,153,232,48,227,48,131,45,3,33,166,193,47,91,23,124,201,134,129,73,155,
162,130,46,201,24,139,185,97,68,164,227,195,46,179,171,172,250,103,160,133,203,189,193,50,83,186,59,244,121,36,249,20,177,84,198,117,85,253,124,131,53,18,70,102,144,144,196,88,36,227,204,128,83,129,75,
50,203,153,20,199,178,132,128,115,111,216,142,30,48,216,50,250,98,26,124,47,108,68,168,199,179,210,108,248,30,251,105,85,148,161,22,219,81,180,5,54,88,78,82,235,211,40,178,138,16,160,160,239,123,93,151,
244,131,171,92,244,50,141,159,172,239,18,14,210,27,113,153,140,160,25,8,22,208,101,236,120,97,40,107,149,74,163,224,1,27,91,182,236,153,199,30,123,252,225,63,253,117,201,146,165,5,193,102,118,255,198,
155,252,83,179,84,97,112,184,107,13,85,225,192,101,7,194,113,225,153,226,205,37,207,95,38,32,41,93,166,169,93,126,25,40,45,232,158,26,115,12,147,83,45,212,68,167,248,237,125,203,98,247,2,136,148,232,195,
65,22,239,249,96,22,54,119,198,149,36,243,105,248,25,173,132,165,114,238,18,82,114,32,49,151,32,181,96,164,224,60,104,21,56,23,169,80,73,29,170,84,174,22,54,68,68,143,122,97,6,162,148,46,149,144,32,12,
10,242,165,174,72,206,53,12,120,94,49,205,134,6,82,57,137,216,233,186,246,170,59,50,164,241,61,26,28,107,83,19,140,255,202,130,43,32,26,89,247,121,43,154,151,210,6,156,158,240,119,117,201,213,52,95,202,
83,181,22,28,123,226,31,84,180,199,5,47,113,173,65,228,181,23,152,64,11,31,132,91,32,91,51,90,28,192,188,117,124,17,55,214,12,45,94,54,6,237,104,19,114,191,87,15,210,89,10,75,125,197,87,141,145,232,106,
107,43,121,35,195,61,118,147,120,156,122,225,184,151,54,162,178,83,145,37,228,122,201,24,25,192,25,228,8,161,176,77,33,35,137,141,228,115,141,212,40,45,49,153,190,82,91,37,247,220,242,148,37,7,204,184,
50,137,130,217,224,79,22,223,185,145,3,15,185,210,8,22,195,71,145,218,229,136,131,110,154,129,2,167,7,21,231,141,77,175,119,169,0,31,177,205,192,102,211,185,108,4,45,237,94,28,117,200,24,75,107,201,74,
159,211,199,57,183,37,152,238,215,4,51,5,42,131,169,36,83,207,43,121,90,179,207,189,106,147,147,130,179,67,230,56,170,12,102,200,56,39,149,64,177,164,154,7,0,50,120,122,4,103,187,61,51,133,74,227,241,
178,213,167,168,212,72,70,93,102,248,171,13,41,91,51,221,136,17,130,179,156,114,140,99,210,108,47,9,149,103,73,184,6,86,18,40,14,27,162,70,23,93,122,172,212,72,26,204,212,40,39,95,50,31,160,74,195,189,
42,28,77,251,155,83,15,104,198,15,58,42,132,131,189,116,242,105,77,120,76,80,58,152,136,93,74,17,200,92,163,123,49,8,128,117,38,209,140,124,206,13,90,227,148,52,83,127,24,205,224,179,60,91,137,108,9,144,
35,160,101,20,107,132,53,166,192,24,117,52,13,66,214,97,168,27,49,1,92,126,98,96,0,15,146,2,166,154,132,61,123,134,196,213,172,137,98,73,205,74,55,230,49,59,57,146,195,134,184,210,72,100,173,71,224,122,
236,98,104,234,166,71,167,93,168,191,63,59,109,242,34,61,124,234,216,243,238,245,0,214,187,40,239,126,185,48,179,88,189,122,168,163,51,128,233,222,98,4,164,153,26,205,38,191,198,150,236,15,130,153,37,
82,67,70,44,43,32,59,121,246,40,11,149,26,199,24,144,17,178,224,112,192,36,42,139,22,51,237,25,88,9,25,224,165,174,18,223,36,196,52,235,180,116,161,47,143,183,58,4,103,172,81,192,184,84,53,181,117,102,
21,124,72,241,179,131,45,111,165,39,174,184,84,240,36,2,27,29,205,148,212,120,171,147,188,120,15,66,247,10,95,64,101,212,10,71,171,107,102,150,214,224,57,129,48,4,181,233,172,81,167,30,228,5,77,43,10,
211,16,198,13,86,41,41,66,184,212,101,96,117,51,107,66,11,24,58,236,204,178,129,173,68,38,88,35,82,211,12,33,104,252,54,99,168,6,180,208,21,108,65,160,157,57,147,174,2,112,197,214,194,218,150,208,165,
125,79,4,74,248,44,192,248,233,4,60,92,220,119,250,153,233,240,114,231,179,20,90,201,225,49,240,245,222,212,152,144,49,224,67,165,38,10,109,157,193,141,15,90,183,100,61,168,232,209,37,210,61,110,5,113,
201,108,95,193,139,8,250,161,148,228,21,28,74,186,192,232,185,87,71,213,20,76,61,120,206,29,226,141,77,171,132,150,5,204,110,72,182,219,147,117,131,211,94,87,36,101,3,27,255,69,192,240,123,109,106,252,
8,83,182,99,211,70,236,201,98,209,92,140,18,121,18,119,165,173,158,132,83,245,60,71,194,199,120,115,223,48,180,117,25,105,241,153,49,91,89,0,151,223,177,176,87,123,91,2,62,6,162,228,39,160,150,223,85,
242,71,37,141,154,222,231,44,120,234,76,86,44,203,36,240,220,75,143,46,233,143,16,140,135,34,228,93,5,67,228,179,104,162,33,68,166,164,82,159,177,164,12,136,38,136,52,11,164,42,87,206,156,104,234,135,
17,208,128,41,221,198,68,170,213,204,49,1,66,33,137,209,152,182,110,167,8,108,53,193,209,206,88,16,221,215,142,78,17,216,79,227,109,59,176,74,74,99,106,90,131,200,118,12,123,53,186,147,96,217,141,18,136,
6,100,58,43,57,182,88,178,80,198,162,32,215,8,139,76,172,27,78,2,228,186,1,11,200,120,23,76,33,12,148,110,138,76,108,165,161,21,182,2,95,53,52,174,120,237,150,224,44,166,189,98,128,70,245,84,197,91,174,
62,43,228,248,138,118,61,108,52,174,0,99,134,86,186,187,25,1,227,129,107,214,89,100,64,220,141,202,229,48,171,24,152,218,153,196,141,124,73,149,45,151,250,25,112,117,245,212,54,226,116,104,249,20,205,
112,178,225,25,153,60,160,113,64,116,146,128,185,39,13,48,130,117,104,209,137,91,138,147,112,216,249,8,71,220,88,78,34,27,157,119,160,173,197,44,72,149,142,80,47,74,158,138,21,157,58,97,138,22,56,200,
131,222,142,169,140,8,151,136,30,84,106,130,2,186,79,145,24,210,200,218,73,45,160,101,132,175,9,51,63,21,28,33,4,65,8,81,23,25,16,105,175,136,101,136,220,152,52,8,26,92,35,24,49,221,133,201,83,52,206,
163,190,76,2,185,191,14,80,33,24,49,113,207,240,121,2,167,199,21,48,140,140,233,77,5,236,44,16,18,201,214,87,174,133,27,152,198,144,200,136,183,169,45,237,76,170,158,255,209,233,186,44,139,77,16,222,105,
109,35,245,64,107,228,105,191,99,228,237,122,43,121,93,199,53,14,136,164,9,88,167,73,100,152,144,46,168,164,104,6,7,42,34,47,56,164,24,87,19,238,74,117,69,165,68,36,224,153,146,199,230,52,66,189,33,9,
202,29,149,163,69,118,34,69,191,45,2,114,156,255,72,56,8,5,170,81,128,69,147,24,43,132,172,58,11,167,93,18,84,48,175,168,84,190,222,52,122,75,94,9,106,138,169,57,172,94,242,22,32,90,88,48,219,16,245,145,
50,194,24,192,235,97,27,1,179,233,42,105,149,248,236,67,169,23,161,105,43,37,177,52,144,146,100,54,87,218,132,217,28,41,78,202,97,21,6,25,44,197,83,99,67,76,10,180,16,210,213,146,240,86,168,100,160,28,
105,45,124,119,150,155,99,6,215,104,61,65,101,45,122,87,45,170,22,214,116,37,231,163,136,212,226,72,163,46,215,200,224,128,159,64,209,17,168,9,74,192,5,211,77,178,138,79,41,181,26,154,236,73,214,116,226,
100,229,64,34,44,254,136,135,53,68,73,24,252,116,187,148,132,5,191,81,64,36,123,37,158,59,228,108,158,147,36,195,255,52,63,96,138,159,76,24,25,233,165,240,107,13,69,146,36,221,227,203,129,219,137,84,18,
133,181,146,115,201,130,192,17,133,99,2,236,201,203,94,117,7,233,18,70,114,65,1,49,152,48,178,184,89,166,118,215,128,80,87,156,142,42,17,46,120,247,211,175,90,187,64,199,8,44,84,255,156,150,248,153,241,
167,96,36,101,143,77,87,42,84,164,158,11,65,143,128,212,58,56,2,149,237,5,115,12,38,36,51,162,30,129,16,55,83,124,75,135,97,136,23,187,128,163,134,56,36,229,37,62,88,211,34,81,75,20,181,114,158,7,164,
130,51,65,96,133,82,18,99,22,181,24,66,86,218,49,179,131,33,139,99,152,236,73,141,63,86,62,190,30,202,30,85,50,38,195,99,72,169,87,209,254,24,7,210,28,32,246,102,153,248,186,74,163,124,106,165,226,52,
197,168,61,103,21,154,165,194,158,49,9,57,195,49,77,235,1,27,246,9,178,189,170,157,29,10,232,111,192,143,14,182,209,100,86,176,107,16,210,174,52,17,25,31,154,178,41,166,35,34,214,146,90,47,22,249,188,
155,85,228,206,6,89,199,177,45,251,242,89,69,20,2,194,130,105,92,161,2,122,45,150,100,197,70,4,131,239,116,51,217,102,156,156,112,21,64,174,43,143,3,133,76,20,21,140,255,144,148,198,65,249,238,252,103,
105,164,177,116,179,209,28,170,142,171,17,65,11,231,192,150,139,215,104,189,132,30,20,145,213,22,249,12,242,9,162,201,112,141,100,162,234,15,213,222,129,106,240,251,102,70,30,44,63,12,228,228,172,38,195,
189,57,147,183,71,220,124,140,222,19,114,74,22,152,246,32,131,214,182,147,142,228,234,227,116,64,108,216,66,121,27,250,179,36,147,102,199,72,234,102,42,12,19,96,106,25,109,180,37,45,176,140,147,207,102,
19,86,170,37,176,172,42,101,212,120,107,20,197,142,22,211,180,8,196,248,153,202,5,73,81,172,8,53,38,4,199,137,233,86,76,199,42,97,132,180,24,30,21,144,32,180,87,113,154,146,25,137,34,246,204,182,36,33,
189,202,11,80,73,177,196,23,69,38,196,1,195,55,205,150,104,70,107,69,53,145,213,224,128,108,154,44,122,97,123,5,245,172,86,45,83,182,169,151,106,24,183,16,75,84,194,168,246,32,99,250,76,99,87,241,102,
99,76,61,209,134,237,29,127,150,102,32,30,25,89,80,13,33,116,253,72,170,199,201,247,22,162,53,194,98,87,8,113,9,132,17,230,174,44,83,107,101,20,83,103,32,164,178,95,66,110,99,139,204,149,102,169,140,155,
24,98,54,41,74,145,22,86,19,33,99,130,31,32,17,128,26,40,81,41,97,215,232,178,138,32,52,74,26,19,69,249,194,22,73,229,219,12,140,84,11,110,100,21,217,189,172,124,99,151,9,237,121,108,106,255,101,211,192,
31,51,36,192,209,146,43,202,225,49,96,26,21,108,154,154,173,83,242,211,128,64,76,199,206,90,169,140,65,19,1,227,0,243,255,23,82,197,184,146,243,251,16,24,0,0,0,0,73,69,78,68,174,66,96,130,0,0};

const char* ChaosChimpMainEditor::background_png = (const char*) resource_ChaosChimpMainEditor_background_png;
const int ChaosChimpMainEditor::background_pngSize = 46255;


//[EndFile] You can add extra defines here...
//[/EndFile]
