/*
  ==============================================================================

  This is an automatically generated GUI class created by the Introjucer!

  Be careful when adding custom code to these files, as only the code within
  the "//[xyz]" and "//[/xyz]" sections will be retained when the file is loaded
  and re-saved.

  Created with Introjucer version: 3.1.0

  ------------------------------------------------------------------------------

  The Introjucer is part of the JUCE library - "Jules' Utility Class Extensions"
  Copyright 2004-13 by Raw Material Software Ltd.

  ==============================================================================
*/

//[Headers] You can add your own extra header files here...
/*
 * Copyright (c) 2013 - Teragon Audio LLC
 *
 * Permission is granted to use this software under the terms of either:
 * a) the GPL v2 (or any later version)
 * b) the Affero GPL v3
 *
 * Details of these licenses can be found at: www.gnu.org/licenses
 *
 * This software is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * ------------------------------------------------------------------------------
 *
 * This software uses the JUCE library.
 *
 * To release a closed-source product which uses JUCE, commercial licenses are
 * available: visit www.juce.com for more information.
 */
//[/Headers]

#include "PluginEditor.h"


//[MiscUserDefs] You can add your own user definitions and misc code here...
using namespace teragon;
//[/MiscUserDefs]

//==============================================================================
PluginEditor::PluginEditor (AudioProcessor *owner, teragon::ConcurrentParameterSet &p, teragon::ResourceCache *r)
    : AudioProcessorEditor(owner),
      parameters(p),
      resources(r)
{
    addAndMakeVisible (frequencyKnob = new teragon::ImageKnobLarge (parameters,
                                                                    "Frequency",
                                                                    resources));
    frequencyKnob->setName ("frequency knob");

    addAndMakeVisible (resonanceKnob = new teragon::ImageKnobSmall (parameters,
                                                                    "Resonance",
                                                                    resources));
    resonanceKnob->setName ("resonance knob");

    addAndMakeVisible (valleySizeKnob = new teragon::ImageKnobSmall (parameters,
                                                                     "Valley Size",
                                                                     resources));
    valleySizeKnob->setName ("valley size knob");

    addAndMakeVisible (statusBar = new teragon::StatusBar (parameters,
                                                           resources));
    statusBar->setName ("status bar");

    addAndMakeVisible (versionLabel = new teragon::ParameterLabel (parameters,
                                                                   "Version"));
    versionLabel->setName ("version label");

    cachedImage_background_png = ImageCache::getFromMemory (background_png, background_pngSize);

    //[UserPreSize]
    //[/UserPreSize]

    setSize (351, 203);


    //[Constructor] You can add your own custom stuff here..
    statusBar->subscribeToParameters();

    versionLabel->setFont(StatusBar::getFont());
    versionLabel.get()->setJustificationType(Justification::centredRight);
    //[/Constructor]
}

PluginEditor::~PluginEditor()
{
    //[Destructor_pre]. You can add your own custom destruction code here..
    //[/Destructor_pre]

    frequencyKnob = nullptr;
    resonanceKnob = nullptr;
    valleySizeKnob = nullptr;
    statusBar = nullptr;
    versionLabel = nullptr;


    //[Destructor]. You can add your own custom destruction code here..
    delete resources;
    //[/Destructor]
}

//==============================================================================
void PluginEditor::paint (Graphics& g)
{
    //[UserPrePaint] Add your own custom painting code here..
    //[/UserPrePaint]

    g.fillAll (Colours::white);

    g.setColour (Colours::black);
    g.drawImage (cachedImage_background_png,
                 0, 0, 351, 203,
                 0, 0, cachedImage_background_png.getWidth(), cachedImage_background_png.getHeight());

    //[UserPaint] Add your own custom painting code here..
    //[/UserPaint]
}

void PluginEditor::resized()
{
    frequencyKnob->setBounds (119, 11, 113, 113);
    resonanceKnob->setBounds (17, 33, 66, 66);
    valleySizeKnob->setBounds (269, 33, 66, 66);
    statusBar->setBounds (24, 155, 150, 30);
    versionLabel->setBounds (136, 169, 188, 16);
    //[UserResized] Add your own custom resize handling here..
    //[/UserResized]
}



//[MiscUserCode] You can add your own definitions of your custom methods or any other code here...
//[/MiscUserCode]


//==============================================================================
#if 0
/*  -- Introjucer information section --

    This is where the Introjucer stores the metadata that describe this GUI layout, so
    make changes in here at your peril!

BEGIN_JUCER_METADATA

<JUCER_COMPONENT documentType="Component" className="PluginEditor" componentName=""
                 parentClasses="public AudioProcessorEditor" constructorParams="AudioProcessor *owner, teragon::ConcurrentParameterSet &amp;p, teragon::ResourceCache *r"
                 variableInitialisers="AudioProcessorEditor(owner),&#10;parameters(p),&#10;resources(r)"
                 snapPixels="8" snapActive="1" snapShown="1" overlayOpacity="0.330"
                 fixedSize="1" initialWidth="351" initialHeight="203">
  <BACKGROUND backgroundColour="ffffffff">
    <IMAGE pos="0 0 351 203" resource="background_png" opacity="1" mode="0"/>
  </BACKGROUND>
  <GENERICCOMPONENT name="frequency knob" id="cbc3f5c5fff9e09b" memberName="frequencyKnob"
                    virtualName="teragon::ImageKnobLarge" explicitFocusOrder="0"
                    pos="119 11 113 113" class="Component" params="parameters,&#10;&quot;Frequency&quot;,&#10;resources"/>
  <GENERICCOMPONENT name="resonance knob" id="13c569138892eb13" memberName="resonanceKnob"
                    virtualName="teragon::ImageKnobSmall" explicitFocusOrder="0"
                    pos="17 33 66 66" class="Component" params="parameters,&#10;&quot;Resonance&quot;,&#10;resources"/>
  <GENERICCOMPONENT name="valley size knob" id="1f8ba387e5cceed1" memberName="valleySizeKnob"
                    virtualName="teragon::ImageKnobSmall" explicitFocusOrder="0"
                    pos="269 33 66 66" class="Component" params="parameters,&#10;&quot;Valley Size&quot;,&#10;resources"/>
  <GENERICCOMPONENT name="status bar" id="2340b7bd80c9851c" memberName="statusBar"
                    virtualName="teragon::StatusBar" explicitFocusOrder="0" pos="24 155 150 30"
                    class="Component" params="parameters,&#10;resources"/>
  <GENERICCOMPONENT name="version label" id="1d7a11a128d30f53" memberName="versionLabel"
                    virtualName="teragon::ParameterLabel" explicitFocusOrder="0"
                    pos="136 169 188 16" class="Component" params="parameters,&#10;&quot;Version&quot;"/>
</JUCER_COMPONENT>

END_JUCER_METADATA
*/
#endif

//==============================================================================
// Binary resources - be careful not to edit any of these sections!

// JUCER_RESOURCE: background_png, 33581, "../Graphics/background.png"
static const unsigned char resource_PluginEditor_background_png[] = { 137,80,78,71,13,10,26,10,0,0,0,13,73,72,68,82,0,0,1,95,0,0,0,203,8,2,0,0,0,70,87,7,55,0,0,10,65,105,67,67,80,73,67,67,32,80,114,111,
102,105,108,101,0,0,72,13,157,150,119,84,83,217,22,135,207,189,55,189,208,18,34,32,37,244,26,122,9,32,210,59,72,21,4,81,137,73,128,80,2,134,132,38,118,68,5,70,20,17,41,86,100,84,192,1,71,135,34,99,69,
20,11,131,130,98,215,9,242,16,80,198,193,81,68,69,229,221,140,107,9,239,173,53,243,222,154,253,199,89,223,217,231,183,215,217,103,239,125,215,186,0,80,252,130,4,194,116,88,1,128,52,161,88,20,238,235,193,
92,18,19,203,196,247,2,24,16,1,14,88,1,192,225,102,102,4,71,248,68,2,212,252,189,61,153,153,168,72,198,179,246,238,46,128,100,187,219,44,191,80,38,115,214,255,127,145,34,55,67,36,6,0,10,69,213,54,60,126,
38,23,229,2,148,83,179,197,25,50,255,4,202,244,149,41,50,134,49,50,22,161,9,162,172,34,227,196,175,108,246,167,230,43,187,201,152,151,38,228,161,26,89,206,25,188,52,158,140,187,80,222,154,37,225,163,140,
4,161,92,152,37,224,103,163,124,7,101,189,84,73,154,0,229,247,40,211,211,248,156,76,0,48,20,153,95,204,231,38,161,108,137,50,69,20,25,238,137,242,2,0,8,148,196,57,188,114,14,139,249,57,104,158,0,120,166,
103,228,138,4,137,73,98,166,17,215,152,105,229,232,200,102,250,241,179,83,249,98,49,43,148,195,77,225,136,120,76,207,244,180,12,142,48,23,128,175,111,150,69,1,37,89,109,153,104,145,237,173,28,237,237,
89,214,230,104,249,191,217,223,30,126,83,253,61,200,122,251,85,241,38,236,207,158,65,140,158,89,223,108,236,172,47,189,22,0,246,36,90,155,29,179,190,149,85,0,180,109,6,64,229,225,172,79,239,32,0,242,5,
0,180,222,156,243,30,134,108,94,146,196,226,12,39,11,139,236,236,108,115,1,159,107,46,43,232,55,251,159,130,111,202,191,134,57,247,153,203,238,251,86,59,166,23,63,129,35,73,21,51,101,69,229,166,167,166,
75,68,204,204,12,14,151,207,100,253,247,16,255,227,192,57,105,205,201,195,44,156,159,192,23,241,133,232,85,81,232,148,9,132,137,104,187,133,60,129,88,144,46,100,10,132,127,213,225,127,24,54,39,7,25,126,
157,107,20,104,117,95,0,125,133,57,80,184,73,7,200,111,61,0,67,35,3,36,110,63,122,2,125,235,91,16,49,10,200,190,188,104,173,145,175,115,143,50,122,254,231,250,31,11,92,138,110,225,76,65,34,83,230,246,
12,143,100,114,37,162,44,25,163,223,132,108,193,2,18,144,7,116,160,10,52,129,46,48,2,44,96,13,28,128,51,112,3,222,32,0,132,128,72,16,3,150,3,46,72,2,105,64,4,178,65,62,216,0,10,65,49,216,1,118,131,106,
112,0,212,129,122,208,4,78,130,54,112,6,92,4,87,192,13,112,11,12,128,71,64,10,134,193,75,48,1,222,129,105,8,130,240,16,21,162,65,170,144,22,164,15,153,66,214,16,27,90,8,121,67,65,80,56,20,3,197,67,137,
144,16,146,64,249,208,38,168,24,42,131,170,161,67,80,61,244,35,116,26,186,8,93,131,250,160,7,208,32,52,6,253,1,125,132,17,152,2,211,97,13,216,0,182,128,217,176,59,28,8,71,194,203,224,68,120,21,156,7,23,
192,219,225,74,184,22,62,14,183,194,23,225,27,240,0,44,133,95,194,147,8,64,200,8,3,209,70,88,8,27,241,68,66,144,88,36,1,17,33,107,145,34,164,2,169,69,154,144,14,164,27,185,141,72,145,113,228,3,6,135,161,
97,152,24,22,198,25,227,135,89,140,225,98,86,97,214,98,74,48,213,152,99,152,86,76,23,230,54,102,16,51,129,249,130,165,98,213,177,166,88,39,172,63,118,9,54,17,155,141,45,196,86,96,143,96,91,176,151,177,
3,216,97,236,59,28,14,199,192,25,226,28,112,126,184,24,92,50,110,53,174,4,183,15,215,140,187,128,235,195,13,225,38,241,120,188,42,222,20,239,130,15,193,115,240,98,124,33,190,10,127,28,127,30,223,143,31,
198,191,39,144,9,90,4,107,130,15,33,150,32,36,108,36,84,16,26,8,231,8,253,132,17,194,52,81,129,168,79,116,34,134,16,121,196,92,98,41,177,142,216,65,188,73,28,38,78,147,20,73,134,36,23,82,36,41,153,180,
129,84,73,106,34,93,38,61,38,189,33,147,201,58,100,71,114,24,89,64,94,79,174,36,159,32,95,37,15,146,63,80,148,40,38,20,79,74,28,69,66,217,78,57,74,185,64,121,64,121,67,165,82,13,168,110,212,88,170,152,
186,157,90,79,189,68,125,74,125,47,71,147,51,151,243,151,227,201,173,147,171,145,107,149,235,151,123,37,79,148,215,151,119,151,95,46,159,39,95,33,127,74,254,166,252,184,2,81,193,64,193,83,129,163,176,
86,161,70,225,180,194,61,133,73,69,154,162,149,98,136,98,154,98,137,98,131,226,53,197,81,37,188,146,129,146,183,18,79,169,64,233,176,210,37,165,33,26,66,211,165,121,210,184,180,77,180,58,218,101,218,48,
29,71,55,164,251,211,147,233,197,244,31,232,189,244,9,101,37,101,91,229,40,229,28,229,26,229,179,202,82,6,194,48,96,248,51,82,25,165,140,147,140,187,140,143,243,52,230,185,207,227,207,219,54,175,105,94,
255,188,41,149,249,42,110,42,124,149,34,149,102,149,1,149,143,170,76,85,111,213,20,213,157,170,109,170,79,212,48,106,38,106,97,106,217,106,251,213,46,171,141,207,167,207,119,158,207,157,95,52,255,228,
252,135,234,176,186,137,122,184,250,106,245,195,234,61,234,147,26,154,26,190,26,25,26,85,26,151,52,198,53,25,154,110,154,201,154,229,154,231,52,199,180,104,90,11,181,4,90,229,90,231,181,94,48,149,153,
238,204,84,102,37,179,139,57,161,173,174,237,167,45,209,62,164,221,171,61,173,99,168,179,88,103,163,78,179,206,19,93,146,46,91,55,65,183,92,183,83,119,66,79,75,47,88,47,95,175,81,239,161,62,81,159,173,
159,164,191,71,191,91,127,202,192,208,32,218,96,139,65,155,193,168,161,138,161,191,97,158,97,163,225,99,35,170,145,171,209,42,163,90,163,59,198,56,99,182,113,138,241,62,227,91,38,176,137,157,73,146,73,
141,201,77,83,216,212,222,84,96,186,207,180,207,12,107,230,104,38,52,171,53,187,199,162,176,220,89,89,172,70,214,160,57,195,60,200,124,163,121,155,249,43,11,61,139,88,139,157,22,221,22,95,44,237,44,83,
45,235,44,31,89,41,89,5,88,109,180,234,176,250,195,218,196,154,107,93,99,125,199,134,106,227,99,179,206,166,221,230,181,173,169,45,223,118,191,237,125,59,154,93,176,221,22,187,78,187,207,246,14,246,34,
251,38,251,49,7,61,135,120,135,189,14,247,216,116,118,40,187,132,125,213,17,235,232,225,184,206,241,140,227,7,39,123,39,177,211,73,167,223,157,89,206,41,206,13,206,163,11,12,23,240,23,212,45,24,114,209,
113,225,184,28,114,145,46,100,46,140,95,120,112,161,212,85,219,149,227,90,235,250,204,77,215,141,231,118,196,109,196,221,216,61,217,253,184,251,43,15,75,15,145,71,139,199,148,167,147,231,26,207,11,94,
136,151,175,87,145,87,175,183,146,247,98,239,106,239,167,62,58,62,137,62,141,62,19,190,118,190,171,125,47,248,97,253,2,253,118,250,221,243,215,240,231,250,215,251,79,4,56,4,172,9,232,10,164,4,70,4,86,
7,62,11,50,9,18,5,117,4,195,193,1,193,187,130,31,47,210,95,36,92,212,22,2,66,252,67,118,133,60,9,53,12,93,21,250,115,24,46,44,52,172,38,236,121,184,85,120,126,120,119,4,45,98,69,68,67,196,187,72,143,200,
210,200,71,139,141,22,75,22,119,70,201,71,197,69,213,71,77,69,123,69,151,69,75,151,88,44,89,179,228,70,140,90,140,32,166,61,22,31,27,21,123,36,118,114,169,247,210,221,75,135,227,236,226,10,227,238,46,
51,92,150,179,236,218,114,181,229,169,203,207,174,144,95,193,89,113,42,30,27,31,29,223,16,255,137,19,194,169,229,76,174,244,95,185,119,229,4,215,147,187,135,251,146,231,198,43,231,141,241,93,248,101,252,
145,4,151,132,178,132,209,68,151,196,93,137,99,73,174,73,21,73,227,2,79,65,181,224,117,178,95,242,129,228,169,148,144,148,163,41,51,169,209,169,205,105,132,180,248,180,211,66,37,97,138,176,43,93,51,61,
39,189,47,195,52,163,48,67,186,202,105,213,238,85,19,162,64,209,145,76,40,115,89,102,187,152,142,254,76,245,72,140,36,155,37,131,89,11,179,106,178,222,103,71,101,159,202,81,204,17,230,244,228,154,228,
110,203,29,201,243,201,251,126,53,102,53,119,117,103,190,118,254,134,252,193,53,238,107,14,173,133,214,174,92,219,185,78,119,93,193,186,225,245,190,235,143,109,32,109,72,217,240,203,70,203,141,101,27,
223,110,138,222,212,81,160,81,176,190,96,104,179,239,230,198,66,185,66,81,225,189,45,206,91,14,108,197,108,21,108,237,221,102,179,173,106,219,151,34,94,209,245,98,203,226,138,226,79,37,220,146,235,223,
89,125,87,249,221,204,246,132,237,189,165,246,165,251,119,224,118,8,119,220,221,233,186,243,88,153,98,89,94,217,208,174,224,93,173,229,204,242,162,242,183,187,87,236,190,86,97,91,113,96,15,105,143,100,
143,180,50,168,178,189,74,175,106,71,213,167,234,164,234,129,26,143,154,230,189,234,123,183,237,157,218,199,219,215,191,223,109,127,211,1,141,3,197,7,62,30,20,28,188,127,200,247,80,107,173,65,109,197,
97,220,225,172,195,207,235,162,234,186,191,103,127,95,127,68,237,72,241,145,207,71,133,71,165,199,194,143,117,213,59,212,215,55,168,55,148,54,194,141,146,198,177,227,113,199,111,253,224,245,67,123,19,
171,233,80,51,163,185,248,4,56,33,57,241,226,199,248,31,239,158,12,60,217,121,138,125,170,233,39,253,159,246,182,208,90,138,90,161,214,220,214,137,182,164,54,105,123,76,123,223,233,128,211,157,29,206,
29,45,63,155,255,124,244,140,246,153,154,179,202,103,75,207,145,206,21,156,155,57,159,119,126,242,66,198,133,241,139,137,23,135,58,87,116,62,186,180,228,210,157,174,176,174,222,203,129,151,175,94,241,
185,114,169,219,189,251,252,85,151,171,103,174,57,93,59,125,157,125,189,237,134,253,141,214,30,187,158,150,95,236,126,105,233,181,239,109,189,233,112,179,253,150,227,173,142,190,5,125,231,250,93,251,47,
222,246,186,125,229,142,255,157,27,3,139,6,250,238,46,190,123,255,94,220,61,233,125,222,253,209,7,169,15,94,63,204,122,56,253,104,253,99,236,227,162,39,10,79,42,158,170,63,173,253,213,248,215,102,169,
189,244,236,160,215,96,207,179,136,103,143,134,184,67,47,255,149,249,175,79,195,5,207,169,207,43,70,180,70,234,71,173,71,207,140,249,140,221,122,177,244,197,240,203,140,151,211,227,133,191,41,254,182,
247,149,209,171,159,126,119,251,189,103,98,201,196,240,107,209,235,153,63,74,222,168,190,57,250,214,246,109,231,100,232,228,211,119,105,239,166,167,138,222,171,190,63,246,129,253,161,251,99,244,199,145,
233,236,79,248,79,149,159,141,63,119,124,9,252,242,120,38,109,102,230,223,247,132,243,251,50,58,89,126,0,0,0,9,112,72,89,115,0,0,11,19,0,0,11,19,1,0,154,156,24,0,0,4,222,105,84,88,116,88,77,76,58,99,111,
109,46,97,100,111,98,101,46,120,109,112,0,0,0,0,0,60,120,58,120,109,112,109,101,116,97,32,120,109,108,110,115,58,120,61,34,97,100,111,98,101,58,110,115,58,109,101,116,97,47,34,32,120,58,120,109,112,116,
107,61,34,88,77,80,32,67,111,114,101,32,53,46,49,46,50,34,62,10,32,32,32,60,114,100,102,58,82,68,70,32,120,109,108,110,115,58,114,100,102,61,34,104,116,116,112,58,47,47,119,119,119,46,119,51,46,111,114,
103,47,49,57,57,57,47,48,50,47,50,50,45,114,100,102,45,115,121,110,116,97,120,45,110,115,35,34,62,10,32,32,32,32,32,32,60,114,100,102,58,68,101,115,99,114,105,112,116,105,111,110,32,114,100,102,58,97,
98,111,117,116,61,34,34,10,32,32,32,32,32,32,32,32,32,32,32,32,120,109,108,110,115,58,116,105,102,102,61,34,104,116,116,112,58,47,47,110,115,46,97,100,111,98,101,46,99,111,109,47,116,105,102,102,47,49,
46,48,47,34,62,10,32,32,32,32,32,32,32,32,32,60,116,105,102,102,58,82,101,115,111,108,117,116,105,111,110,85,110,105,116,62,49,60,47,116,105,102,102,58,82,101,115,111,108,117,116,105,111,110,85,110,105,
116,62,10,32,32,32,32,32,32,32,32,32,60,116,105,102,102,58,67,111,109,112,114,101,115,115,105,111,110,62,53,60,47,116,105,102,102,58,67,111,109,112,114,101,115,115,105,111,110,62,10,32,32,32,32,32,32,
32,32,32,60,116,105,102,102,58,88,82,101,115,111,108,117,116,105,111,110,62,55,50,60,47,116,105,102,102,58,88,82,101,115,111,108,117,116,105,111,110,62,10,32,32,32,32,32,32,32,32,32,60,116,105,102,102,
58,79,114,105,101,110,116,97,116,105,111,110,62,49,60,47,116,105,102,102,58,79,114,105,101,110,116,97,116,105,111,110,62,10,32,32,32,32,32,32,32,32,32,60,116,105,102,102,58,89,82,101,115,111,108,117,116,
105,111,110,62,55,50,60,47,116,105,102,102,58,89,82,101,115,111,108,117,116,105,111,110,62,10,32,32,32,32,32,32,60,47,114,100,102,58,68,101,115,99,114,105,112,116,105,111,110,62,10,32,32,32,32,32,32,60,
114,100,102,58,68,101,115,99,114,105,112,116,105,111,110,32,114,100,102,58,97,98,111,117,116,61,34,34,10,32,32,32,32,32,32,32,32,32,32,32,32,120,109,108,110,115,58,101,120,105,102,61,34,104,116,116,112,
58,47,47,110,115,46,97,100,111,98,101,46,99,111,109,47,101,120,105,102,47,49,46,48,47,34,62,10,32,32,32,32,32,32,32,32,32,60,101,120,105,102,58,80,105,120,101,108,88,68,105,109,101,110,115,105,111,110,
62,51,53,49,60,47,101,120,105,102,58,80,105,120,101,108,88,68,105,109,101,110,115,105,111,110,62,10,32,32,32,32,32,32,32,32,32,60,101,120,105,102,58,67,111,108,111,114,83,112,97,99,101,62,49,60,47,101,
120,105,102,58,67,111,108,111,114,83,112,97,99,101,62,10,32,32,32,32,32,32,32,32,32,60,101,120,105,102,58,80,105,120,101,108,89,68,105,109,101,110,115,105,111,110,62,50,48,51,60,47,101,120,105,102,58,
80,105,120,101,108,89,68,105,109,101,110,115,105,111,110,62,10,32,32,32,32,32,32,60,47,114,100,102,58,68,101,115,99,114,105,112,116,105,111,110,62,10,32,32,32,32,32,32,60,114,100,102,58,68,101,115,99,
114,105,112,116,105,111,110,32,114,100,102,58,97,98,111,117,116,61,34,34,10,32,32,32,32,32,32,32,32,32,32,32,32,120,109,108,110,115,58,100,99,61,34,104,116,116,112,58,47,47,112,117,114,108,46,111,114,
103,47,100,99,47,101,108,101,109,101,110,116,115,47,49,46,49,47,34,62,10,32,32,32,32,32,32,32,32,32,60,100,99,58,115,117,98,106,101,99,116,62,10,32,32,32,32,32,32,32,32,32,32,32,32,60,114,100,102,58,66,
97,103,47,62,10,32,32,32,32,32,32,32,32,32,60,47,100,99,58,115,117,98,106,101,99,116,62,10,32,32,32,32,32,32,60,47,114,100,102,58,68,101,115,99,114,105,112,116,105,111,110,62,10,32,32,32,32,32,32,60,114,
100,102,58,68,101,115,99,114,105,112,116,105,111,110,32,114,100,102,58,97,98,111,117,116,61,34,34,10,32,32,32,32,32,32,32,32,32,32,32,32,120,109,108,110,115,58,120,109,112,61,34,104,116,116,112,58,47,
47,110,115,46,97,100,111,98,101,46,99,111,109,47,120,97,112,47,49,46,48,47,34,62,10,32,32,32,32,32,32,32,32,32,60,120,109,112,58,77,111,100,105,102,121,68,97,116,101,62,50,48,49,51,45,49,50,45,50,51,84,
49,56,58,49,50,58,50,51,60,47,120,109,112,58,77,111,100,105,102,121,68,97,116,101,62,10,32,32,32,32,32,32,32,32,32,60,120,109,112,58,67,114,101,97,116,111,114,84,111,111,108,62,80,105,120,101,108,109,
97,116,111,114,32,51,46,48,60,47,120,109,112,58,67,114,101,97,116,111,114,84,111,111,108,62,10,32,32,32,32,32,32,60,47,114,100,102,58,68,101,115,99,114,105,112,116,105,111,110,62,10,32,32,32,60,47,114,
100,102,58,82,68,70,62,10,60,47,120,58,120,109,112,109,101,116,97,62,10,154,70,221,78,0,0,64,0,73,68,65,84,120,1,236,189,7,220,109,69,117,54,126,43,92,164,11,210,4,69,148,98,1,27,88,81,105,162,128,45,
177,155,216,18,99,47,137,249,98,71,141,154,226,23,77,162,209,104,140,81,140,26,99,69,164,9,130,128,168,8,22,162,81,177,35,69,138,72,239,112,203,247,204,172,61,107,158,89,179,102,246,62,239,125,81,255,
191,255,57,188,156,179,102,205,179,158,181,102,77,217,179,247,217,251,220,165,123,221,103,239,37,213,107,221,218,117,149,46,40,150,46,91,170,122,136,138,106,225,21,60,69,96,114,224,93,78,131,17,90,23,
217,247,88,243,44,128,164,239,226,183,80,107,90,81,55,193,0,56,36,6,79,132,5,243,117,52,48,150,230,193,128,26,67,194,252,236,215,149,217,118,38,67,151,109,80,114,168,80,149,209,6,5,13,102,49,129,235,90,
137,170,133,133,228,82,137,163,206,123,203,151,178,181,0,129,211,52,185,227,70,170,150,46,85,218,96,29,231,51,107,86,172,91,179,182,78,92,139,150,35,91,211,2,45,84,159,201,235,70,166,174,13,24,212,166,
226,66,93,229,254,214,92,64,200,1,44,152,183,50,84,254,170,198,42,250,222,91,60,133,21,231,45,166,72,107,107,115,213,0,163,48,27,83,85,94,186,124,153,234,90,86,45,189,24,170,95,229,81,161,111,168,176,
137,2,135,234,154,184,238,84,201,113,170,172,181,205,121,72,35,51,131,217,61,247,17,235,85,38,6,213,193,221,186,53,206,176,215,192,18,178,88,175,147,210,255,148,181,81,15,240,0,129,13,49,115,216,43,144,
68,46,251,76,73,171,209,76,55,73,166,147,63,105,242,187,238,102,10,120,212,107,209,144,78,207,185,125,214,97,79,84,161,83,241,154,213,188,98,46,226,148,218,228,34,99,217,139,212,38,77,109,174,185,21,193,
2,106,242,232,102,221,218,236,205,72,150,193,84,167,226,56,204,184,78,77,72,4,83,63,199,29,149,219,7,197,107,102,58,158,120,233,113,55,209,32,81,66,230,97,67,214,171,172,86,101,24,121,218,43,0,38,225,
208,222,122,141,229,109,252,232,190,110,221,10,118,214,114,164,250,26,92,182,65,129,89,96,19,23,204,0,152,113,250,76,149,144,178,114,10,97,14,165,43,69,170,220,7,140,229,238,103,61,203,28,21,244,220,10,
20,77,45,27,46,88,22,23,102,119,28,182,86,114,56,144,193,129,153,214,24,37,253,144,76,252,26,100,223,74,97,211,5,175,7,139,94,152,232,209,227,201,81,56,36,113,13,26,214,238,12,12,146,171,12,21,148,73,
38,116,167,217,0,224,149,46,154,179,97,224,172,95,201,100,74,24,173,110,2,171,56,50,105,25,247,78,241,128,124,5,21,131,104,232,76,45,138,198,129,41,214,120,222,131,21,13,166,92,179,149,75,88,71,37,48,
23,28,216,82,138,153,57,200,13,167,193,130,247,88,165,153,219,253,37,196,150,2,27,199,208,246,91,88,178,73,81,209,140,156,163,134,83,36,170,204,149,127,4,51,220,69,49,198,80,244,148,84,79,105,194,236,
241,119,210,94,68,53,86,200,60,38,134,70,216,24,250,217,196,35,47,211,24,16,14,222,248,2,168,116,199,179,23,230,134,211,33,4,1,157,187,121,113,21,97,184,12,108,85,108,46,202,216,24,102,229,52,6,86,152,
136,13,110,212,61,240,125,6,212,27,78,41,78,97,86,195,153,192,33,164,70,138,167,243,72,163,44,190,30,13,193,153,223,64,142,193,242,104,195,32,48,167,71,229,71,226,14,214,134,146,189,169,108,122,77,35,
228,176,21,28,194,172,6,183,212,170,33,138,45,91,49,23,124,209,222,65,69,31,94,6,168,218,23,203,182,12,221,81,159,87,195,88,163,85,65,24,133,129,55,137,6,224,58,174,219,107,172,250,69,151,211,152,212,
152,178,177,117,125,110,35,234,56,194,98,165,48,118,101,218,213,106,182,51,139,204,41,99,58,146,154,246,112,244,166,42,155,139,52,54,49,44,126,114,121,196,111,228,225,56,161,48,38,90,100,24,14,204,18,
2,31,177,71,131,82,42,23,169,61,33,228,184,42,228,195,26,231,177,46,120,138,178,21,85,75,15,78,84,113,54,106,164,213,208,32,209,144,180,189,170,97,161,96,104,164,34,227,83,119,20,86,169,186,181,227,227,
38,36,236,240,185,70,46,18,161,212,114,157,60,2,82,243,184,97,24,23,147,138,174,247,228,90,188,136,119,199,99,105,155,247,128,248,122,162,60,100,242,57,169,140,103,101,211,117,196,158,89,76,138,62,173,
73,202,50,88,197,6,168,15,135,170,12,93,142,186,205,118,214,246,198,92,1,41,113,170,104,10,96,72,224,94,156,100,207,176,53,100,78,144,74,108,197,105,128,101,186,214,44,241,215,5,99,148,139,226,37,53,39,
235,33,185,1,148,200,122,112,23,12,169,192,205,15,196,179,172,139,50,28,141,9,138,181,107,131,17,231,60,154,117,40,179,127,99,165,180,70,159,154,50,124,246,107,107,215,108,206,182,44,51,6,242,196,72,6,
95,218,182,88,6,45,55,92,153,141,59,83,84,152,107,139,90,224,141,73,107,245,4,88,73,22,184,58,136,39,101,145,224,140,123,141,88,5,131,159,104,213,55,71,237,16,76,153,101,213,139,121,234,48,255,44,192,
128,197,164,126,71,252,163,109,132,21,55,19,65,153,133,57,211,78,92,107,178,65,33,137,23,55,30,14,64,109,12,210,20,21,230,175,44,90,93,46,49,170,118,133,166,139,10,141,222,201,224,180,180,241,113,175,
51,148,149,44,51,168,106,161,66,139,42,141,34,135,151,77,88,118,160,165,170,6,215,26,181,24,13,160,99,171,36,44,48,161,218,170,208,188,238,160,8,230,50,178,143,105,31,211,50,62,141,0,67,216,47,230,225,
2,220,216,48,205,190,34,169,20,57,23,234,203,32,85,95,11,19,145,12,195,176,22,167,242,174,139,69,36,111,46,85,236,154,217,166,232,129,169,77,224,125,98,219,221,149,133,253,178,156,29,117,58,84,123,42,
97,234,175,69,203,240,108,90,178,151,228,219,109,75,170,12,159,181,9,215,14,114,138,199,169,210,152,203,186,73,180,106,210,225,87,140,43,36,239,139,220,204,68,203,62,135,22,185,161,46,93,26,174,59,184,
65,176,114,166,164,116,142,105,26,150,25,130,45,126,142,65,109,69,40,76,98,219,138,181,131,209,148,148,194,138,49,183,157,44,247,177,36,126,123,12,164,216,0,145,246,46,86,144,38,123,62,109,53,44,114,26,
203,216,134,61,133,81,166,118,153,14,77,234,240,169,126,21,163,26,133,213,26,173,114,133,89,241,46,137,198,131,90,217,119,98,151,55,48,107,90,26,237,117,9,179,82,204,187,182,220,59,234,61,51,120,210,204,
173,70,24,116,185,193,49,175,154,201,81,1,31,206,44,28,51,47,184,137,186,41,108,140,65,64,28,147,122,1,166,184,174,209,206,53,119,179,154,171,192,190,236,182,57,113,186,1,40,131,8,5,79,170,235,24,10,126,
134,216,60,78,215,169,0,197,117,7,224,84,233,104,72,190,234,45,152,182,200,152,75,67,140,82,105,90,122,5,64,112,48,117,60,108,96,228,212,89,70,189,224,34,199,163,171,118,106,254,176,127,97,12,28,165,90,
199,39,35,251,157,46,198,140,87,239,161,170,147,147,148,129,78,24,101,100,246,222,199,178,182,56,5,150,42,142,10,154,21,78,52,41,8,84,155,56,140,177,113,54,169,88,53,62,31,172,216,126,184,3,60,111,50,
197,181,137,135,45,32,143,134,103,186,77,241,42,24,194,209,162,26,154,192,84,63,8,220,106,74,175,225,87,43,163,119,139,46,216,132,81,25,230,124,86,85,131,194,165,69,93,75,223,226,153,162,111,117,135,216,
154,182,204,26,192,136,57,247,200,224,47,36,199,122,41,97,124,78,100,248,77,209,52,223,210,154,106,41,138,175,52,60,148,48,219,2,16,107,179,198,229,81,101,25,124,80,39,114,129,20,60,53,24,171,131,233,
33,152,177,13,203,194,184,158,239,181,59,151,16,126,213,181,164,73,147,37,120,173,117,205,161,52,120,104,152,179,101,53,232,77,166,202,156,170,173,186,24,101,118,91,205,77,80,42,37,103,129,145,172,175,
229,233,200,218,118,138,70,227,92,20,71,134,4,228,172,41,118,142,8,110,66,47,112,19,152,138,245,34,215,61,82,227,99,99,139,245,52,99,202,19,198,129,191,17,97,168,53,35,106,48,160,15,58,5,32,109,16,53,
231,16,115,0,6,228,21,167,180,81,237,106,48,170,154,247,59,80,76,202,96,133,145,88,189,140,248,59,5,38,110,167,120,196,29,147,148,107,92,89,83,148,26,205,108,140,137,194,180,88,70,203,26,42,197,36,12,
173,94,164,166,17,251,162,137,141,60,52,219,200,248,162,95,188,78,111,77,108,19,61,120,152,22,147,129,1,236,165,132,13,40,81,50,140,205,141,60,5,214,193,184,115,9,120,55,176,232,122,104,139,92,98,208,
96,248,14,11,222,152,40,96,125,132,58,30,63,69,237,33,218,252,70,83,83,163,13,86,77,17,177,59,26,4,209,158,12,168,87,218,130,141,10,234,46,8,174,151,46,63,49,149,98,73,53,58,111,75,227,153,75,60,140,180,
69,35,44,101,132,22,92,181,154,51,57,213,69,149,255,137,134,246,120,46,193,81,72,220,94,141,220,146,183,27,232,31,60,136,95,56,133,144,27,14,189,245,162,238,61,1,182,51,225,13,71,203,22,250,22,179,68,
203,247,107,128,147,154,48,115,60,100,107,162,27,41,154,8,185,203,76,187,210,234,192,29,86,118,134,49,48,158,153,218,84,245,139,66,235,182,176,246,216,241,82,131,93,191,228,168,56,34,9,120,132,132,147,
163,236,101,150,84,109,132,17,102,131,142,69,52,86,173,52,108,209,152,126,21,107,5,123,100,133,78,217,10,109,44,116,170,4,60,4,16,239,183,179,30,145,159,148,13,91,85,121,138,142,114,23,232,237,167,32,
192,110,189,130,7,133,153,81,46,102,86,229,104,156,134,112,98,126,96,197,204,198,138,171,148,95,48,110,149,98,92,97,1,38,179,242,12,171,67,103,250,129,177,19,135,84,153,44,104,16,142,97,57,2,194,177,34,
13,44,181,170,5,135,167,6,37,141,9,70,108,103,98,72,76,195,39,79,215,92,69,83,34,43,141,196,141,157,208,76,177,70,168,166,9,208,171,70,132,137,205,81,43,19,151,22,13,143,75,46,74,166,98,57,82,165,227,
30,183,87,124,148,173,174,12,151,172,233,60,131,172,81,38,161,54,79,53,254,16,85,124,209,76,19,100,25,161,18,26,193,237,148,130,214,24,196,226,40,0,168,41,24,143,123,170,206,79,194,52,235,97,117,8,33,
154,172,137,61,229,78,221,72,13,183,138,229,190,223,122,25,170,109,141,163,62,97,167,86,153,167,19,170,73,166,109,252,240,70,88,212,70,51,70,119,182,59,204,217,135,149,102,2,91,99,42,207,202,227,226,93,
37,57,201,98,171,115,235,252,79,231,204,236,52,145,12,97,193,70,157,82,156,167,164,145,108,130,132,173,97,115,61,66,25,188,16,121,134,37,230,172,153,85,2,173,71,98,2,43,154,57,217,69,97,229,198,47,84,
94,0,233,204,2,71,39,26,202,234,154,169,89,86,128,35,112,4,149,203,41,36,1,35,36,165,185,73,150,184,158,74,232,4,58,73,213,75,75,25,222,64,71,61,61,30,155,215,204,73,97,253,254,129,184,119,76,195,181,
168,24,21,164,29,10,232,55,203,88,1,12,67,40,85,31,138,222,48,22,100,203,151,227,157,199,48,204,82,71,187,228,246,90,76,2,139,187,41,239,160,117,98,160,213,112,10,201,20,140,27,191,24,186,1,228,213,33,
100,54,93,81,45,160,141,76,249,209,208,220,0,155,242,8,179,22,125,91,210,74,51,56,36,84,78,55,39,166,66,212,6,170,182,197,169,1,187,128,154,71,9,49,148,92,147,1,80,37,19,84,61,60,241,246,68,67,171,208,
217,71,170,154,206,42,76,105,197,20,76,225,87,219,21,27,226,154,179,178,238,23,174,45,152,187,5,51,139,148,68,5,182,110,129,51,166,108,69,214,39,201,165,77,149,24,247,229,229,152,245,232,211,17,71,217,
229,32,229,213,1,10,215,120,188,241,68,202,96,102,99,153,224,249,116,154,149,28,201,96,200,9,250,173,100,167,21,176,196,137,90,93,62,76,228,253,34,231,71,169,250,38,83,106,107,218,133,147,115,170,193,
50,37,219,198,100,162,213,132,134,105,187,250,221,161,76,19,97,138,111,9,218,191,2,168,23,157,150,33,244,30,120,184,10,219,12,15,9,108,231,89,147,32,78,77,108,117,36,77,47,17,234,133,23,42,92,171,116,
175,100,59,56,187,113,210,112,60,147,209,208,213,90,132,22,30,109,224,112,57,65,172,207,108,245,0,69,157,68,232,86,137,165,215,132,204,89,73,117,102,107,77,101,212,83,248,109,233,89,248,117,53,143,4,102,
210,232,27,151,90,78,53,106,106,230,18,30,74,198,100,162,85,205,195,26,147,88,45,218,120,76,231,206,216,161,236,49,203,145,115,134,175,186,53,6,215,187,214,170,131,26,6,13,96,181,62,154,216,38,79,236,
148,116,30,160,110,133,167,102,83,64,45,12,247,74,118,108,234,190,23,22,54,145,206,91,128,123,80,49,79,29,95,208,184,247,165,49,180,113,159,153,48,215,241,103,143,117,207,41,45,117,149,14,205,16,203,109,
241,245,154,58,93,60,193,143,211,109,47,181,116,97,13,44,124,185,46,192,91,122,153,169,161,61,254,68,203,35,208,146,183,66,18,92,98,8,49,14,51,42,127,225,90,184,6,194,165,82,134,126,173,134,85,195,226,
0,182,190,20,207,66,109,203,181,26,201,34,13,212,230,189,146,234,116,74,208,83,48,74,56,171,128,233,205,252,169,11,51,13,106,25,144,43,162,84,87,17,67,24,7,24,18,245,148,103,43,150,13,57,23,137,150,213,
131,60,145,196,177,108,168,250,238,196,200,56,53,153,4,6,36,6,211,240,150,213,125,19,94,139,57,177,179,122,113,241,177,201,121,234,230,152,146,164,57,97,115,14,9,64,174,74,118,195,167,84,41,9,180,44,71,
80,207,187,222,187,33,116,245,160,26,220,148,247,128,138,178,19,85,178,10,159,166,45,92,5,217,146,180,150,18,90,68,12,131,41,22,215,29,66,157,97,156,76,228,216,66,53,197,92,61,54,192,104,51,119,146,77,
65,112,60,195,139,169,196,44,223,205,58,3,77,130,106,240,200,92,251,222,13,56,21,191,19,131,215,32,125,124,116,186,128,27,111,57,147,194,108,79,27,27,93,128,214,106,72,70,78,137,112,62,101,122,216,38,
80,198,28,27,163,42,227,177,84,6,76,69,142,150,212,97,254,104,213,192,38,241,148,142,212,100,186,71,152,20,143,90,10,133,219,88,242,165,193,168,80,120,172,204,185,211,213,68,163,133,134,205,91,75,9,99,
212,54,8,198,29,126,223,161,242,81,172,142,77,34,143,171,142,166,103,158,226,82,171,14,88,171,16,173,6,172,202,196,228,127,42,222,84,79,52,55,86,92,140,204,147,210,53,171,175,38,158,135,114,213,151,28,
91,75,86,230,148,150,34,126,88,41,192,48,180,244,6,214,47,214,25,147,189,60,214,145,116,224,45,252,20,133,68,13,18,87,207,131,219,189,211,65,8,212,150,51,160,74,96,88,78,62,23,248,137,177,173,108,201,
93,193,175,181,174,3,157,26,117,45,12,251,182,48,17,128,235,183,38,132,166,118,87,237,29,162,157,227,216,140,197,64,150,39,42,74,83,194,141,220,246,205,241,101,33,185,236,128,189,192,178,65,202,17,107,
22,71,30,189,26,2,55,116,148,152,234,180,219,156,178,255,138,137,237,100,134,92,234,16,33,221,32,246,13,107,252,68,77,199,35,51,96,93,144,0,166,255,172,102,43,224,50,57,217,73,11,239,232,235,228,11,205,
44,253,200,13,135,11,45,58,238,114,140,190,180,0,19,94,34,133,180,88,40,125,63,81,187,212,89,115,227,191,148,87,219,84,233,112,83,191,144,232,107,95,93,141,38,87,81,214,105,25,42,240,22,80,238,138,235,
90,101,158,73,112,19,2,134,130,223,29,109,101,192,226,84,154,9,219,154,86,8,199,243,160,209,123,78,253,33,82,69,82,123,81,86,22,138,54,114,5,201,22,99,162,170,92,147,105,20,13,94,170,91,86,17,220,57,179,
107,146,151,132,117,242,217,208,182,72,234,224,186,36,49,48,83,132,145,246,53,147,47,68,238,166,72,188,12,151,89,75,118,115,65,100,136,176,106,8,24,26,223,89,84,208,186,145,165,199,226,188,212,84,105,
177,73,82,183,51,101,188,105,146,72,205,128,118,241,174,50,17,204,254,25,163,109,205,55,142,39,237,150,139,171,158,110,48,170,84,193,132,5,61,51,163,86,139,198,132,135,120,28,28,121,139,129,221,40,211,
26,67,84,169,70,201,25,191,62,50,71,197,142,90,156,6,47,48,123,149,68,180,244,141,213,228,248,115,78,76,0,202,96,244,173,34,226,236,152,112,26,21,22,132,178,35,2,121,26,240,45,71,181,222,164,72,207,209,
4,41,185,202,151,66,136,159,163,10,158,135,37,100,200,9,199,57,124,103,145,16,26,131,115,4,14,117,237,86,41,169,82,76,23,76,59,217,176,71,219,153,165,160,104,167,195,114,214,141,42,205,57,158,80,211,184,
87,23,85,96,102,242,240,11,247,252,162,144,88,93,203,85,119,4,8,51,215,38,170,97,88,28,28,49,6,137,100,114,0,32,113,99,16,47,168,98,47,234,186,35,76,194,83,186,134,197,183,12,184,149,121,75,222,57,233,
43,9,59,1,79,172,42,22,172,138,60,4,70,141,26,56,105,57,83,47,210,132,58,231,182,105,106,80,141,135,97,33,80,119,41,24,225,108,241,131,175,227,98,184,238,208,65,80,60,206,196,152,104,200,36,131,76,205,
88,24,73,107,172,8,63,115,178,44,181,101,55,56,71,146,218,68,155,208,169,82,204,224,165,92,71,166,27,54,145,154,52,246,148,198,1,235,140,44,185,106,210,26,116,44,206,4,22,130,50,171,153,116,34,85,221,
161,198,208,20,179,3,72,156,153,42,33,26,24,51,168,50,88,155,221,118,65,109,11,98,40,38,28,179,75,194,0,33,194,130,146,55,158,101,168,53,3,7,57,37,206,218,157,56,85,158,218,133,109,30,149,211,85,73,78,
46,85,27,49,183,10,21,101,195,12,82,138,26,147,169,69,136,218,140,153,194,101,158,158,161,52,167,29,97,207,150,125,76,151,189,4,154,239,159,120,84,77,39,102,164,38,141,149,83,218,50,5,163,157,213,2,43,
128,189,79,145,39,26,182,252,78,114,81,46,196,198,196,101,86,37,194,155,41,66,53,132,23,150,141,83,41,214,0,238,68,212,178,235,26,92,107,92,47,170,156,21,175,134,174,160,223,104,230,227,231,148,43,25,
224,154,18,7,48,220,120,141,64,149,53,137,84,213,122,181,157,34,72,7,184,36,234,122,98,19,24,175,174,45,51,150,134,114,37,170,91,97,77,148,171,22,188,133,38,160,202,171,202,110,96,53,153,129,117,194,64,
149,128,235,224,133,86,109,13,39,106,181,170,14,160,208,152,166,149,73,83,100,205,63,209,69,63,12,67,171,96,21,52,0,95,224,224,27,145,59,134,108,21,171,249,152,1,197,84,239,209,182,213,4,199,239,4,149,
97,171,45,156,123,37,243,149,140,26,222,209,84,89,16,172,201,69,135,32,225,203,115,117,54,16,23,19,58,166,147,241,78,21,187,82,121,10,158,143,6,69,43,234,156,140,5,31,59,108,88,169,229,162,166,94,74,52,
145,152,162,6,108,132,137,176,34,108,67,145,138,136,77,216,12,39,244,173,113,86,32,145,13,211,252,70,126,10,171,228,189,255,41,38,110,24,202,166,2,83,213,38,46,12,38,220,203,45,12,51,139,204,86,162,25,
108,235,182,15,6,233,56,237,1,102,157,77,3,37,29,240,57,114,150,5,105,222,211,83,88,80,155,158,51,192,177,98,157,5,88,32,170,214,9,93,17,153,151,8,199,97,29,97,203,144,144,117,247,27,230,34,18,83,55,173,
216,98,168,115,34,200,209,144,196,109,107,93,8,181,166,225,212,222,105,33,47,4,213,106,102,75,111,124,112,54,210,112,93,22,49,153,32,75,198,120,90,113,48,55,201,129,109,157,159,132,41,78,150,187,94,50,
178,102,107,27,182,90,132,108,212,85,24,24,170,228,116,41,189,214,170,166,24,9,141,192,28,171,108,223,147,86,228,196,33,95,21,59,143,227,190,15,183,22,219,16,102,208,64,12,216,77,132,130,85,24,172,164,
95,99,168,45,67,230,103,89,169,110,19,161,74,96,203,117,75,223,140,42,13,229,12,168,110,69,203,85,158,196,189,224,123,175,93,8,79,53,36,60,250,113,29,7,0,180,28,51,214,173,93,219,183,84,43,63,230,134,
113,61,42,212,92,9,49,48,27,214,142,218,28,228,192,70,60,1,175,252,142,113,67,85,147,24,158,137,156,220,216,194,164,213,161,110,60,141,94,214,235,14,48,202,235,150,46,72,121,189,52,164,46,29,7,148,0,110,
22,12,89,209,42,83,71,197,212,37,161,95,197,164,248,62,137,144,131,152,98,168,107,68,35,132,19,189,183,72,84,143,126,90,44,42,229,132,16,131,244,135,114,223,29,183,46,35,189,62,10,94,26,87,245,178,33,
199,52,187,188,48,30,199,10,241,143,117,171,99,149,2,54,85,105,68,141,76,239,250,92,91,121,148,33,121,72,159,146,231,110,168,74,146,108,232,147,187,73,213,30,91,139,132,59,52,237,212,148,40,8,188,169,
55,36,218,40,231,186,3,44,153,186,160,76,5,67,39,106,182,98,192,200,28,78,156,249,211,203,2,106,153,179,246,152,205,147,84,227,83,205,240,233,3,220,142,49,150,94,132,62,91,50,212,140,247,97,9,158,63,103,
197,195,82,125,137,204,12,205,62,226,193,162,206,91,169,168,155,63,29,169,228,125,161,67,216,169,234,115,86,181,156,25,83,201,57,52,85,117,145,193,194,41,121,238,240,215,36,89,131,6,86,25,134,11,151,141,
93,103,134,82,242,159,51,116,211,24,253,170,35,186,238,32,140,101,117,233,101,164,164,164,6,199,35,210,84,185,197,130,199,109,67,50,155,122,145,166,75,146,200,210,103,204,128,36,93,23,93,51,119,138,8,
147,93,254,244,220,53,119,97,217,172,148,170,241,81,86,247,74,157,240,58,85,53,99,115,136,75,3,41,194,86,23,207,228,142,3,80,66,102,72,51,161,183,147,74,24,38,43,100,38,44,42,202,194,68,88,105,148,75,
214,220,27,18,25,45,82,202,167,155,246,214,33,54,140,171,100,104,9,187,101,205,48,163,76,216,246,95,202,51,213,108,185,96,121,125,56,221,54,104,36,19,153,251,36,46,155,116,198,154,89,243,94,78,155,209,
145,170,174,107,97,98,211,106,195,17,77,61,76,169,141,38,96,137,193,40,35,127,62,185,19,119,139,30,173,18,178,119,85,118,218,56,5,211,49,31,170,218,89,226,120,12,79,199,245,148,17,168,230,34,84,142,252,
53,17,49,168,161,198,163,182,117,149,98,66,149,105,102,53,18,252,51,11,165,88,52,193,196,1,94,10,165,227,69,155,39,13,214,98,199,164,110,179,181,170,131,17,58,10,73,186,147,13,167,4,96,6,1,155,231,128,
107,239,228,55,195,90,82,109,174,72,225,233,0,128,236,250,146,128,117,108,169,224,54,68,107,213,63,4,23,201,0,43,247,163,13,132,214,98,134,178,146,87,173,70,240,126,168,98,82,225,117,80,21,123,192,26,
214,8,206,247,229,129,53,171,211,77,106,26,216,10,143,223,76,74,139,186,3,9,123,20,57,222,43,169,232,218,79,173,241,50,194,62,140,133,184,49,211,198,132,82,152,104,48,165,35,14,157,241,158,235,98,149,
173,13,235,96,148,80,193,195,70,174,140,1,176,218,157,154,160,150,101,229,28,132,70,187,66,173,86,89,155,84,166,48,70,131,103,128,158,25,129,200,156,28,37,106,39,230,186,21,117,171,97,94,195,198,27,162,
94,85,72,77,131,11,243,213,128,66,68,96,119,117,60,92,59,24,34,171,137,188,8,44,42,29,124,52,227,236,149,1,20,131,170,14,169,4,87,165,126,23,107,156,110,86,43,178,41,138,86,3,97,203,109,236,192,128,148,
239,44,134,150,199,219,111,138,155,145,234,33,197,116,117,39,213,113,11,134,173,24,227,49,12,193,180,76,216,28,242,68,24,91,117,76,40,158,16,6,35,89,102,54,150,201,156,213,65,70,110,235,100,38,144,51,
242,80,229,122,132,178,229,5,122,212,178,85,125,177,61,121,140,159,60,100,105,128,14,24,170,157,120,114,203,195,174,112,52,161,128,176,71,162,37,18,110,163,170,171,180,112,86,89,14,22,46,67,71,175,94,
68,16,95,149,71,131,226,162,13,128,235,114,48,154,243,186,59,216,96,253,228,236,110,140,39,61,103,17,113,24,90,83,44,59,73,153,98,206,33,41,190,195,201,248,32,107,6,185,98,145,178,41,241,204,16,76,181,
155,208,22,113,116,144,167,15,125,53,212,48,50,103,108,123,177,185,5,122,74,219,27,73,115,92,36,247,238,84,207,145,36,24,127,246,107,25,121,91,200,235,235,221,164,168,155,213,245,245,133,246,27,119,146,
145,232,20,157,50,145,95,187,79,243,57,209,48,224,221,0,148,40,10,197,234,0,141,248,235,251,232,215,150,252,83,75,61,78,211,140,110,183,13,254,140,73,104,88,111,241,54,81,74,48,72,133,102,191,19,94,167,
42,184,229,205,189,113,19,139,29,243,186,106,1,51,86,124,186,134,168,170,93,104,140,185,74,147,57,75,14,149,103,209,4,13,163,102,92,140,192,76,138,114,243,107,119,235,169,137,13,81,119,58,64,116,107,41,
174,235,145,83,135,84,107,166,135,166,1,116,76,242,85,73,142,70,100,235,91,186,167,234,9,54,236,120,178,108,213,204,169,1,194,54,165,25,234,87,72,106,147,65,175,93,161,6,165,192,49,176,220,92,104,171,
108,148,124,121,250,153,44,21,228,100,99,96,84,19,196,150,149,129,213,197,5,27,134,134,107,27,205,252,84,125,244,199,145,79,117,103,8,37,238,146,54,183,165,210,171,71,215,157,214,42,131,11,211,90,35,168,
185,181,154,41,102,67,26,139,50,56,195,133,173,216,162,214,166,210,250,245,168,214,71,55,133,127,216,59,52,115,33,254,37,35,210,61,85,118,58,39,165,74,11,26,150,77,171,250,129,186,181,202,230,214,6,101,
21,39,156,230,61,57,15,181,26,201,181,49,214,122,185,145,38,184,222,53,182,224,49,29,17,84,8,134,181,71,161,43,159,194,20,221,2,223,213,69,217,22,55,182,142,139,178,225,197,254,171,104,17,181,180,195,
102,170,74,242,161,210,208,170,73,29,121,190,5,160,108,163,152,56,60,154,19,37,133,144,108,29,60,106,141,137,247,195,45,1,149,122,121,32,54,86,131,118,240,37,96,180,29,66,221,40,197,186,2,227,1,176,126,
93,155,81,101,43,218,116,85,114,132,160,236,197,98,136,12,33,54,28,248,179,177,242,102,218,204,245,173,246,183,244,106,91,198,172,234,65,96,243,22,146,49,44,91,174,106,225,155,0,182,57,20,206,190,97,237,
183,163,105,53,138,77,36,237,125,167,69,109,163,151,117,130,49,249,20,89,200,181,247,11,95,149,61,106,21,153,132,156,70,107,91,135,218,152,216,149,31,163,200,46,76,5,23,83,60,195,116,229,228,107,96,192,
168,44,182,181,38,232,189,200,213,151,97,80,158,96,103,86,40,181,25,19,56,90,197,10,91,62,179,208,138,90,232,59,142,169,25,73,162,50,104,30,225,69,149,131,32,121,73,107,121,29,134,171,97,66,1,8,155,146,
187,86,172,204,135,32,214,66,174,35,169,123,46,154,184,187,39,191,239,169,213,198,27,23,185,81,211,27,194,12,11,179,114,134,38,72,83,30,220,97,132,250,133,248,162,76,14,135,144,228,37,56,156,229,4,144,
91,157,227,39,182,1,160,63,39,87,87,69,132,235,116,33,77,43,19,162,180,46,149,214,82,43,236,84,114,13,9,31,242,15,30,67,53,106,5,6,99,162,156,66,136,162,189,42,169,136,66,160,190,44,244,49,209,163,113,
76,12,93,6,223,40,91,17,64,217,19,166,106,98,113,134,65,95,14,44,180,75,162,85,129,61,230,134,180,178,39,232,146,83,116,217,150,25,215,67,110,141,3,80,178,47,55,21,10,80,33,79,66,9,137,154,208,114,148,
109,131,203,112,45,195,32,25,192,178,211,232,58,159,41,0,55,254,196,48,204,186,14,121,167,42,145,76,248,44,195,107,109,159,23,199,87,10,71,217,52,171,42,36,200,240,169,72,148,89,174,97,96,176,171,67,77,
10,138,86,210,59,236,236,44,192,52,101,169,35,25,32,178,101,83,19,134,182,205,25,53,147,108,253,86,198,117,78,20,130,42,152,251,187,143,20,106,43,123,66,50,234,157,125,169,204,194,20,134,81,76,171,141,
214,80,58,37,53,141,195,16,217,226,107,4,14,89,241,121,80,65,170,95,21,70,121,216,124,160,79,67,165,53,21,189,40,172,110,74,228,214,198,43,215,221,61,48,35,200,50,111,189,38,167,22,13,30,74,67,199,109,
194,231,12,212,32,37,73,224,26,194,17,34,108,123,85,82,13,56,89,44,43,96,38,65,83,230,82,73,154,76,149,154,176,35,127,30,50,98,186,172,201,98,19,47,113,33,227,46,56,26,198,224,195,113,201,196,175,11,34,
223,11,108,6,4,172,234,182,215,152,34,192,133,158,94,50,73,45,219,224,107,68,212,184,157,130,154,194,188,206,97,153,61,6,179,220,240,153,212,137,86,38,64,25,73,200,25,39,102,6,218,212,5,201,205,248,103,
159,220,212,34,178,212,161,246,186,131,65,178,227,178,117,101,122,19,46,209,134,50,156,136,154,147,144,128,195,167,186,51,228,12,83,140,40,135,103,52,121,4,51,122,177,100,227,213,208,214,181,220,114,5,
3,214,105,152,194,38,10,181,83,24,182,248,93,176,56,210,170,42,102,103,43,171,224,78,144,6,99,104,181,104,96,3,97,154,66,67,49,13,26,199,157,65,10,162,131,7,64,79,221,187,224,58,135,126,168,145,80,152,
134,247,174,119,208,50,143,57,78,56,223,11,50,155,219,216,228,251,54,29,252,28,115,114,24,62,181,31,89,169,96,21,184,214,200,140,145,230,187,156,176,98,100,93,52,180,92,108,252,107,55,12,89,44,185,238,
161,212,127,110,171,76,147,36,10,87,217,9,176,102,238,51,244,107,59,142,80,53,140,215,212,168,62,88,206,189,71,48,177,122,166,144,204,204,84,219,58,15,24,159,181,119,197,215,85,208,180,200,13,88,73,196,
169,22,13,204,39,172,7,137,152,197,239,122,203,86,132,248,245,152,9,89,127,104,79,44,216,175,137,92,0,238,59,91,185,128,160,116,131,156,216,239,137,116,146,35,245,53,141,124,42,103,140,161,76,102,10,171,
252,156,244,157,69,105,146,75,163,14,138,112,203,22,194,86,151,255,230,201,18,153,24,95,5,115,142,168,144,140,137,212,169,114,10,67,65,55,86,144,33,56,145,22,96,7,89,15,59,202,192,136,255,104,235,100,
50,50,56,190,26,116,154,31,83,15,134,233,36,98,91,227,59,228,98,210,204,161,180,174,122,94,115,226,191,190,89,68,82,39,25,190,167,231,185,90,37,103,109,44,240,69,60,98,223,120,215,132,180,82,55,19,91,
118,50,109,27,104,175,74,102,251,9,82,175,145,117,31,80,7,160,169,176,149,150,119,252,48,63,203,19,23,239,194,164,227,198,171,234,116,134,7,15,253,61,234,78,90,45,230,46,184,78,72,134,213,249,4,17,167,
180,243,211,111,174,109,221,12,111,29,225,152,107,139,25,52,49,134,214,226,165,60,210,94,47,249,97,167,144,179,161,6,73,240,76,82,93,252,84,219,58,201,168,215,218,194,166,81,208,163,154,173,167,238,176,
85,198,5,247,200,20,43,51,153,153,189,107,238,207,20,152,27,43,137,199,40,195,55,154,28,40,123,173,41,76,109,183,232,246,129,90,72,103,132,119,246,94,5,167,120,35,184,228,185,131,153,19,150,147,105,131,
151,100,59,140,227,153,108,77,148,85,49,71,88,85,137,162,3,24,105,50,15,190,212,4,117,226,218,106,109,118,45,134,101,147,37,164,122,238,117,66,53,204,67,49,209,78,89,110,102,35,143,97,59,235,142,27,199,
236,119,163,214,109,199,144,114,185,77,216,166,168,38,145,48,51,180,96,138,135,208,233,65,99,94,69,155,29,49,97,37,231,197,151,25,236,111,67,177,153,113,204,85,142,204,131,114,114,31,112,179,199,221,37,
23,121,40,164,49,135,120,168,85,19,51,226,28,49,56,30,112,142,135,228,36,162,161,74,193,59,213,212,10,167,54,170,220,72,180,201,92,107,154,0,107,174,109,241,71,170,60,68,12,108,10,131,49,209,117,118,208,
83,27,53,108,84,45,132,185,244,36,237,93,127,158,146,53,151,38,50,163,81,220,174,108,159,36,229,81,33,213,140,127,90,147,214,88,154,60,239,58,46,217,151,119,221,129,125,83,167,118,24,81,197,131,146,29,
136,149,36,174,214,215,154,142,23,118,193,48,33,153,66,101,250,207,20,133,115,10,15,123,159,40,107,240,122,31,96,254,45,80,36,220,203,179,9,175,14,172,214,212,193,56,24,238,223,100,176,232,123,37,109,
111,242,48,44,4,97,91,238,53,86,97,166,213,162,183,173,208,38,164,249,160,86,154,94,49,12,219,211,206,183,124,234,85,9,85,195,66,25,176,250,98,102,150,217,116,84,22,54,107,94,199,67,49,212,185,21,47,150,
4,218,46,79,176,170,1,194,21,221,241,47,214,139,26,239,197,177,183,118,169,217,81,3,8,53,44,16,149,125,165,69,3,86,125,159,208,88,49,216,105,36,101,83,145,61,6,128,76,166,74,6,13,114,132,68,157,149,130,
90,229,127,152,59,241,163,179,181,150,141,6,165,68,149,192,12,112,101,151,138,145,173,177,5,204,168,45,243,244,229,154,42,37,208,126,237,111,120,106,67,3,64,81,155,160,96,21,204,87,155,112,154,252,214,
52,131,6,182,74,40,170,160,161,161,171,228,90,219,228,154,86,193,228,98,1,13,123,49,241,0,195,181,38,60,245,105,72,160,175,121,12,149,11,80,194,226,170,36,71,160,136,90,40,96,102,70,149,232,137,223,36,
11,161,73,153,20,71,124,165,57,83,55,146,13,13,51,199,88,192,202,11,123,92,5,19,83,100,146,154,191,7,46,189,12,204,157,52,166,54,178,199,133,200,201,133,187,77,144,38,56,57,159,197,83,63,15,156,19,70,
178,126,162,183,233,38,19,145,5,12,137,194,150,4,123,28,126,153,94,72,201,100,200,32,27,100,137,224,134,151,53,225,80,170,97,168,80,99,160,65,109,11,96,240,163,176,0,168,219,146,154,80,172,14,134,122,
74,177,158,150,108,53,26,156,3,230,88,83,148,2,171,125,41,191,10,76,56,200,173,235,189,37,57,192,66,226,247,31,71,5,104,105,219,243,94,5,228,130,235,166,25,59,215,202,233,87,99,70,113,26,23,134,208,20,
153,198,79,72,68,24,43,83,100,18,35,91,36,210,75,161,26,112,81,228,142,152,104,82,216,151,5,102,211,154,225,25,144,222,14,90,146,169,173,224,137,173,52,174,160,38,90,203,233,21,185,198,40,120,168,226,
176,167,37,129,189,24,54,51,48,180,22,130,119,221,129,235,107,153,35,195,140,194,93,198,120,77,11,177,38,179,26,144,71,42,55,77,157,172,133,16,104,43,40,180,130,111,53,222,176,193,92,52,70,47,84,53,137,
11,179,205,153,92,182,71,170,137,134,244,44,19,90,175,231,215,18,155,182,72,200,252,128,203,222,44,220,166,62,245,13,11,168,83,208,238,152,98,142,244,6,152,6,147,92,215,188,220,17,204,172,238,106,147,
174,166,88,2,20,201,204,170,100,65,0,236,148,229,26,201,26,35,143,250,50,120,20,53,9,220,233,10,203,132,154,79,157,167,10,34,33,95,227,39,165,136,141,189,3,241,90,19,183,231,4,95,86,181,242,101,9,99,121,
72,119,218,117,231,22,186,104,79,217,50,105,233,13,71,31,54,204,222,178,129,202,208,105,105,159,54,51,164,134,171,6,130,177,117,189,40,134,207,183,5,169,85,174,161,240,235,56,171,221,229,185,202,49,25,
121,246,132,100,90,178,149,80,53,24,141,60,131,147,223,112,174,234,13,78,62,135,213,246,102,158,104,174,122,33,51,181,162,4,198,213,135,90,227,55,93,16,21,195,153,222,53,146,166,175,46,157,90,113,167,
215,22,154,207,186,138,53,122,84,53,71,23,96,26,171,3,245,28,19,137,172,109,163,170,152,211,50,125,97,77,234,242,144,249,32,106,179,235,170,223,173,70,18,221,10,175,165,55,49,107,222,106,124,173,129,173,
226,13,79,13,110,33,197,176,198,43,33,87,25,18,190,73,89,240,58,122,92,115,85,66,0,173,178,169,32,190,116,200,178,107,177,101,77,178,10,199,246,106,248,58,7,124,182,101,57,71,229,158,96,86,227,211,223,
196,69,152,70,158,163,45,7,252,224,75,56,221,170,20,13,175,101,73,183,152,159,41,123,35,156,146,40,93,98,212,74,5,127,117,208,106,151,190,200,190,102,1,73,161,92,11,131,32,59,108,5,149,235,108,162,82,
195,168,241,20,85,81,217,49,1,174,180,66,156,104,133,219,144,162,9,134,179,34,9,1,24,140,196,84,34,69,87,48,139,170,241,62,29,217,32,8,234,64,66,177,233,160,9,117,94,120,65,223,120,185,137,82,165,27,173,
214,214,148,249,171,95,169,163,32,131,130,98,235,144,0,87,51,215,145,152,37,96,112,24,215,197,153,192,134,199,156,2,20,84,166,57,117,148,212,192,186,210,213,128,191,147,138,194,59,217,215,250,114,117,
72,129,218,83,145,42,62,248,22,46,147,5,245,197,158,88,86,64,95,232,180,77,12,11,78,132,93,69,216,231,71,109,43,114,53,52,46,114,78,218,190,70,57,35,121,111,152,186,13,47,34,209,248,38,8,194,54,221,220,
141,223,140,108,184,109,17,106,240,45,0,175,62,57,252,152,207,166,73,198,165,133,149,174,182,116,130,153,68,200,228,109,185,149,198,193,69,154,53,129,32,141,13,227,189,88,106,147,163,148,46,103,60,36,
72,248,4,85,66,102,181,225,207,21,73,26,5,36,96,252,228,38,64,145,90,81,172,14,238,224,0,184,246,164,26,21,10,103,82,48,46,21,145,124,171,162,22,148,182,206,139,128,161,207,24,239,164,93,57,21,166,26,
17,90,122,229,47,93,231,46,52,134,37,204,56,9,69,131,119,16,164,202,224,86,246,8,156,197,70,74,7,182,154,170,131,175,192,197,200,110,24,74,36,57,248,88,230,204,72,213,244,1,150,155,70,146,154,103,71,101,
180,195,10,222,13,146,248,146,72,36,249,24,144,42,139,79,143,89,163,2,50,7,22,10,197,63,28,21,120,74,243,2,28,170,227,171,182,2,211,236,39,233,137,110,210,39,154,80,4,147,98,40,86,7,70,112,215,118,60,
184,48,225,225,172,49,3,123,97,189,147,205,42,47,236,78,100,176,49,33,3,132,188,214,64,207,38,69,12,169,48,10,72,192,113,42,69,206,36,180,178,167,36,203,151,45,93,147,174,4,20,209,166,174,13,200,56,28,
59,84,133,161,80,151,35,88,221,5,50,90,145,89,111,100,55,225,130,113,220,25,227,110,177,54,239,52,173,102,170,205,5,51,157,36,48,112,122,163,125,177,160,80,246,90,180,173,48,234,96,10,164,250,37,23,117,
27,23,166,129,35,233,181,193,163,12,155,240,203,113,13,175,106,208,247,199,13,208,97,161,2,108,25,160,84,12,80,37,134,31,201,190,232,178,49,84,1,13,23,1,59,17,227,50,168,45,59,181,178,166,84,43,26,61,
202,46,12,179,41,42,147,246,215,106,62,166,19,63,15,74,33,25,168,52,42,2,11,45,135,145,29,85,146,9,169,182,42,220,177,185,184,174,252,50,100,97,178,9,105,209,72,52,87,194,72,145,115,122,107,119,136,71,
211,210,143,77,97,53,137,104,152,42,106,134,217,193,180,163,36,74,206,86,170,100,65,0,76,8,77,126,10,203,218,155,107,188,148,32,38,29,100,100,115,150,47,120,216,23,7,36,108,92,235,248,154,166,26,39,225,
6,246,91,71,30,57,90,199,69,53,13,4,47,72,182,37,202,188,90,177,178,37,187,163,147,35,97,153,73,212,176,6,212,26,54,108,201,211,173,196,245,116,124,203,227,109,165,215,181,32,13,3,205,149,120,228,200,
89,118,227,25,5,184,86,181,35,104,70,169,70,1,236,75,135,95,199,202,84,173,240,191,194,1,107,204,212,20,198,128,53,231,45,28,84,87,86,126,70,185,74,6,64,54,205,8,181,218,199,2,77,61,45,165,250,93,99,134,
59,135,205,117,81,177,84,161,218,237,15,51,67,174,240,129,209,15,192,52,39,185,94,240,151,97,26,73,29,131,86,5,39,236,119,44,135,41,168,230,103,237,11,80,87,89,196,80,241,213,41,170,73,250,12,21,101,86,
232,90,160,12,254,164,72,217,24,119,45,57,76,248,236,137,36,245,69,186,40,174,71,254,53,48,151,220,85,90,239,101,57,239,29,74,253,80,98,70,245,109,144,192,8,204,5,48,131,49,68,49,212,78,72,101,109,88,
107,116,182,15,85,154,229,70,39,193,181,4,236,71,168,230,66,215,38,177,145,116,13,125,95,66,209,53,204,94,0,107,4,51,68,170,183,7,100,155,66,234,197,16,23,122,69,247,145,10,99,193,29,3,2,104,85,77,241,
98,49,188,239,3,123,153,144,150,35,141,211,176,153,98,224,243,174,115,43,76,5,37,52,130,152,23,48,237,220,50,84,99,40,174,179,161,88,141,153,40,137,26,214,25,208,42,5,215,24,84,25,216,12,119,82,27,75,
117,163,194,40,64,145,44,152,84,214,65,91,90,77,116,193,18,142,255,165,173,61,79,43,107,179,177,232,141,23,51,62,180,182,38,209,42,97,108,25,102,127,13,201,24,26,84,246,130,177,162,25,240,198,77,70,26,
138,105,197,223,173,249,180,24,135,217,155,67,213,132,68,251,226,50,161,203,168,121,131,161,202,132,204,204,164,156,46,14,230,28,149,122,17,165,22,43,82,216,210,24,11,99,120,1,193,20,38,26,70,195,105,
1,46,227,41,190,179,40,171,126,75,37,19,156,41,58,65,52,26,9,164,218,82,126,135,125,44,170,180,214,225,44,85,106,94,155,212,154,210,52,196,160,230,166,74,139,53,0,86,163,204,106,238,14,232,92,187,160,
173,59,155,255,214,100,206,131,54,159,149,38,18,197,168,48,0,218,67,194,48,216,226,130,13,45,145,87,118,201,93,101,105,109,91,87,214,78,47,165,76,218,179,93,97,152,226,133,86,7,93,99,196,122,66,51,2,208,
172,133,40,78,52,20,47,244,158,26,67,42,154,240,133,182,46,80,24,224,169,55,215,107,73,53,154,23,11,208,204,52,154,166,254,196,208,154,87,209,54,1,141,236,41,127,197,52,40,12,161,41,138,185,33,49,152,
22,179,163,231,32,41,237,14,114,76,229,198,224,42,199,152,198,235,165,249,11,36,215,1,160,126,226,72,48,41,149,202,142,11,131,239,32,65,101,192,163,228,26,90,16,98,192,197,30,170,49,116,11,171,170,144,
87,7,179,179,229,208,59,153,21,43,5,163,24,100,205,230,44,49,41,9,130,212,212,168,192,181,85,43,138,19,69,32,135,47,251,52,12,54,152,37,36,177,51,153,97,50,35,107,180,162,239,199,28,178,84,6,51,100,79,
73,83,252,69,55,107,173,10,37,137,170,85,208,48,56,60,150,21,160,38,42,48,44,41,249,88,180,192,173,111,160,74,173,75,180,229,231,88,163,74,244,120,201,109,163,182,206,173,85,210,214,0,232,91,169,185,10,
51,225,71,192,179,102,79,240,211,179,26,241,195,234,32,105,106,5,4,61,0,154,74,109,45,4,99,34,69,205,166,169,101,195,190,60,240,208,1,95,189,187,156,174,82,195,96,95,46,146,1,181,188,0,147,154,196,153,
12,232,42,244,1,117,152,113,228,198,95,51,27,43,0,52,87,2,86,128,10,53,73,75,51,147,137,250,157,98,165,173,163,78,118,30,66,215,192,166,112,42,120,84,208,80,5,201,69,117,196,74,38,84,0,43,23,81,102,191,
214,151,46,10,105,216,48,152,99,176,134,130,247,214,136,6,67,88,247,195,47,199,129,200,114,177,159,40,143,2,216,98,38,48,27,26,121,61,121,214,211,28,193,52,18,103,194,44,138,45,167,58,25,10,116,186,1,
204,181,114,149,165,185,95,26,53,148,118,141,192,116,32,26,39,105,92,26,53,138,35,132,165,129,130,249,174,174,18,50,27,161,177,237,23,213,123,134,113,123,99,27,29,76,70,223,134,82,199,111,61,138,90,224,
198,208,117,246,122,45,6,180,112,134,239,44,66,62,56,131,156,159,122,196,48,178,174,141,182,166,1,110,148,11,192,132,48,211,45,198,28,227,2,228,197,226,105,185,238,240,155,134,187,12,108,174,120,86,186,
86,170,236,155,212,3,81,12,71,249,149,22,120,11,230,81,33,116,141,177,161,65,26,65,200,45,173,1,197,98,51,12,19,67,10,0,237,205,180,6,227,241,23,186,68,82,40,91,5,151,188,100,224,224,133,70,98,203,17,
182,200,147,126,58,50,89,56,159,249,186,131,84,114,88,181,131,233,35,134,145,53,143,248,106,233,57,204,81,12,7,12,195,81,188,146,27,67,213,183,72,58,120,181,237,120,31,170,204,200,40,199,132,242,180,98,
96,128,145,125,215,198,29,108,162,71,31,92,50,2,83,55,185,111,200,120,23,201,163,66,188,21,176,58,218,50,36,4,95,224,77,109,89,108,33,77,12,10,131,64,241,243,181,149,146,119,17,74,14,185,134,33,244,166,
184,8,62,23,68,97,87,135,126,88,253,90,14,96,58,18,86,212,43,3,199,116,115,255,182,54,14,165,150,203,25,82,123,119,44,232,228,184,31,155,203,166,38,50,52,181,104,174,59,212,126,215,75,131,201,86,174,62,
136,45,187,158,64,237,128,91,19,184,76,105,139,219,33,36,168,153,183,84,51,136,125,115,131,55,29,161,182,65,168,91,49,45,126,227,194,41,214,204,14,168,161,42,59,171,0,213,180,2,102,125,199,188,224,42,
10,38,75,168,211,68,65,182,171,67,97,186,72,133,209,65,201,1,245,124,114,46,4,135,71,253,189,219,218,164,210,165,173,131,113,97,38,140,41,24,25,115,253,59,157,133,135,186,36,31,70,124,23,218,228,217,251,
190,147,25,211,186,233,197,233,156,126,115,186,158,102,50,161,28,102,82,102,96,57,35,162,84,183,162,3,54,182,253,98,205,12,60,29,89,6,107,251,123,54,162,70,95,151,189,76,109,204,227,100,192,198,115,103,
118,55,52,65,7,204,224,42,125,148,204,208,18,249,128,169,147,80,173,14,147,217,147,219,241,79,120,157,18,202,40,17,231,66,192,96,54,77,98,71,44,43,249,128,215,102,86,89,83,164,61,194,116,144,209,70,194,
51,241,100,54,146,166,96,4,174,77,86,19,183,81,2,86,140,91,36,255,99,162,38,71,129,169,237,226,194,141,193,120,87,83,21,92,43,173,133,48,202,176,96,48,27,206,234,200,216,246,139,110,19,234,203,174,141,
84,216,157,157,195,86,118,141,243,85,119,234,41,27,167,26,38,128,67,110,109,170,189,131,14,71,131,172,185,26,45,44,236,212,74,133,162,122,198,194,64,162,237,84,243,212,96,40,38,58,210,102,118,240,138,
145,181,191,190,208,105,108,81,68,78,76,90,12,38,135,28,73,91,181,10,171,1,162,49,94,4,47,202,218,196,5,139,73,13,134,94,27,174,97,24,176,107,37,24,246,101,96,166,200,72,182,53,48,19,131,83,212,241,64,
195,0,176,154,31,202,41,228,98,232,35,213,87,112,96,143,231,78,108,13,149,79,158,192,28,185,65,106,215,232,126,164,30,150,137,198,124,14,209,26,66,3,50,197,184,119,160,54,59,171,145,177,64,49,230,101,
38,55,53,199,68,13,103,42,153,216,94,89,64,36,83,76,20,83,175,253,18,137,23,91,168,81,195,20,240,240,201,195,206,98,168,11,140,149,59,10,173,121,240,74,191,68,84,14,92,7,108,125,20,229,89,241,131,113,
12,192,142,159,50,18,118,51,131,23,110,26,83,68,114,157,48,134,208,20,217,174,47,119,12,213,23,24,12,108,214,193,160,49,180,12,5,96,106,213,169,51,38,91,89,202,158,236,196,209,154,150,16,86,7,110,115,
11,199,122,13,145,149,97,116,182,135,66,129,156,165,224,251,18,6,77,199,250,249,53,29,160,209,21,174,213,151,86,99,124,140,254,91,30,101,78,10,66,123,112,235,245,156,49,164,16,178,200,157,56,142,247,154,
147,185,92,105,44,201,28,128,18,248,145,24,239,11,98,134,11,33,247,93,104,4,70,48,174,165,118,44,0,229,232,248,234,84,169,185,43,20,134,110,120,48,155,16,33,231,31,59,139,122,79,161,142,90,3,30,126,20,
35,161,230,127,71,211,84,72,117,135,72,0,249,144,133,6,72,219,170,150,116,72,92,167,5,231,224,198,249,208,116,4,146,105,105,109,69,226,135,65,62,213,151,232,70,241,2,131,85,7,137,42,55,158,142,73,167,
153,181,85,135,220,52,135,26,218,20,107,126,134,186,190,0,16,125,97,139,158,74,35,196,169,141,38,5,190,26,178,157,36,112,72,70,78,17,58,171,176,113,103,12,167,23,147,11,107,209,231,47,173,134,240,204,
244,22,134,18,217,243,50,236,44,220,73,81,125,43,204,180,144,57,218,145,95,127,97,40,194,17,34,166,131,142,194,12,50,76,74,0,213,215,61,93,84,14,5,29,187,198,187,193,114,173,154,8,38,87,149,11,86,214,
27,174,177,162,49,52,13,52,181,74,214,210,55,1,117,119,166,137,36,38,166,153,77,158,88,17,188,27,194,196,54,26,152,50,79,20,166,19,114,19,6,171,50,200,252,165,79,169,15,145,196,248,153,129,195,51,49,152,
62,82,164,129,169,190,200,85,74,84,174,77,131,159,53,42,11,103,147,89,113,34,72,187,146,11,215,202,57,113,152,54,119,216,149,38,170,112,161,89,237,6,32,60,225,215,95,10,227,168,70,102,107,37,106,160,212,
164,187,0,33,237,84,5,128,198,7,57,133,24,68,189,210,18,64,225,165,154,17,194,50,48,54,4,7,138,131,57,251,13,32,94,215,80,158,225,53,26,207,12,92,4,213,238,36,221,122,137,134,112,106,216,38,81,18,194,
88,186,180,179,250,17,215,49,72,144,89,175,222,107,143,177,170,184,180,81,99,146,251,76,152,52,253,79,206,149,107,235,42,251,156,117,109,204,82,49,240,22,133,22,142,220,252,11,121,89,53,120,159,226,55,
94,119,160,105,41,54,29,203,78,85,157,11,87,83,116,3,253,75,199,253,94,151,22,118,188,107,149,230,66,53,18,6,251,133,198,212,14,161,234,208,228,208,219,67,144,81,83,100,141,205,5,187,33,245,77,192,99,
173,168,9,238,149,17,16,90,19,137,70,13,221,246,106,173,9,61,129,7,206,49,152,177,214,248,169,153,180,160,39,116,170,45,230,149,218,38,212,212,207,196,54,224,37,114,63,39,17,98,240,236,198,90,113,243,
83,102,122,120,174,91,63,185,136,132,195,192,8,89,232,15,222,219,231,44,102,72,132,215,24,53,47,98,45,145,92,101,102,172,2,25,35,202,90,163,96,35,180,144,45,61,155,187,241,136,161,54,141,241,83,56,23,
142,143,125,220,95,52,51,185,14,8,26,148,18,179,9,210,20,51,3,25,102,101,62,40,217,153,41,24,195,230,38,16,72,3,99,126,159,135,142,88,142,185,54,182,38,106,180,130,129,163,193,48,216,241,110,170,169,200,
205,159,213,11,209,76,16,59,25,128,117,157,4,224,107,229,152,159,198,55,154,179,19,137,35,155,17,105,67,155,45,224,91,237,108,91,141,53,106,225,245,54,126,98,234,133,42,176,69,9,152,179,17,9,121,85,26,
194,171,48,240,207,227,82,163,118,240,90,23,108,138,9,207,142,24,85,220,171,94,154,48,76,228,78,2,7,48,7,95,219,39,77,190,250,144,52,101,120,69,228,9,18,62,199,3,96,244,2,100,55,254,148,22,241,94,134,
90,250,112,205,1,73,12,37,186,44,177,109,249,15,130,149,184,162,52,36,4,252,108,94,64,168,80,134,97,191,209,28,184,92,162,210,146,40,155,162,12,217,126,135,185,195,90,25,173,173,27,24,208,179,199,166,
46,166,11,28,42,31,219,228,219,35,27,170,242,182,98,54,97,71,24,187,16,130,154,22,152,172,76,228,197,22,67,93,71,23,53,103,193,204,12,94,26,217,60,251,101,23,179,200,204,214,177,155,238,104,58,178,227,
110,122,213,122,198,223,50,31,90,145,250,194,141,199,216,78,108,56,45,85,205,37,85,221,25,206,176,58,176,42,113,57,68,12,83,58,21,146,161,42,6,161,111,5,208,40,128,25,77,130,180,106,38,18,181,90,31,65,
86,4,102,104,101,0,75,23,195,88,214,176,163,109,134,169,94,192,53,51,105,6,81,227,17,91,5,160,104,52,26,64,194,52,253,10,178,8,166,59,124,235,53,58,185,200,189,92,176,193,65,159,80,99,5,112,244,238,18,
2,223,118,162,141,127,70,79,117,95,48,97,107,120,139,147,128,172,211,229,45,232,28,20,243,171,190,238,23,169,82,189,20,227,153,133,26,205,56,87,57,86,123,236,162,160,213,165,27,40,57,143,34,183,159,72,
44,44,149,39,113,38,176,249,148,192,124,6,13,131,98,240,145,134,116,65,197,204,172,126,133,39,122,151,90,77,163,241,160,235,194,96,17,119,53,153,48,161,107,77,170,153,225,179,30,190,5,173,9,94,167,180,
235,33,54,173,38,84,172,238,206,184,129,133,187,8,109,165,69,121,84,168,109,181,202,17,180,45,52,0,28,216,20,149,82,37,112,107,178,72,132,173,22,69,125,94,202,133,172,215,168,202,239,224,191,186,229,33,
197,149,23,113,209,44,223,118,219,29,180,110,86,1,93,139,136,241,183,205,182,219,236,190,199,238,75,151,45,187,238,250,235,69,179,36,222,215,187,209,70,27,237,186,235,221,46,187,236,55,161,136,203,34,
0,211,75,48,198,169,114,26,176,216,25,48,138,202,119,135,59,220,97,235,173,182,186,250,234,107,12,102,179,77,55,189,203,46,119,249,13,98,168,95,72,159,100,176,26,1,26,134,27,100,205,52,73,211,234,45,50,
86,191,156,198,161,62,230,48,196,35,199,16,13,94,245,44,16,231,98,138,225,218,86,30,160,24,154,69,55,201,132,6,0,160,52,54,164,33,245,251,144,88,142,185,148,165,125,33,103,252,87,55,134,107,251,50,217,
22,97,167,49,196,125,157,227,71,115,64,155,94,24,102,187,239,190,27,44,174,187,238,186,164,91,178,199,30,187,95,123,237,181,107,214,132,219,20,80,123,93,146,5,144,169,226,100,105,167,98,112,115,167,157,
118,188,203,206,59,175,93,179,230,250,235,174,199,248,220,248,118,183,187,251,30,123,108,186,201,38,151,255,230,242,48,92,227,223,158,247,186,231,54,119,184,195,165,151,92,42,46,110,127,251,45,183,190,
195,214,215,92,19,6,255,150,91,110,137,170,171,175,185,166,229,151,155,35,230,173,247,101,173,138,41,122,12,14,252,109,177,249,230,135,60,250,96,52,252,128,253,247,219,126,187,237,68,9,243,29,118,216,
254,241,143,123,204,131,31,244,64,109,18,174,111,241,95,208,87,47,49,55,239,140,50,85,82,188,215,61,239,121,232,33,143,186,251,221,247,96,36,100,244,226,126,251,63,226,254,247,187,111,200,84,231,47,117,
155,154,171,23,213,176,96,58,152,171,58,114,47,128,20,155,250,149,68,105,234,152,22,60,104,152,204,64,214,67,214,192,88,175,202,150,192,224,81,57,68,152,250,17,225,169,44,145,171,139,220,144,56,72,234,
226,168,35,1,40,225,2,4,227,130,25,76,85,237,139,1,106,120,251,173,182,60,236,176,71,175,88,177,252,160,131,246,199,240,86,204,3,31,176,207,170,85,27,73,241,1,15,216,103,227,77,55,209,42,8,117,219,141,
70,192,50,60,238,180,243,157,239,113,143,187,99,13,56,248,81,143,220,254,142,219,47,95,185,226,9,127,240,184,77,54,221,228,94,123,221,107,239,125,238,47,24,116,253,42,28,120,111,183,145,12,3,188,111,183,
253,246,187,239,182,171,140,150,237,182,221,102,143,61,118,43,186,6,253,69,189,192,177,245,228,117,248,119,52,117,3,23,155,209,67,55,234,118,217,101,151,243,206,59,255,91,223,250,206,218,181,107,119,219,
109,215,139,46,186,88,128,183,219,104,163,147,79,62,229,177,143,61,52,180,129,94,174,71,86,42,22,77,18,89,5,173,50,2,70,233,55,190,113,214,206,59,223,217,232,239,119,191,251,94,124,241,37,155,238,122,
183,81,6,99,216,47,142,176,213,171,94,204,192,136,85,233,50,44,1,244,194,36,28,74,113,91,40,233,170,9,107,13,172,172,178,14,15,160,178,143,200,179,35,154,216,4,33,94,172,47,199,122,54,213,12,132,110,187,
224,45,53,77,169,250,131,173,19,223,93,118,190,203,47,127,121,222,55,191,249,109,108,19,120,168,27,19,56,186,247,94,123,98,215,188,98,197,10,76,138,79,125,234,51,1,144,194,48,96,45,74,120,231,159,119,
62,254,160,220,108,179,205,183,221,102,27,28,231,209,172,175,125,237,140,109,183,221,246,192,3,247,199,44,11,76,114,48,91,178,100,131,13,55,56,228,144,71,253,207,255,124,55,236,126,150,133,227,95,170,
93,182,114,195,13,158,240,248,199,162,136,101,228,204,179,190,249,227,31,253,4,114,120,105,150,198,226,1,155,189,223,65,24,138,119,165,131,214,99,220,120,227,219,93,123,109,216,101,97,87,191,195,246,249,
60,229,231,231,158,139,42,216,20,108,8,143,6,186,86,105,207,5,39,173,219,117,20,93,9,223,255,254,15,208,25,70,141,77,32,182,88,95,63,227,27,187,85,85,6,57,90,172,199,19,7,108,204,235,201,211,1,27,91,45,
26,19,229,20,189,169,21,171,58,72,101,43,5,219,35,168,117,9,75,171,92,154,9,156,205,38,74,60,222,96,226,13,57,151,73,83,100,106,77,180,147,179,100,104,66,241,118,183,219,232,154,107,174,133,96,134,58,
52,135,29,118,8,206,5,16,45,198,60,92,124,239,251,223,199,223,163,14,126,228,69,23,95,44,129,153,48,2,157,247,146,240,54,221,116,147,157,119,190,211,231,143,58,122,155,109,238,128,115,22,40,175,189,238,
90,40,197,2,84,248,195,114,240,232,131,15,254,249,207,126,113,222,47,207,199,118,227,78,119,218,233,169,79,126,18,0,27,110,184,225,197,151,92,114,235,45,183,126,250,211,159,187,195,214,91,63,242,145,7,
158,251,139,95,170,43,205,210,104,60,0,216,171,146,202,146,5,238,30,237,57,82,34,83,88,159,128,71,88,171,87,175,86,67,105,3,22,135,170,63,134,209,217,138,47,232,213,145,210,65,32,167,161,68,187,158,88,
25,22,80,81,130,97,217,178,101,7,30,176,223,255,124,247,123,219,111,191,29,150,112,92,148,8,151,63,170,151,146,180,130,17,139,126,109,240,94,6,3,205,168,73,21,75,79,49,133,109,10,198,250,112,243,172,160,
50,225,131,218,53,241,144,83,115,98,8,19,149,118,165,134,211,23,154,205,47,249,235,59,41,64,11,95,83,162,197,210,192,67,61,155,44,93,114,242,151,191,44,11,199,83,158,252,68,16,34,24,92,140,88,190,124,
249,247,190,251,191,26,118,198,183,135,7,12,55,218,104,21,166,253,41,167,124,229,218,107,174,93,133,237,193,202,149,80,226,29,19,94,169,32,220,227,30,123,96,103,241,165,147,78,22,229,133,23,252,234,180,
175,156,14,25,199,194,237,182,223,14,2,134,253,1,7,238,127,202,169,167,221,114,203,45,130,193,251,144,37,201,73,74,181,214,26,97,124,117,224,38,33,135,98,159,182,252,161,116,233,175,127,141,243,46,204,
198,237,182,219,246,242,43,174,128,128,230,93,127,253,13,97,134,199,191,188,89,80,231,137,71,21,70,208,21,142,245,67,195,146,202,208,174,91,27,79,174,226,198,100,211,77,55,189,241,198,27,113,142,131,165,
119,131,13,54,88,177,114,197,118,219,109,231,174,14,194,137,54,114,51,147,135,240,105,156,114,21,203,1,86,142,66,174,53,235,90,81,101,10,45,146,177,140,25,26,41,106,163,90,173,208,60,251,0,4,83,249,85,
19,246,232,154,231,14,170,72,216,214,37,20,128,75,203,182,131,172,73,243,28,25,126,151,211,85,214,142,46,185,228,210,7,62,112,24,234,87,92,121,5,3,110,190,249,150,155,110,186,9,26,156,228,130,109,179,
205,54,187,255,253,239,119,228,145,71,49,102,138,151,85,171,86,29,122,232,33,223,56,243,172,11,47,188,16,182,152,80,27,111,178,9,142,187,56,179,128,204,108,63,251,233,207,175,185,246,218,131,14,220,255,
152,99,143,135,126,205,218,53,18,192,173,56,66,35,33,235,214,61,228,193,15,58,247,23,231,94,156,206,244,217,22,221,138,177,49,26,15,173,14,154,226,130,38,125,207,28,149,238,163,99,191,190,228,210,213,
183,222,250,236,103,253,17,86,132,51,190,254,141,157,239,124,39,156,237,127,230,51,159,11,3,43,244,150,188,27,82,231,122,36,35,220,5,158,1,144,77,175,135,243,46,76,242,229,203,144,223,63,126,230,51,62,
244,225,143,156,254,181,175,1,182,249,230,155,109,187,237,54,223,255,193,15,116,170,24,30,83,28,77,153,193,19,237,176,116,26,64,167,88,251,50,141,82,91,65,146,47,173,153,36,168,161,241,168,69,5,32,133,
216,183,38,82,103,0,229,57,159,64,245,10,34,53,218,22,245,162,22,44,244,107,53,48,53,169,241,234,72,49,42,0,92,227,181,118,86,225,178,203,46,195,21,135,103,63,235,143,175,191,254,250,51,206,56,51,51,99,
50,38,71,146,60,28,47,87,174,88,129,139,2,112,255,185,207,21,107,68,203,169,180,244,1,15,216,123,235,173,183,58,224,192,253,1,195,87,18,95,60,225,196,31,253,232,71,79,127,198,83,81,60,225,139,39,178,237,
205,183,220,252,189,255,253,223,157,238,180,227,253,238,127,223,155,110,188,73,55,206,97,218,45,91,182,229,86,183,191,231,189,238,113,197,21,87,220,249,206,119,250,225,57,231,252,232,71,63,22,91,237,220,
28,60,147,150,242,210,61,247,188,159,104,58,41,46,77,138,95,209,212,77,4,182,49,122,90,193,178,177,229,152,234,142,87,112,31,198,181,106,194,66,39,0,134,77,145,59,65,138,249,104,48,198,203,40,161,193,
155,226,172,238,140,57,138,117,0,29,78,1,51,96,170,121,94,98,98,8,225,56,49,237,101,12,97,52,221,118,154,135,245,68,21,163,171,142,214,176,183,130,175,13,93,100,132,225,12,69,190,46,205,220,46,88,171,
153,124,58,18,230,37,56,60,193,45,156,60,2,212,75,16,216,83,172,200,59,8,226,226,147,34,150,11,170,114,104,54,61,170,77,116,29,110,29,33,71,90,153,133,42,66,236,101,66,109,223,42,219,247,164,28,100,229,
37,155,205,226,40,19,102,251,223,138,36,241,183,239,132,113,131,144,104,235,21,193,5,23,74,147,19,120,55,26,69,155,196,182,96,138,239,8,134,202,32,61,230,122,249,51,70,117,81,143,130,168,210,233,99,174,
59,233,81,179,213,221,106,168,252,25,201,173,136,49,175,89,187,86,178,167,29,145,193,106,79,2,147,79,71,130,64,193,226,104,252,59,11,245,164,150,96,89,64,78,37,120,38,169,215,29,106,96,20,181,59,57,95,
193,125,121,32,50,69,101,233,91,41,108,154,160,121,168,225,69,163,164,90,92,183,2,171,41,160,49,209,66,51,147,185,203,153,148,177,191,202,164,165,42,253,116,90,145,234,66,85,29,94,170,213,56,117,236,106,
13,9,206,73,138,212,118,18,43,128,78,96,196,31,196,62,149,225,225,104,85,54,152,162,213,212,29,138,215,0,252,229,192,36,141,24,196,208,186,131,22,38,37,140,125,57,120,141,32,10,12,150,26,214,212,230,181,
70,172,68,79,215,29,102,113,83,59,134,166,229,169,36,206,165,126,95,42,46,208,150,249,210,42,17,184,253,101,85,49,31,220,240,140,173,139,17,206,80,101,58,27,21,141,192,164,105,5,91,109,171,177,70,146,
86,54,10,18,53,153,38,152,214,193,104,193,108,110,120,134,205,20,167,197,24,67,146,228,52,146,57,206,147,114,219,186,67,217,101,208,104,53,75,170,81,60,183,154,107,89,86,112,45,176,57,106,217,138,101,
54,52,38,198,138,145,34,155,224,91,180,181,161,106,148,65,53,42,20,119,67,169,22,194,84,55,169,99,6,219,89,58,216,185,190,197,17,36,170,78,244,18,228,212,80,35,185,178,205,100,155,172,242,114,35,59,73,
61,98,112,224,42,39,43,81,100,91,5,136,48,83,36,198,182,95,156,41,51,197,218,151,146,175,252,46,149,52,208,84,149,173,86,130,222,136,146,41,97,120,130,37,70,87,21,73,102,76,82,61,163,164,198,33,76,38,
252,217,129,53,171,204,176,103,58,146,135,213,202,52,161,99,59,227,121,31,92,153,8,91,201,167,160,130,40,86,125,48,48,197,222,193,120,138,52,122,249,186,228,79,13,54,29,227,48,148,118,92,50,182,92,5,89,
169,84,48,128,122,232,244,91,43,156,77,182,196,62,133,4,216,124,241,37,25,234,39,51,100,119,157,49,145,45,155,43,136,114,102,66,181,106,9,236,49,245,87,11,11,61,119,7,123,81,215,106,171,181,42,104,21,
4,87,201,0,145,107,218,26,19,150,6,183,21,172,132,71,121,124,115,224,181,57,52,142,38,134,231,4,67,42,206,21,169,131,104,248,225,93,53,41,18,27,161,97,208,162,26,170,102,84,168,77,146,83,27,24,168,106,
48,148,138,135,176,124,155,109,182,15,79,101,200,95,229,28,89,0,200,249,11,223,159,196,167,83,212,118,16,240,65,175,254,160,180,182,41,12,151,10,172,37,91,232,33,241,166,99,5,130,252,1,236,146,83,104,
77,145,13,229,108,66,248,85,223,180,76,21,138,132,144,94,205,76,82,122,17,51,174,78,227,1,155,43,174,188,18,119,224,22,15,252,172,91,178,241,237,54,198,131,36,155,109,182,41,190,166,74,172,75,194,227,
55,91,151,143,223,92,125,245,80,139,116,233,159,166,168,204,161,242,4,65,194,174,79,160,76,243,99,163,48,36,110,119,187,219,237,186,219,221,126,115,249,229,113,44,20,143,42,237,138,91,215,215,173,149,
175,223,65,188,231,158,247,194,151,202,191,254,245,175,197,157,196,28,158,151,91,135,248,111,143,102,226,241,161,214,72,229,177,23,34,140,195,151,149,86,150,104,232,93,156,234,251,48,110,181,188,48,65,
114,229,189,135,120,210,11,247,74,222,109,215,187,254,252,23,191,184,219,221,238,250,228,39,63,241,236,255,249,46,110,134,128,195,208,88,207,214,42,41,54,220,242,16,238,164,72,253,184,207,62,123,35,105,
249,54,167,164,39,139,40,162,187,213,145,169,51,38,58,48,20,191,110,9,38,24,205,40,99,223,45,254,249,43,94,246,189,239,126,11,127,95,61,253,203,31,252,224,251,119,223,109,55,192,195,28,160,191,60,87,187,
84,110,37,243,136,108,96,58,158,134,90,157,9,33,35,169,81,38,5,134,66,138,12,86,57,86,105,12,106,199,99,81,149,65,80,67,35,36,16,162,109,253,37,72,88,182,113,179,205,131,30,252,192,85,27,173,50,15,252,
224,30,179,199,63,254,177,184,75,247,94,247,188,7,110,179,81,19,220,229,101,31,191,137,121,8,145,211,186,51,189,33,138,44,4,166,138,231,84,120,220,238,113,143,57,236,65,15,120,128,54,42,132,20,219,126,
231,59,237,180,223,35,30,142,123,120,53,39,171,54,220,112,163,85,171,66,49,190,66,204,187,135,209,130,23,30,37,216,99,247,221,180,43,69,169,239,74,46,0,105,145,214,78,20,152,36,200,184,95,78,251,104,34,
69,130,221,117,151,93,48,224,31,244,192,7,40,195,159,61,239,79,190,254,181,83,113,107,131,182,78,221,193,232,144,71,63,234,208,67,30,13,97,183,93,119,125,201,139,95,136,175,66,165,54,241,53,63,185,239,
176,4,191,255,125,255,242,181,175,158,2,71,31,250,208,7,176,152,174,92,185,242,95,223,251,238,125,247,125,136,218,23,157,197,19,80,17,44,72,243,105,190,192,124,168,215,204,68,97,228,27,77,52,134,105,11,
121,221,186,75,47,253,245,203,94,254,23,187,236,114,151,231,255,217,159,190,228,165,47,124,249,203,95,105,240,226,213,40,65,130,198,227,189,214,7,126,132,21,95,83,110,136,74,200,96,2,206,76,136,150,247,
189,136,101,124,207,169,33,165,80,101,194,177,168,148,68,191,217,234,100,142,252,20,34,30,251,195,141,186,55,220,112,35,180,187,220,229,46,225,217,182,111,135,103,219,48,151,228,160,241,245,175,127,67,
158,198,249,246,183,195,211,56,242,178,143,223,108,176,18,143,223,32,94,80,157,121,230,89,63,249,201,79,19,176,248,12,77,75,141,202,21,222,121,175,116,86,198,196,196,110,188,241,198,39,127,249,212,199,
62,230,208,66,191,124,25,86,129,251,221,255,126,120,146,8,9,193,159,100,35,200,120,100,104,213,134,135,60,234,96,28,63,217,68,100,76,155,39,60,225,113,144,59,49,15,1,199,158,173,25,166,107,180,167,96,
226,39,193,112,145,71,236,2,240,119,208,35,15,56,243,155,223,20,212,65,7,29,128,91,149,87,175,93,3,218,60,90,98,29,150,161,176,67,64,207,97,73,138,169,54,0,227,135,139,140,124,254,243,254,20,105,121,250,
51,158,181,197,230,155,221,227,158,247,196,29,89,64,62,252,17,7,226,110,96,54,81,153,109,157,46,6,14,91,27,29,166,201,44,105,138,179,158,208,36,249,75,176,25,62,111,189,245,86,220,131,117,220,113,95,252,
196,127,127,234,225,15,219,23,35,6,198,88,44,142,248,240,191,127,227,140,175,124,234,147,31,223,107,207,61,37,214,151,191,236,197,95,56,234,179,39,159,244,197,127,124,231,219,55,223,108,83,36,110,231,
59,221,233,131,255,254,254,51,190,254,149,163,62,255,153,71,63,234,96,241,122,248,27,94,247,167,207,123,238,223,191,253,111,78,63,253,148,247,252,203,63,223,235,94,247,132,126,195,85,27,254,253,223,191,
237,148,47,159,120,242,73,199,31,126,248,235,240,52,43,90,178,255,254,143,192,130,250,244,167,63,229,132,19,142,249,220,103,63,249,148,167,60,9,142,160,199,99,173,135,191,225,181,95,62,249,4,128,255,242,
47,254,28,74,108,201,222,120,248,235,78,59,237,164,47,157,120,220,115,158,243,172,186,121,210,124,243,110,96,97,124,199,63,163,215,162,154,227,159,87,198,159,46,13,170,207,66,122,252,57,140,30,122,180,
118,229,138,149,15,220,103,159,175,126,245,235,56,78,3,140,1,129,189,55,132,171,174,186,122,227,77,112,86,129,71,221,242,211,56,104,233,240,183,116,41,110,134,123,215,54,46,111,0,0,51,156,73,68,65,84,
234,83,158,140,39,112,246,217,123,111,140,66,121,252,230,180,83,191,178,102,245,106,60,80,168,17,214,130,54,74,133,26,3,77,142,60,13,21,104,126,250,211,159,221,112,195,245,6,15,253,195,246,221,23,75,216,
154,212,46,201,6,244,24,146,225,145,161,95,156,123,254,249,23,192,10,49,63,237,169,79,198,223,3,246,217,27,69,220,65,128,155,107,241,152,0,238,249,9,43,139,182,206,8,122,136,51,142,103,41,114,115,96,167,
109,87,33,159,142,201,209,21,19,155,254,78,60,241,164,253,247,219,47,204,250,181,235,182,223,110,123,156,235,157,120,194,73,144,241,19,12,31,57,226,131,24,207,159,252,239,143,61,237,105,79,17,102,27,87,
228,217,229,46,59,235,4,193,163,156,119,218,105,167,47,30,255,133,135,60,248,129,2,126,238,115,159,245,169,79,253,23,182,138,146,4,40,113,94,134,27,171,145,240,111,125,231,236,143,124,228,163,208,160,
246,200,207,125,242,128,3,246,219,100,147,77,96,139,191,227,143,61,10,127,216,200,32,18,158,128,247,185,239,189,181,93,89,192,113,212,12,66,183,136,135,149,36,166,245,121,199,56,126,208,131,30,112,241,
197,23,227,246,82,240,188,233,77,111,184,246,186,235,94,240,194,151,254,244,103,63,127,253,235,94,13,205,125,239,123,159,63,249,147,231,252,195,59,254,241,13,135,191,233,7,63,60,231,154,235,174,195,227,
165,239,125,239,187,241,204,217,95,255,245,219,190,251,221,239,189,253,237,127,115,15,252,52,195,186,117,56,35,125,197,203,95,122,195,245,55,188,249,205,111,197,211,83,47,120,193,243,96,142,147,171,31,
254,240,71,255,231,175,94,243,134,195,223,140,31,146,56,232,128,253,145,2,220,46,253,144,135,60,248,49,143,57,236,29,239,248,167,31,252,224,135,175,126,213,95,98,109,130,254,101,47,121,209,33,135,60,250,
19,255,253,201,119,188,243,159,191,115,246,217,224,124,210,19,255,224,225,15,223,247,13,175,127,227,191,254,235,251,255,226,207,95,182,211,142,119,228,206,206,114,55,5,96,150,191,14,138,199,180,194,180,
143,85,227,12,190,88,247,208,135,60,24,79,172,108,187,221,54,120,42,4,155,8,172,5,27,174,218,0,230,104,41,38,15,158,240,193,3,35,0,202,211,56,26,15,150,131,11,206,191,224,243,71,30,245,249,207,127,225,
236,179,255,71,154,179,98,249,242,3,14,216,239,148,83,78,205,231,165,217,125,150,6,18,29,25,186,164,101,200,108,18,30,106,198,67,67,27,108,176,18,63,88,178,213,86,183,223,112,195,16,176,188,240,200,16,
52,191,56,247,220,144,144,165,75,47,252,213,175,142,58,250,24,252,157,253,93,121,250,120,233,202,13,86,30,24,99,190,249,166,155,115,235,82,218,85,147,248,210,167,204,219,84,146,79,184,40,21,189,146,50,
171,160,104,233,59,76,170,229,43,194,159,204,46,172,14,120,162,111,175,189,246,4,236,192,3,247,195,111,192,224,33,96,200,151,95,126,249,137,95,58,249,57,207,125,222,151,191,124,234,171,254,234,149,120,
206,2,132,74,37,130,48,188,249,205,135,195,234,133,47,122,233,207,48,65,94,255,154,11,126,117,225,181,215,93,127,232,97,135,8,230,113,143,125,204,15,127,240,67,108,24,37,30,40,177,55,249,147,231,62,251,
217,207,126,230,6,43,99,62,99,147,119,216,97,7,252,66,2,182,15,135,191,241,45,248,251,232,199,62,1,13,8,129,231,9,248,186,215,190,90,219,197,66,94,41,210,97,207,209,132,5,202,44,207,141,204,58,48,252,
230,196,118,219,226,200,143,235,14,123,237,121,175,215,188,246,112,68,182,197,22,155,99,57,252,236,103,143,196,149,179,47,124,225,24,60,166,118,199,59,238,128,3,2,86,187,251,223,255,190,223,255,193,15,
241,248,3,96,88,47,118,220,241,142,152,192,184,141,252,205,111,121,27,102,194,19,254,224,241,33,190,165,75,113,173,229,173,111,251,187,147,191,124,202,231,143,250,2,78,240,160,194,58,247,159,31,249,232,
217,223,57,251,87,23,254,10,251,228,135,62,244,33,97,14,196,215,123,222,243,175,95,250,210,201,239,121,239,251,112,38,182,207,62,247,135,238,176,199,28,122,226,151,78,250,247,127,255,208,241,199,159,128,
126,2,231,195,31,241,176,211,78,59,253,188,243,47,248,246,119,206,62,247,151,191,124,228,193,7,105,34,138,137,42,227,44,49,11,63,222,77,195,85,95,11,156,125,237,90,129,9,9,203,153,54,29,15,241,68,13,46,
73,238,124,231,59,47,91,182,252,142,119,188,227,197,23,95,186,205,29,182,65,222,144,228,43,240,252,205,21,87,108,178,201,198,216,7,225,241,59,243,52,14,102,208,205,183,222,130,191,213,107,86,203,89,198,
67,247,125,200,47,207,59,239,146,116,21,176,14,149,53,57,27,172,141,114,14,178,49,42,212,2,129,97,85,192,82,133,238,195,177,11,251,59,60,60,143,171,39,10,192,35,67,223,57,251,127,14,220,63,28,117,241,
90,187,38,92,179,196,107,184,171,117,201,18,60,50,244,11,60,50,116,241,37,106,226,8,218,71,42,200,225,189,132,34,249,165,162,44,169,109,75,72,112,237,208,53,56,115,88,61,252,112,209,207,113,106,241,139,
115,15,60,112,127,160,14,58,240,128,83,78,57,13,59,104,200,56,203,254,248,199,63,113,225,5,23,156,118,218,87,112,162,244,192,7,236,29,87,234,200,21,28,5,1,132,155,111,182,25,86,150,207,126,238,243,87,
92,113,229,23,142,30,38,200,81,71,125,97,255,253,30,129,133,21,91,170,187,222,117,151,99,142,61,46,31,180,214,173,251,135,255,251,206,15,125,232,136,63,127,197,75,143,254,194,231,246,219,239,225,210,95,
129,110,217,82,204,172,111,126,243,91,223,249,206,217,248,153,165,227,191,120,34,6,188,51,1,119,216,129,217,100,238,104,211,250,194,240,141,38,64,193,95,251,229,0,214,173,195,30,225,99,31,251,47,28,171,
151,47,95,246,189,239,133,39,85,113,41,21,3,250,109,111,125,179,48,97,172,236,186,235,221,48,57,223,246,182,191,123,197,43,94,250,164,39,254,225,191,254,235,191,253,215,39,62,185,205,214,119,0,224,39,
63,249,9,222,49,80,126,244,227,159,96,14,132,64,151,172,195,3,35,24,100,208,95,117,229,85,24,115,203,86,44,223,106,203,173,223,240,250,215,220,247,62,247,190,244,215,151,225,210,183,252,36,150,240,255,
224,7,231,64,184,242,202,171,240,142,75,232,24,162,91,110,177,5,150,94,73,1,148,248,1,139,189,239,127,191,251,220,123,175,71,61,234,145,98,130,233,167,109,193,232,23,101,124,31,100,173,149,42,83,36,124,
88,56,184,88,227,93,91,87,137,128,191,253,173,111,11,3,34,60,235,204,179,110,196,204,89,189,250,89,127,140,103,219,174,199,94,29,7,19,100,70,182,172,39,158,240,37,118,141,116,9,103,28,237,24,127,155,223,
227,238,119,191,252,138,203,119,218,105,71,236,212,206,249,225,143,234,32,89,227,199,19,17,157,42,102,128,140,19,4,140,212,175,127,253,140,159,198,203,28,7,30,120,192,5,23,92,112,245,149,233,219,147,37,
75,240,200,16,54,137,59,237,184,227,253,238,123,31,52,205,141,25,95,127,236,180,211,78,216,9,254,56,14,12,118,33,145,96,98,176,82,229,233,113,194,196,37,105,49,44,95,46,93,28,222,101,138,0,137,195,207,
97,135,30,130,77,254,189,239,189,215,135,62,244,17,9,227,17,15,127,216,243,158,247,220,59,239,124,103,108,229,160,193,233,112,152,198,113,241,10,130,12,149,117,235,246,217,251,254,152,32,111,125,203,155,
196,10,19,228,110,119,189,235,49,199,28,255,202,191,120,5,46,241,226,171,13,60,6,250,237,111,159,205,65,98,50,188,255,3,31,196,198,228,181,175,125,213,59,223,241,246,63,124,226,83,47,184,224,194,96,158,
126,15,8,39,20,184,84,249,252,23,188,24,186,122,2,238,182,251,174,23,93,50,252,32,147,56,109,53,86,106,135,247,56,7,135,59,169,121,180,57,20,17,26,244,104,45,189,240,187,119,159,254,204,231,206,250,230,
183,142,252,220,167,30,247,184,199,28,117,212,209,225,193,237,37,75,158,255,130,151,252,240,135,97,222,234,235,83,159,254,236,23,79,248,210,139,95,252,130,215,188,230,175,240,155,11,23,196,167,83,119,
222,121,103,140,24,96,240,88,39,206,183,3,120,221,146,112,173,69,221,65,177,102,237,51,255,232,233,123,236,190,251,33,135,62,30,243,4,39,108,114,202,39,204,56,248,136,32,239,242,20,45,122,72,147,139,9,
118,203,45,183,126,234,211,159,249,231,119,253,75,160,47,23,193,80,36,95,153,170,108,102,214,151,146,97,67,37,210,88,103,178,52,178,37,33,209,128,81,253,209,143,255,23,222,161,63,246,216,227,113,20,66,
19,196,230,172,179,190,133,113,131,73,200,20,88,10,195,106,24,95,231,132,181,224,28,244,209,251,222,255,1,198,168,220,138,173,110,136,154,184,130,240,220,112,227,141,31,254,200,127,66,134,249,215,190,
126,6,144,104,133,80,97,235,23,12,83,26,191,121,214,112,13,239,152,99,142,21,194,34,230,115,194,250,213,138,89,240,242,110,226,212,230,168,192,96,215,4,202,130,68,123,63,133,106,24,176,101,208,86,160,
10,142,240,135,159,84,120,225,11,254,12,43,245,13,55,220,112,198,153,103,66,143,9,255,170,87,253,229,25,223,56,243,217,207,121,30,206,142,113,217,11,196,112,20,246,12,113,237,198,91,48,95,190,236,134,
56,98,113,222,141,190,26,34,137,85,167,158,250,149,71,60,226,97,184,252,124,220,113,199,227,183,8,216,169,248,253,197,185,231,190,238,245,111,60,233,196,227,238,121,207,123,12,171,3,42,240,51,150,187,
237,246,252,231,255,41,206,187,113,125,10,69,59,1,35,121,4,150,111,101,123,77,2,17,152,12,200,225,204,162,52,13,37,73,132,232,1,149,191,26,6,205,249,23,92,128,171,146,175,252,139,151,111,190,197,102,120,
164,244,202,43,175,68,184,59,238,116,71,156,48,227,75,23,44,159,104,0,126,108,15,51,25,195,29,105,66,78,127,116,206,143,46,187,236,55,207,121,246,51,113,73,230,25,207,120,218,54,219,108,35,63,92,145,215,
90,28,37,98,3,224,23,123,105,28,85,48,43,176,249,188,207,125,238,237,198,160,202,111,124,227,76,236,247,112,74,130,37,25,223,171,65,255,229,83,78,197,183,74,184,98,135,243,71,108,100,224,81,193,16,180,
105,44,48,192,151,67,191,59,127,97,64,204,248,39,252,181,149,232,117,105,144,162,89,26,160,228,176,69,22,164,251,238,95,139,42,87,76,215,208,40,77,180,168,197,214,6,47,232,101,216,216,119,233,77,116,104,
245,135,152,133,220,154,196,121,200,74,19,3,138,38,12,183,88,91,177,38,103,175,114,55,184,78,225,137,149,184,248,233,143,127,122,238,185,191,124,202,147,159,20,174,236,220,116,51,70,2,190,209,196,85,149,
95,95,250,235,141,86,109,248,92,239,202,183,154,127,247,236,239,98,130,224,104,191,195,246,219,203,4,193,238,24,97,28,117,244,209,251,62,236,161,184,12,127,236,241,95,12,89,74,163,11,215,163,95,240,252,
63,221,99,183,221,238,184,253,246,184,130,6,30,184,22,54,188,227,224,241,214,183,189,249,43,95,249,42,142,28,155,196,159,129,248,222,119,191,167,19,16,87,232,31,246,240,125,133,63,183,84,230,114,121,24,
51,169,3,179,104,210,119,22,122,105,170,20,36,202,48,170,226,160,215,176,178,128,233,190,102,237,251,223,247,1,44,170,47,125,241,139,175,187,230,218,87,190,242,85,119,221,229,46,199,30,253,249,179,206,
252,42,46,22,98,194,223,113,199,29,254,238,111,223,114,230,55,78,255,231,127,122,199,135,63,252,159,184,144,126,203,234,91,95,242,178,87,224,183,174,142,62,250,115,56,161,250,183,15,124,16,231,111,153,
147,36,248,253,239,255,254,52,206,23,240,37,200,75,94,250,162,143,126,44,28,87,59,175,191,127,251,59,113,215,205,251,223,247,158,207,126,230,191,177,76,0,249,142,119,252,211,57,231,156,243,129,127,123,
239,183,191,117,6,182,30,219,110,183,109,48,151,236,167,44,112,118,80,137,145,17,48,252,74,189,53,24,162,85,105,197,100,129,45,32,243,224,86,217,96,214,179,200,145,139,172,142,68,96,126,14,85,101,6,244,
101,195,92,243,195,188,142,199,141,74,169,80,43,78,125,67,29,141,9,214,143,144,107,213,5,4,214,179,236,59,45,215,119,198,139,140,212,125,233,164,147,182,220,114,139,19,79,58,89,210,136,241,252,225,35,
254,243,185,207,125,246,105,167,157,188,108,249,114,92,95,171,173,68,131,31,109,127,229,95,190,250,174,119,189,203,113,199,30,21,39,200,255,9,71,196,37,225,151,35,241,165,213,207,126,246,243,159,254,228,
103,33,224,180,140,34,59,251,238,251,208,35,142,248,224,49,199,124,30,63,224,252,150,183,252,77,216,30,98,52,134,215,58,156,166,225,110,145,3,14,216,15,183,66,224,239,175,113,189,83,248,227,4,60,243,140,
211,113,125,84,246,218,110,75,35,73,239,109,233,158,123,133,139,121,156,65,78,166,118,138,246,34,147,177,21,235,33,99,37,195,187,252,170,183,216,66,195,63,242,45,120,124,209,112,211,205,55,225,176,163,
230,174,35,212,2,41,223,137,40,178,35,224,26,4,174,240,225,98,167,98,112,217,18,1,92,125,245,213,226,75,34,111,249,82,43,21,234,150,186,182,10,115,107,149,173,22,212,16,85,83,109,135,33,82,147,121,154,
56,4,189,138,161,235,251,78,57,60,33,233,227,93,71,70,57,133,83,49,29,119,83,48,198,117,179,200,41,29,203,88,77,130,11,179,88,88,112,145,178,19,173,90,241,4,129,18,151,216,190,120,252,209,71,124,228,163,
242,157,165,54,74,240,56,115,193,70,3,155,110,20,167,144,3,102,248,133,199,127,71,171,27,141,29,86,7,223,108,130,214,52,131,45,38,54,131,77,126,123,50,143,131,218,107,35,89,22,200,36,13,19,205,143,159,
13,102,0,123,131,196,250,141,101,101,118,107,141,210,247,110,65,195,97,220,168,135,98,59,182,209,72,10,239,166,201,96,111,51,155,72,212,81,65,104,64,235,81,84,126,112,220,70,46,66,116,101,6,226,215,109,
123,255,193,31,60,30,191,28,251,196,39,62,117,184,148,214,206,9,7,41,109,93,207,80,59,132,197,83,88,69,232,237,248,114,243,188,91,235,36,98,231,189,76,74,0,116,92,56,246,89,165,237,89,112,94,176,33,204,
116,149,212,162,85,191,201,34,111,89,179,73,217,204,252,128,144,215,88,19,134,67,66,86,149,247,16,69,54,73,49,13,159,101,24,166,210,45,154,96,12,198,119,20,189,76,186,171,85,227,161,22,25,23,163,69,63,
134,218,76,125,153,42,114,237,38,147,225,2,232,120,172,25,10,112,29,67,242,110,242,188,209,198,183,123,213,171,255,242,199,63,254,201,43,255,207,171,240,181,180,212,22,84,28,150,244,120,77,14,140,242,
243,230,191,180,237,148,92,143,118,239,160,109,86,180,106,106,106,197,212,85,131,70,155,129,179,171,42,232,113,243,38,239,162,85,212,81,9,245,130,99,91,31,194,150,45,66,154,53,158,14,149,230,206,114,106,
103,41,162,35,196,177,40,94,44,143,103,213,137,167,105,222,137,39,205,4,207,85,113,154,204,128,166,35,6,77,145,235,192,170,120,234,246,46,154,119,172,3,213,84,66,212,179,241,115,19,170,224,53,7,118,239,
80,251,40,52,74,218,102,84,106,8,186,76,130,164,224,97,208,162,200,26,88,139,109,66,192,139,18,225,130,73,234,46,23,170,167,62,245,201,184,75,157,155,245,185,35,143,58,249,228,47,179,38,200,101,6,234,
95,22,168,249,43,77,222,10,5,190,248,5,132,245,82,149,139,246,150,49,12,216,152,249,2,70,36,136,161,10,99,168,70,141,94,246,34,139,32,182,98,19,47,45,95,134,100,193,69,29,213,202,80,123,172,53,1,236,230,
71,88,38,140,207,142,59,173,10,66,203,11,185,224,38,248,161,70,70,187,58,20,110,170,130,146,226,123,138,170,146,20,41,14,56,150,190,151,247,78,28,100,60,65,212,246,39,71,26,152,24,99,96,69,33,59,12,146,
90,169,135,214,153,81,141,84,19,17,146,95,148,90,131,59,251,54,182,141,162,31,225,146,37,248,106,246,97,15,123,232,73,39,125,89,175,233,222,84,222,18,50,240,53,118,103,147,194,171,219,27,217,102,109,2,
122,193,152,192,187,209,116,50,134,42,6,23,247,117,84,73,99,100,85,185,190,10,147,52,227,203,20,71,157,17,91,177,254,142,26,2,96,124,17,85,176,54,181,66,104,230,130,40,229,93,241,42,112,109,45,151,171,
3,70,9,141,251,26,173,164,157,8,212,74,192,106,82,76,206,174,23,101,104,9,234,93,200,77,202,96,133,157,10,222,179,235,72,164,86,74,91,0,120,134,208,76,211,77,28,31,199,216,144,101,101,206,2,211,170,182,
209,252,58,66,88,44,141,87,72,222,253,158,247,226,145,205,76,176,124,217,223,253,237,91,113,95,221,145,159,63,234,53,175,250,43,220,165,254,164,167,60,3,255,194,26,110,197,197,253,102,248,133,8,60,151,
129,167,227,112,139,145,220,34,129,6,189,236,165,47,122,236,99,15,67,56,184,69,253,199,63,254,41,138,207,251,179,23,254,230,55,151,63,227,233,79,125,202,83,159,244,154,215,190,1,167,190,224,223,98,139,
45,62,252,161,15,224,11,230,119,189,235,61,226,238,176,195,14,193,111,180,227,235,103,124,21,253,158,247,190,79,238,91,219,106,235,219,255,199,7,255,13,207,206,224,95,48,5,45,190,114,62,235,172,111,253,
205,223,253,253,149,87,92,33,137,194,147,117,207,122,230,31,237,188,243,206,231,159,127,254,87,78,255,234,49,199,28,247,174,127,126,39,238,23,122,251,219,223,33,25,195,221,244,111,122,227,235,143,62,250,
216,255,248,208,17,218,174,245,23,234,193,0,78,219,71,220,41,94,95,12,120,134,113,100,158,9,215,139,108,34,177,49,212,6,19,52,153,164,142,45,69,149,49,19,8,251,144,248,92,122,226,197,232,236,83,107,131,
251,48,215,37,15,253,5,152,51,167,49,55,69,70,66,214,152,141,190,170,42,214,117,229,236,31,193,106,78,163,225,86,107,149,146,171,70,4,87,47,195,0,85,161,150,198,196,246,219,111,191,235,221,238,118,192,
254,251,225,142,105,60,240,134,127,160,25,55,228,252,215,199,63,130,199,52,142,61,238,56,236,56,112,79,218,170,141,54,124,231,63,190,11,228,120,196,254,121,207,251,19,76,212,115,206,249,49,30,233,193,
54,4,63,187,130,123,105,80,181,229,237,183,196,211,226,27,110,176,33,248,145,43,60,193,133,34,110,103,150,188,97,105,248,219,183,189,5,207,77,126,246,179,71,30,124,240,35,223,251,158,119,61,243,153,207,
197,93,243,203,150,44,3,236,45,111,126,35,120,112,55,14,110,242,59,240,192,253,241,208,215,171,95,253,58,112,226,167,40,222,250,214,55,227,203,227,211,79,255,26,158,166,195,111,61,156,247,203,243,176,
66,61,225,241,143,251,167,127,122,183,60,27,118,240,193,7,225,137,12,125,160,187,211,77,146,28,121,119,83,52,19,0,96,238,20,38,228,24,66,54,170,75,215,3,152,122,129,93,155,35,43,51,23,176,110,129,99,168,
129,202,217,140,173,182,89,144,70,194,8,191,239,160,46,85,104,17,90,64,43,77,108,159,150,30,107,203,152,245,144,59,217,20,143,83,253,78,105,75,43,206,212,198,186,126,170,247,104,169,109,169,173,30,121,
208,129,191,249,205,111,228,159,18,57,245,212,211,194,15,43,45,89,178,235,174,119,195,45,204,47,120,225,75,228,225,165,231,255,217,159,224,31,1,123,217,203,95,137,7,129,80,251,241,143,127,228,105,79,125,
202,123,222,243,126,124,3,255,244,167,61,5,95,149,61,227,143,158,131,127,142,113,235,173,182,250,204,167,63,1,0,220,133,63,90,21,225,87,238,249,149,91,104,80,247,226,23,190,0,75,201,19,159,248,52,76,233,
143,125,252,19,39,124,241,24,220,243,131,171,235,50,58,241,47,193,62,238,9,79,188,224,252,11,241,181,28,30,198,123,240,131,31,4,125,176,122,201,11,113,151,231,19,159,252,180,243,207,59,15,142,194,142,
116,249,178,163,143,57,246,229,47,123,201,131,31,242,192,211,78,61,29,74,60,119,132,189,79,120,174,52,190,224,186,211,124,193,44,214,123,157,94,141,129,93,4,152,142,138,152,166,20,33,165,140,12,90,180,
4,25,23,39,145,132,91,16,189,175,159,185,47,147,171,20,115,42,167,79,223,81,106,175,124,15,53,254,139,245,137,13,157,92,6,132,81,80,45,174,25,28,165,156,95,47,110,3,94,88,209,111,228,236,92,163,109,233,
80,46,78,12,173,46,143,89,127,249,203,95,162,1,60,249,201,207,184,42,61,224,116,196,17,31,213,231,26,239,115,223,251,96,78,174,92,185,226,17,143,120,56,206,71,46,251,245,101,56,197,192,191,149,116,221,
181,215,227,8,143,163,52,158,249,1,201,101,151,253,6,143,117,97,83,128,176,195,31,245,106,92,44,226,208,15,255,158,210,210,173,183,222,122,199,29,239,136,231,98,30,242,208,7,137,119,60,42,138,3,190,24,
66,243,157,239,156,141,165,1,2,22,32,60,17,183,247,222,247,195,157,249,240,133,95,142,250,223,239,255,128,254,113,215,224,3,39,23,47,125,201,139,14,58,224,0,172,14,216,107,224,41,245,35,142,248,207,240,
76,1,94,113,120,72,26,67,12,122,58,23,234,242,75,0,185,124,219,75,58,42,196,245,164,0,56,161,18,225,98,15,126,141,202,36,192,13,207,85,26,67,45,26,230,242,186,131,162,60,65,44,217,25,203,106,33,93,43,
85,81,14,163,109,64,214,137,67,221,98,231,78,35,25,17,202,96,250,95,218,143,143,215,146,45,55,170,165,175,130,67,122,145,165,218,145,92,119,120,227,155,254,26,207,8,195,8,179,249,194,139,126,5,24,210,
138,227,57,30,204,82,19,60,231,138,147,133,127,124,231,255,101,238,45,54,219,124,163,85,225,223,64,254,113,250,183,210,32,95,126,121,254,101,74,6,199,110,202,7,70,156,20,160,22,79,184,190,251,159,255,
81,97,188,217,192,147,160,170,151,59,249,80,139,48,160,212,231,172,20,128,157,2,30,55,222,111,191,71,224,54,86,108,28,160,63,254,132,19,117,56,14,35,164,63,84,148,171,22,116,20,153,132,215,72,163,81,67,
213,19,67,113,136,174,145,113,255,165,145,11,129,182,40,243,21,151,172,104,49,6,162,226,212,222,84,115,8,198,5,23,25,15,153,171,148,65,48,110,149,98,68,48,152,25,86,7,177,212,104,12,145,186,97,61,203,
97,235,225,229,162,192,40,203,52,65,131,113,225,125,102,211,139,53,184,67,238,128,203,109,148,2,70,189,104,228,98,82,127,25,36,99,245,236,179,191,139,167,221,20,12,1,163,12,59,133,53,171,243,133,17,156,
110,220,126,203,219,63,230,177,79,184,249,230,155,21,121,237,181,215,225,82,37,138,120,212,77,119,127,248,253,18,5,136,128,123,117,69,192,63,59,26,4,236,169,241,179,84,87,132,71,227,113,34,243,198,55,
189,69,106,67,13,77,158,213,183,230,127,114,93,0,88,29,228,6,118,252,24,201,160,161,141,192,23,142,62,246,129,15,124,192,125,239,123,111,252,180,23,158,38,234,60,93,110,242,166,222,91,66,43,225,45,188,
234,213,80,53,174,107,52,130,231,184,130,213,188,51,90,20,12,193,144,171,185,98,106,141,86,13,2,229,31,154,209,245,43,96,220,208,45,175,83,30,198,132,83,83,171,16,86,216,253,14,191,119,86,215,135,193,
103,254,8,132,188,32,131,230,47,196,109,76,164,72,134,29,177,223,108,227,203,244,31,108,245,15,46,4,204,190,134,90,125,16,136,132,16,115,249,18,176,234,212,53,52,234,5,130,2,92,33,88,213,15,119,201,78,
63,205,49,101,51,12,176,253,249,207,126,142,95,184,184,251,61,246,192,79,96,232,31,158,159,187,228,210,75,177,142,236,185,231,61,149,28,63,76,160,230,215,94,19,158,70,193,195,60,162,145,95,61,130,12,66,
252,46,0,118,4,123,239,179,55,158,11,198,3,194,242,39,151,60,212,60,8,220,101,235,214,93,124,209,69,56,209,184,247,189,247,12,251,27,26,48,136,28,223,203,226,9,253,71,30,116,16,126,22,8,63,207,83,144,
148,5,109,166,73,26,235,89,86,107,86,78,145,213,80,133,108,69,61,62,252,250,11,141,25,129,57,86,130,33,91,206,143,146,139,161,142,147,90,80,102,35,104,39,214,130,65,246,138,238,164,171,148,51,236,29,16,
141,250,67,35,85,86,129,1,162,100,24,203,106,2,161,182,130,178,5,102,67,145,167,35,179,45,207,237,184,157,81,18,116,82,134,197,48,56,60,133,5,140,144,148,187,33,7,160,116,37,82,213,44,20,230,169,66,252,
200,162,156,116,241,83,122,32,181,5,199,144,15,126,240,195,248,71,159,15,127,253,235,238,190,251,103,241,75,16,184,100,128,223,2,120,235,91,255,246,134,235,174,63,225,132,47,225,66,195,191,189,239,61,
159,255,252,23,240,15,192,203,230,95,70,45,126,84,6,116,207,124,230,31,221,124,203,45,119,187,235,46,79,120,194,227,3,123,76,3,190,13,197,163,135,248,49,101,124,199,249,201,79,126,250,202,171,174,194,
179,0,56,43,193,247,23,67,243,129,68,0,216,48,32,111,178,138,45,95,118,203,173,183,226,123,86,60,224,252,233,79,227,201,254,79,227,171,13,252,144,220,155,254,250,173,104,29,150,134,147,78,62,229,15,255,
240,241,176,192,23,174,153,36,184,140,47,47,75,110,90,146,129,243,89,119,34,131,76,45,87,169,44,30,185,235,165,106,74,36,137,191,24,72,202,12,65,72,28,170,212,149,25,60,57,27,226,52,185,206,4,34,213,190,
234,166,177,141,78,130,198,234,32,129,150,193,213,62,152,17,61,61,101,147,83,152,196,194,8,109,109,80,107,188,104,107,148,106,56,53,198,187,41,194,132,53,101,246,67,247,115,173,242,139,192,94,2,178,190,
127,172,76,175,49,55,69,176,25,66,177,102,229,47,126,121,238,139,95,250,10,60,53,255,162,23,189,0,230,216,47,28,119,252,23,5,240,15,239,252,167,173,239,176,53,118,245,248,161,141,83,79,251,202,209,199,
28,135,223,26,19,78,252,240,216,187,255,229,189,143,125,204,97,111,126,211,27,112,209,241,205,127,253,214,23,195,60,158,89,128,228,63,254,227,8,200,207,122,214,31,253,205,223,132,147,11,44,16,184,97,1,
194,224,23,179,60,30,51,66,30,226,106,5,1,127,248,218,18,63,130,120,232,161,143,62,252,245,175,197,184,248,204,103,142,212,68,225,247,4,241,75,214,248,209,42,252,158,162,216,202,88,148,195,141,194,224,
194,125,149,93,48,64,140,149,41,26,158,126,45,131,167,35,97,229,6,198,108,42,11,178,38,31,82,170,184,238,232,82,84,237,183,102,86,176,10,125,140,158,172,46,221,115,207,252,143,35,168,113,125,129,32,87,
65,226,69,46,13,113,19,165,117,207,38,204,149,204,89,39,178,33,20,165,165,141,90,155,238,150,47,128,219,238,132,127,145,223,57,146,210,53,98,118,219,178,40,1,224,159,189,192,3,188,248,229,66,236,240,153,
16,74,108,7,110,188,1,63,234,123,248,31,254,225,19,14,62,248,80,92,41,12,128,24,27,238,131,186,234,170,112,161,193,125,109,189,245,86,248,165,105,125,4,94,49,110,55,73,45,174,101,108,179,13,254,37,155,
107,241,27,98,138,223,119,223,135,224,223,98,192,79,138,126,244,99,31,87,165,8,54,33,141,236,117,60,142,16,154,234,209,34,7,192,224,178,43,165,198,68,101,219,194,230,81,54,120,232,28,147,58,128,228,186,
54,55,30,28,54,139,112,182,255,6,18,238,119,48,42,45,182,28,176,137,98,84,16,115,142,30,85,108,162,252,16,140,213,196,42,134,213,36,45,95,3,82,51,158,18,109,216,122,69,181,101,80,155,199,68,194,141,29,
182,18,198,214,229,135,175,4,227,172,114,8,144,153,28,151,9,194,47,136,85,108,215,201,15,94,200,137,0,88,211,126,68,108,177,52,180,248,1,192,93,149,198,99,40,234,134,49,69,200,152,53,107,215,92,124,209,
37,224,84,90,252,140,242,95,190,242,207,241,47,50,28,121,228,81,28,112,182,210,152,211,174,68,170,24,204,114,221,198,76,213,146,188,80,93,172,233,62,197,184,1,152,239,188,180,201,106,85,11,5,79,93,29,
59,200,168,213,68,5,3,152,94,68,235,152,196,13,120,150,251,29,146,103,38,77,58,251,89,96,100,12,53,122,197,13,75,232,10,18,235,161,185,151,27,177,74,171,161,3,211,161,105,124,165,200,221,225,226,240,36,
115,84,113,235,88,70,215,215,109,100,254,153,246,219,110,12,204,150,34,26,62,165,161,176,50,134,166,104,172,234,162,186,232,24,74,21,190,197,196,175,117,225,7,202,241,51,39,47,123,217,95,240,15,243,100,
90,132,149,82,157,215,29,169,86,125,44,82,38,155,167,247,0,134,203,162,233,133,182,38,209,126,182,130,247,245,134,39,186,64,60,6,108,138,131,75,99,107,2,161,104,165,198,146,184,230,149,149,97,109,21,65,
78,105,44,142,46,106,82,252,27,220,54,26,69,149,2,147,162,166,111,21,193,237,83,116,61,248,148,46,242,40,73,250,169,29,144,240,173,207,94,180,11,74,116,29,24,187,102,119,125,36,172,24,172,231,126,204,
38,50,195,234,90,213,116,96,248,167,180,144,248,27,111,186,49,246,78,176,48,96,213,43,155,10,140,100,185,56,140,87,153,132,59,220,193,137,239,59,240,131,206,23,94,248,43,101,99,65,215,154,168,204,19,27,
197,194,81,85,28,72,170,201,19,114,88,69,50,128,39,126,84,156,46,161,9,47,184,213,43,123,133,163,162,81,69,77,171,81,4,42,243,67,21,109,177,14,140,177,161,182,110,160,32,98,222,236,239,59,168,49,55,175,
239,67,77,22,32,176,151,150,249,109,231,221,120,108,5,83,4,96,178,185,158,131,207,68,208,47,170,235,142,83,197,212,84,29,171,26,12,77,135,202,197,51,255,116,91,182,114,105,147,210,244,78,209,41,17,99,
0,98,55,192,166,196,83,70,226,178,165,88,156,207,137,241,20,81,57,52,148,246,50,30,23,91,43,91,97,23,225,113,54,210,105,166,13,44,98,26,223,89,32,200,250,26,187,198,178,160,184,213,154,133,34,232,162,
162,185,15,12,40,4,192,45,100,67,149,103,15,210,4,227,38,218,172,223,198,68,157,91,161,19,109,138,211,117,7,30,117,161,174,85,99,189,32,49,233,188,169,174,178,86,157,144,196,56,6,38,81,241,129,208,251,
46,187,246,214,59,72,50,218,70,197,117,165,28,144,157,152,203,135,241,53,153,73,24,143,167,136,68,183,180,169,119,202,88,154,165,228,174,0,20,204,69,141,83,208,30,28,109,175,99,76,163,101,168,117,51,150,
26,37,209,242,37,48,138,63,100,172,88,29,6,116,236,127,141,18,32,105,158,90,78,108,173,226,235,102,116,24,146,85,175,59,97,94,135,87,123,97,77,162,29,116,126,0,101,42,195,23,180,41,143,74,229,27,106,181,
8,204,35,115,108,194,164,117,152,153,39,172,215,99,43,102,234,41,19,142,91,228,4,186,128,161,41,113,48,116,78,115,154,182,101,240,25,86,165,52,87,181,165,212,125,205,81,97,178,39,69,177,50,85,181,147,
68,78,53,26,100,171,21,132,13,98,194,143,250,50,118,117,145,25,58,125,196,176,154,68,53,29,6,96,132,68,48,34,27,218,252,47,139,7,52,205,7,198,77,204,114,136,73,179,89,174,229,161,106,218,139,253,118,44,
198,97,26,73,100,49,151,148,93,230,58,149,193,139,242,164,17,224,218,178,146,121,36,206,28,173,178,193,160,65,72,131,213,153,12,160,34,64,118,155,93,100,93,79,26,197,195,203,40,198,117,144,194,115,130,
7,126,34,103,34,201,30,38,26,230,254,146,241,12,130,50,207,202,172,132,42,168,51,197,240,117,77,173,133,16,215,76,86,76,146,11,71,60,18,140,117,10,184,192,27,204,180,162,203,160,173,83,1,100,34,27,124,
254,70,115,168,240,130,182,71,173,20,189,68,200,62,224,69,148,198,205,180,182,116,81,38,48,138,65,2,224,221,47,136,48,137,186,116,147,42,35,179,229,233,52,173,76,69,112,161,26,177,226,133,67,35,48,132,
166,168,48,17,64,216,7,24,124,171,168,129,185,0,184,40,188,152,228,195,134,242,111,24,22,229,156,180,240,110,29,140,236,161,76,211,12,149,41,26,110,41,42,102,124,211,100,50,83,165,133,131,81,25,252,238,
72,48,222,221,216,214,83,169,49,48,143,182,151,149,144,87,232,89,71,50,179,147,65,13,90,20,45,189,26,46,138,128,108,22,142,168,87,100,95,48,116,36,233,131,223,170,183,108,48,6,207,213,149,173,164,40,37,
138,161,35,178,70,174,130,107,208,97,86,67,21,4,172,197,129,176,213,156,212,150,142,11,14,169,130,217,81,97,253,146,113,103,220,19,170,39,130,188,10,128,241,54,24,174,131,220,137,45,32,235,20,165,228,
8,79,215,181,64,134,247,16,103,251,156,177,128,86,81,113,144,198,163,41,50,210,112,46,160,56,19,219,176,119,128,205,168,153,6,221,65,78,193,76,108,146,82,41,190,212,228,33,82,28,172,202,158,86,91,22,90,
60,140,129,108,155,169,87,170,12,78,138,19,252,186,118,172,12,30,235,177,11,132,71,238,131,61,100,112,145,104,243,54,208,67,74,102,108,195,57,196,9,242,96,158,60,102,11,207,99,174,45,165,245,137,161,236,
223,130,23,180,245,124,54,190,76,177,176,175,10,51,128,77,66,40,27,51,144,84,1,44,64,209,202,79,29,198,66,238,134,2,123,77,36,81,26,125,43,14,128,13,178,110,228,40,64,77,234,254,214,170,154,164,14,169,
198,168,57,11,35,94,76,223,171,37,13,2,213,117,4,215,75,43,66,23,220,32,175,186,140,3,78,65,182,28,133,197,37,97,26,252,86,93,199,214,36,183,166,121,45,43,106,38,7,96,28,153,30,55,181,133,139,88,152,21,
95,51,100,77,149,100,37,31,13,35,147,172,135,164,238,152,99,186,235,244,157,5,55,131,153,72,206,135,29,85,142,117,216,244,56,148,114,1,130,227,197,109,78,140,214,1,79,115,233,27,138,35,48,151,223,27,43,
165,111,165,213,149,48,19,126,38,112,53,80,104,243,53,118,145,13,83,189,216,160,153,176,189,97,208,140,173,221,53,202,90,175,44,168,234,5,160,150,16,170,96,154,145,176,21,201,179,226,201,212,138,210,16,
38,244,91,81,197,108,137,22,90,102,215,11,224,24,86,7,183,63,70,233,22,224,187,26,163,217,137,207,86,15,166,9,169,116,155,3,126,227,221,122,28,245,213,0,8,173,101,203,45,27,151,56,176,62,15,35,149,183,
111,34,176,41,24,37,52,2,108,91,41,13,200,58,45,106,95,118,86,12,62,175,74,138,50,177,153,162,192,76,0,124,167,185,0,66,144,237,93,173,250,26,17,180,45,101,228,214,10,48,15,96,122,71,26,162,202,80,244,
172,22,176,53,203,241,104,192,80,185,228,25,58,179,52,172,14,78,51,102,166,90,160,129,184,110,25,155,49,97,96,45,91,87,175,157,100,72,180,88,251,50,60,53,64,108,13,76,9,167,11,62,3,119,124,226,26,118,
112,11,29,7,163,73,72,126,236,169,159,27,97,98,11,19,190,158,174,80,170,85,66,14,244,170,87,119,163,130,49,9,23,161,171,41,234,31,153,149,122,66,210,234,46,54,126,3,217,186,176,86,58,122,106,175,250,12,
240,180,53,51,73,32,76,117,222,71,117,142,40,3,35,54,135,3,86,71,198,164,237,55,0,91,86,168,74,103,22,145,79,112,224,194,95,199,38,98,195,27,174,211,97,67,141,251,22,163,28,255,89,113,173,107,8,222,125,
7,206,193,68,173,21,47,45,172,162,106,219,86,83,75,169,148,28,139,45,201,72,19,151,68,30,5,56,176,154,165,165,113,187,77,219,200,29,111,24,20,99,244,163,69,175,141,209,200,164,43,140,188,162,237,46,51,
179,53,190,252,27,72,24,25,169,12,121,126,80,56,79,225,165,195,55,151,173,198,214,249,201,44,20,174,246,106,139,39,98,7,211,42,78,33,82,142,80,20,191,152,36,75,82,132,80,118,201,133,196,29,96,67,85,200,
182,211,5,90,91,8,18,128,120,44,3,14,89,197,157,70,225,231,57,210,244,132,102,74,108,133,131,84,40,86,7,137,207,185,190,32,232,220,111,161,188,217,230,155,237,124,247,187,110,119,231,29,55,216,112,195,
196,102,186,60,14,48,93,231,76,227,147,141,255,201,190,146,33,127,205,93,121,10,89,41,168,146,85,161,28,10,17,137,55,15,227,120,25,99,102,19,241,80,134,162,165,18,104,104,97,217,142,71,41,234,230,148,
164,105,78,51,185,71,155,121,128,236,1,134,31,125,10,120,120,234,196,33,140,61,170,236,211,72,210,4,159,187,8,143,33,101,187,11,152,161,79,197,233,57,73,22,245,103,51,212,34,128,73,113,54,211,185,30,113,
106,82,110,189,249,230,139,206,187,240,252,31,253,252,154,171,194,15,145,59,175,86,79,169,119,28,251,247,186,207,222,142,165,167,226,21,104,155,29,182,219,247,49,7,109,188,201,198,203,87,44,87,54,207,
104,174,155,103,96,158,129,223,65,6,48,247,241,139,196,215,95,127,221,233,71,159,116,217,69,241,55,126,202,40,220,125,43,32,58,205,1,104,62,163,89,82,21,165,85,27,173,58,244,153,79,220,108,243,205,195,
10,41,135,150,249,10,81,100,104,94,152,103,224,119,154,1,156,243,195,127,60,195,184,230,170,171,143,251,175,35,111,190,241,166,160,72,87,64,38,6,87,158,89,96,178,167,27,146,91,68,240,187,249,86,91,108,
190,229,230,56,187,89,186,44,220,135,30,255,227,173,212,68,215,115,216,60,3,243,12,220,54,25,8,171,67,252,127,237,218,45,110,143,217,186,197,37,215,93,20,174,16,154,151,123,114,65,48,187,58,180,22,5,165,
133,143,205,183,216,114,229,138,21,107,241,5,82,184,124,25,95,90,61,23,230,25,152,103,224,119,157,1,108,28,176,54,224,254,103,76,81,28,193,55,223,98,139,75,47,188,184,14,170,190,172,11,76,88,1,210,170,
145,87,7,221,53,8,75,107,153,192,250,179,98,229,114,252,226,48,254,13,85,44,13,203,227,250,128,61,7,30,122,162,43,184,117,36,115,205,60,3,243,12,220,230,25,72,211,16,11,3,190,93,192,17,124,29,126,251,
119,197,202,240,19,112,121,70,167,201,159,191,127,72,251,133,48,155,195,217,67,124,227,111,52,179,113,172,44,232,138,70,173,91,190,124,5,126,29,112,201,154,181,88,123,64,59,124,177,19,183,50,201,111,97,
48,47,204,51,48,207,192,111,33,3,152,140,216,201,203,165,192,181,114,102,129,223,112,90,142,245,97,217,146,240,239,149,14,103,22,245,150,65,231,190,10,56,242,35,224,188,119,224,232,21,196,202,65,94,182,
28,187,15,108,87,214,134,31,245,12,193,224,70,152,176,21,9,59,7,20,194,149,144,249,107,158,129,121,6,126,219,25,192,228,139,75,67,152,134,97,94,134,123,52,214,133,165,33,78,82,76,91,249,7,141,229,220,
97,44,56,89,1,252,213,161,99,11,179,112,46,179,28,107,196,26,252,211,119,209,117,248,194,60,60,228,137,133,1,33,134,211,157,14,193,188,106,158,129,121,6,22,57,3,225,32,29,246,241,114,102,16,86,7,76,69,
76,68,92,69,192,84,197,132,133,191,225,108,161,242,108,183,2,52,123,157,213,129,89,172,165,80,47,197,110,5,203,131,4,19,252,98,69,192,157,165,75,195,26,129,197,3,154,249,2,81,117,194,92,49,207,192,109,
147,129,176,42,196,87,252,135,106,33,45,139,43,197,58,172,16,203,113,200,142,71,240,56,145,39,29,180,249,188,195,89,29,252,21,129,26,6,255,184,9,106,221,154,176,32,225,244,4,255,97,97,88,187,22,59,136,
181,203,214,97,67,19,254,155,47,16,148,176,185,56,207,192,109,149,129,97,105,8,219,120,108,30,194,31,62,241,17,182,13,97,53,192,63,176,24,166,104,56,247,15,91,251,112,232,238,191,134,233,31,119,16,213,
234,64,251,10,203,146,168,225,45,92,231,136,95,83,68,221,210,165,171,241,120,28,46,144,34,162,112,21,98,190,64,216,212,205,203,243,12,220,6,25,224,165,33,172,9,113,101,8,194,138,176,30,224,80,29,254,67,
17,171,66,248,13,171,176,183,111,69,17,80,64,36,128,236,32,236,234,192,251,10,67,164,150,88,156,240,181,69,220,45,68,8,156,175,88,138,171,148,248,11,63,91,27,47,142,132,2,34,11,17,25,154,121,113,158,129,
121,6,22,33,3,113,105,144,115,138,97,215,16,191,157,8,107,4,142,208,75,194,221,72,97,6,134,37,3,26,154,249,174,111,157,221,82,43,69,187,58,24,144,75,132,213,0,171,195,218,165,107,66,124,216,66,132,47,
85,177,230,224,27,85,132,178,100,233,154,117,8,118,45,246,54,225,10,196,124,109,112,83,56,87,206,51,176,40,25,8,215,27,48,221,48,13,177,10,224,255,112,149,33,148,195,9,5,54,14,56,54,135,253,4,230,33,190,
218,12,155,131,225,37,59,133,84,10,159,238,196,47,254,165,188,22,136,89,240,157,68,56,151,217,96,249,178,91,227,218,0,94,92,144,92,141,19,10,124,97,18,22,7,148,229,54,202,16,115,140,175,52,159,151,230,
25,152,103,96,17,50,16,151,4,76,178,240,138,251,131,120,111,98,88,28,112,255,19,190,167,192,234,128,249,183,100,233,202,160,192,57,1,54,251,234,213,93,11,134,90,218,237,79,251,93,73,50,136,223,140,192,
227,138,53,43,87,135,229,33,156,204,132,29,196,146,213,171,195,45,15,88,167,112,173,52,236,106,194,114,22,183,55,243,239,47,180,83,230,194,60,3,139,147,129,112,228,13,211,110,120,133,29,67,88,23,194,210,
176,124,197,138,101,184,77,49,156,76,132,237,195,242,101,56,237,15,78,81,215,91,20,2,36,188,244,218,2,166,114,241,175,221,72,117,152,213,229,75,13,162,26,203,209,210,165,8,96,117,60,43,193,220,143,87,
63,214,226,220,38,172,19,113,81,136,203,69,88,57,74,158,121,105,158,129,121,6,22,49,3,178,68,200,50,33,83,79,118,17,225,108,98,152,137,184,38,24,22,141,184,46,52,167,35,22,14,141,74,87,16,252,156,79,248,
197,122,45,15,8,222,41,196,149,162,4,132,141,193,10,60,133,181,14,167,19,225,116,37,158,71,132,219,185,241,165,166,190,194,174,33,68,61,95,32,52,237,115,97,158,129,197,204,128,204,47,76,50,126,201,186,
16,79,53,194,70,2,254,150,173,176,87,15,234,32,202,9,158,235,195,153,5,175,28,177,38,144,226,21,108,120,165,16,45,174,43,196,13,12,182,44,82,139,219,162,112,118,17,174,67,226,21,130,141,127,80,206,215,
135,33,99,243,143,121,6,110,139,12,196,51,139,176,58,200,140,11,82,120,133,139,12,225,107,139,48,175,227,84,13,243,57,76,228,230,222,33,216,243,43,205,250,112,118,208,90,57,226,170,81,154,5,138,232,114,
25,118,28,225,150,135,112,115,100,188,186,16,162,74,43,2,228,136,138,235,154,4,198,190,231,242,60,3,243,12,172,95,6,226,145,55,204,179,56,209,194,135,76,192,240,17,167,58,222,177,143,128,126,216,77,196,
251,29,38,251,28,102,189,119,221,65,56,112,205,51,221,26,1,5,237,47,226,149,207,24,3,150,24,124,98,117,8,22,241,18,164,152,206,223,231,25,152,103,224,183,159,129,176,91,79,71,243,180,70,132,117,35,108,
27,214,226,50,66,170,155,28,89,254,87,118,141,9,47,13,168,26,138,178,63,193,149,200,244,168,149,124,33,1,117,172,9,111,1,28,223,173,152,149,115,105,158,129,121,6,214,63,3,152,103,97,194,231,73,135,217,
152,46,6,64,194,82,17,138,254,245,1,199,187,236,0,120,226,231,111,52,105,119,16,44,107,104,80,202,253,152,33,130,53,248,245,23,124,132,87,128,7,21,254,151,69,34,188,147,24,234,231,175,121,6,230,25,88,
188,12,96,134,97,97,8,239,152,126,248,40,39,96,152,146,56,130,135,59,160,112,130,177,38,212,203,43,75,73,67,159,225,49,136,242,149,239,149,228,53,163,196,228,82,196,192,3,214,134,176,62,160,2,107,2,150,
137,240,63,222,227,74,17,170,227,226,48,4,157,173,231,210,60,3,243,12,44,98,6,194,76,75,255,99,121,24,38,227,178,240,13,1,30,145,12,119,38,66,183,6,151,8,67,101,120,149,183,38,136,46,191,23,43,0,136,205,
175,191,152,237,67,182,139,82,50,14,95,85,172,89,189,122,237,154,225,110,168,176,56,192,191,172,14,97,133,144,179,142,176,179,209,53,203,80,205,139,243,12,204,51,176,158,25,8,203,65,184,206,16,166,92,
156,116,56,143,144,99,181,252,208,11,234,195,53,193,240,181,102,152,234,225,209,139,52,133,199,61,203,58,146,247,14,176,152,104,28,246,13,171,215,96,223,18,47,142,194,106,201,218,53,216,189,196,69,1,111,
114,194,33,75,68,8,125,60,148,57,98,158,129,121,6,102,202,0,166,21,174,54,226,61,76,187,101,97,210,133,139,12,65,179,22,147,113,9,126,216,33,30,154,3,0,63,241,56,251,36,148,165,160,88,29,70,227,139,155,
139,240,93,198,234,53,88,29,86,227,198,7,152,224,183,43,113,138,19,66,8,155,136,16,31,126,228,65,62,103,143,106,52,132,57,96,158,129,121,6,66,6,194,228,194,60,195,86,62,124,224,151,160,240,35,10,235,214,
132,69,97,53,102,95,248,89,135,161,62,236,235,195,227,81,241,76,195,205,93,235,164,161,90,29,100,66,203,174,160,98,10,19,63,58,9,171,1,214,3,1,96,125,10,127,113,117,144,223,193,29,42,194,133,137,249,107,
158,129,121,6,110,179,12,96,138,45,199,236,195,105,61,150,139,112,42,31,142,221,120,68,58,252,138,35,94,241,77,254,133,211,248,160,67,35,142,252,227,212,10,136,43,128,93,29,220,235,22,178,40,168,225,45,
183,222,122,253,181,215,98,65,138,55,61,196,183,176,58,132,253,66,220,51,132,133,34,174,22,106,49,23,230,25,152,103,96,241,51,16,215,133,112,38,31,46,68,226,136,141,223,84,8,175,112,61,82,39,33,110,135,
90,189,58,44,16,238,212,238,199,148,87,135,122,119,97,22,5,37,66,24,215,95,119,61,214,43,56,150,104,194,38,38,190,80,76,226,252,115,158,129,121,6,110,195,12,96,105,192,43,28,137,101,139,48,200,81,25,228,
120,164,198,38,34,172,14,195,35,81,18,205,212,153,190,110,93,94,29,90,107,129,48,14,239,49,34,132,19,22,1,252,143,255,228,85,128,230,133,121,6,230,25,248,29,100,160,60,54,135,47,44,130,38,30,175,101,69,
144,57,62,117,166,227,97,75,44,50,69,59,248,224,111,170,128,131,183,112,243,118,105,82,216,207,11,243,12,204,51,240,251,149,1,204,233,184,34,204,48,109,135,111,52,187,103,35,222,105,2,206,113,120,5,249,
253,202,195,60,154,121,6,230,25,176,25,8,71,249,176,147,176,250,78,89,246,23,249,78,234,14,148,171,176,96,212,91,10,6,204,229,121,6,230,25,248,125,203,192,12,139,3,77,111,251,203,16,197,57,9,225,180,181,
56,149,89,189,6,95,168,182,191,60,85,232,92,152,103,96,158,129,223,117,6,48,85,49,97,227,5,194,16,74,49,193,41,54,186,84,153,207,24,252,189,67,130,102,156,242,224,54,135,171,175,184,242,230,91,110,90,
181,114,67,85,206,133,121,6,230,25,248,253,204,192,205,55,223,132,9,139,199,160,154,23,4,226,38,160,184,229,33,93,58,24,126,170,18,203,65,90,17,66,27,177,192,180,254,224,227,202,203,174,184,228,130,75,
240,144,230,144,14,111,139,241,251,153,169,121,84,243,12,252,255,34,3,105,74,98,146,94,116,193,69,87,254,250,138,230,210,128,43,18,248,137,218,242,79,83,180,66,30,181,28,202,105,205,208,234,44,36,127,
208,220,124,211,205,167,29,115,226,254,143,125,212,142,119,222,113,229,170,149,184,233,33,126,153,225,108,52,162,185,94,12,105,1,178,147,133,74,234,2,4,183,157,151,133,70,55,201,78,154,240,255,209,224,
39,181,240,182,4,33,123,191,255,169,251,45,117,177,220,1,129,187,39,87,223,116,235,69,231,93,120,250,49,39,221,124,243,205,72,62,31,254,165,47,228,44,163,117,174,17,76,246,186,207,222,218,109,61,92,252,
5,75,38,93,181,106,213,86,219,223,97,139,45,182,88,185,114,101,188,30,90,45,45,161,191,26,125,166,107,141,24,105,81,67,41,5,238,124,241,53,80,71,243,240,219,220,233,53,236,103,218,132,210,69,2,151,224,
50,185,182,160,109,158,252,248,159,76,14,68,177,96,71,206,236,203,16,168,107,232,219,222,149,191,145,86,67,26,138,106,2,57,118,72,54,141,195,40,96,162,158,160,169,83,162,45,19,12,216,96,147,186,150,171,
51,181,32,232,93,97,53,6,85,181,146,76,173,40,84,49,183,131,24,16,41,189,138,30,56,57,177,90,151,192,192,16,133,86,7,33,234,165,82,244,46,81,97,98,10,3,115,176,131,152,154,152,92,43,56,199,137,42,227,
36,129,53,78,181,130,144,24,89,23,100,113,118,235,173,183,92,117,213,213,151,95,124,233,77,55,134,165,97,120,25,254,164,110,125,46,221,115,175,251,23,117,49,160,160,153,64,132,225,5,84,188,223,34,136,
83,76,10,95,110,65,3,112,107,53,170,137,48,151,100,138,82,248,213,221,20,147,6,6,107,118,189,236,198,133,28,75,25,175,108,205,43,70,32,174,23,126,245,198,228,45,24,99,92,54,1,176,185,49,17,171,90,169,
97,172,159,144,243,144,83,142,235,236,244,26,117,205,193,147,93,33,182,73,228,137,194,2,156,11,75,241,172,83,24,230,56,225,206,202,48,224,169,24,43,218,252,217,14,82,43,84,49,111,213,10,197,184,11,252,
222,115,60,132,98,78,226,31,182,40,28,199,194,56,67,178,201,247,74,166,152,90,75,146,51,118,229,216,24,214,170,120,118,145,56,139,207,86,40,201,221,0,86,152,60,91,38,90,40,167,192,10,127,177,160,108,117,
85,214,112,79,231,33,169,61,23,242,224,240,176,85,230,234,45,166,117,43,162,93,72,219,112,136,114,29,49,185,0,90,174,129,164,248,197,206,137,156,8,91,181,172,55,153,135,117,124,212,143,88,70,69,14,152,
34,172,153,227,19,132,150,142,131,177,117,94,57,227,217,47,35,41,6,86,71,153,126,64,73,235,132,7,86,120,10,90,149,97,180,199,57,82,45,13,128,196,127,99,134,160,141,158,205,161,22,216,161,208,175,245,44,
74,93,186,179,1,211,115,61,169,242,234,176,62,68,176,173,187,188,79,216,170,101,61,56,185,200,57,96,61,187,102,61,227,85,38,176,179,14,194,188,207,208,186,121,172,182,34,71,234,188,41,8,184,38,97,3,227,
26,67,52,61,36,155,87,177,192,176,144,185,193,126,6,185,31,140,99,80,169,56,96,190,188,85,92,30,175,172,22,168,160,153,207,126,13,219,108,141,18,206,42,159,69,252,228,215,248,186,173,138,85,60,133,163,
69,141,39,175,14,133,15,45,180,66,169,130,152,45,239,202,79,130,59,157,160,84,102,23,32,4,138,33,62,95,52,72,195,105,138,74,161,86,42,104,149,8,174,97,11,108,108,109,209,228,188,74,181,224,241,131,59,
190,97,137,215,192,250,193,40,204,112,246,173,12,56,20,41,248,97,22,197,120,100,198,210,197,171,193,84,23,56,135,106,130,42,135,103,252,150,73,24,152,8,19,52,46,134,156,74,78,244,215,22,91,41,18,139,28,
9,49,140,139,38,164,113,131,28,182,27,15,175,194,153,108,172,165,25,73,18,248,71,86,135,214,50,188,192,92,144,239,90,52,156,218,120,21,216,196,128,195,160,92,80,10,44,15,251,152,69,94,0,143,182,203,216,
182,114,110,194,129,121,109,104,52,48,25,134,203,88,114,106,67,227,110,180,152,154,227,236,200,212,182,181,22,140,120,239,76,33,109,151,10,226,204,53,49,24,13,171,33,72,84,169,93,121,131,230,195,93,143,
53,180,140,1,125,109,188,212,22,45,141,155,52,30,60,25,192,177,149,1,180,200,161,199,200,25,89,29,178,131,14,205,109,83,53,147,107,205,114,17,139,38,101,90,70,116,28,48,201,76,97,176,225,168,220,98,110,
233,167,16,114,19,112,157,45,94,69,107,78,215,5,59,114,35,89,4,54,237,47,118,128,179,103,239,210,26,67,60,185,104,181,236,89,194,89,23,157,2,79,12,120,34,108,98,144,134,77,227,49,122,175,69,147,116,3,
143,100,82,135,189,10,224,64,21,23,219,172,104,209,176,58,240,168,114,241,83,162,103,146,41,120,215,209,160,52,205,99,40,143,161,212,78,215,157,118,152,91,27,40,75,47,77,152,122,103,215,170,76,49,72,243,
199,73,162,33,231,74,152,38,26,242,214,93,67,24,132,242,42,84,252,17,49,11,233,149,235,214,165,166,57,86,12,158,8,171,89,74,67,237,47,6,34,45,83,51,195,102,165,44,215,20,145,115,252,249,123,111,198,151,
81,113,77,51,249,101,230,11,147,177,194,12,173,227,156,11,109,21,106,26,87,254,226,24,141,236,150,179,21,32,2,179,207,89,180,160,201,107,168,111,181,167,165,159,98,107,252,202,64,49,132,137,103,104,57,
95,150,51,230,92,44,72,76,126,37,185,70,201,198,144,169,3,90,195,87,44,130,163,14,21,241,0,207,81,161,93,92,52,254,77,209,141,33,7,96,208,117,177,27,97,202,240,96,214,137,138,195,152,8,51,253,21,172,202,
96,194,117,138,50,75,117,248,235,163,145,56,57,114,151,109,98,115,216,182,99,194,176,245,148,235,200,107,191,181,6,78,249,11,151,153,98,240,158,179,208,62,43,187,74,135,142,10,198,147,27,153,1,155,162,
97,144,34,120,92,42,163,92,64,155,235,252,70,143,197,66,43,49,232,80,102,167,44,11,12,205,41,91,148,169,100,55,11,152,156,108,215,182,168,82,91,21,92,152,248,146,185,84,92,48,15,20,217,227,0,235,126,152,
12,72,144,18,33,236,196,187,6,163,130,86,13,220,248,38,221,92,19,109,132,193,205,201,253,37,3,204,59,101,48,1,104,83,152,231,255,21,111,181,75,17,132,48,236,253,223,218,66,151,144,164,192,126,56,163,254,
112,218,146,164,129,5,238,60,21,69,11,216,109,12,237,40,187,186,169,45,211,224,114,151,133,20,206,78,240,55,107,178,84,206,34,139,27,44,122,45,218,37,232,119,77,155,6,43,164,102,55,191,248,220,33,55,80,
179,50,158,226,229,1,155,40,115,254,94,213,71,143,237,148,152,254,87,113,154,177,103,176,116,56,183,50,121,3,17,20,4,132,186,194,170,0,58,192,7,58,48,8,236,96,163,158,193,65,234,208,183,154,12,181,41,
165,27,0,29,225,100,34,49,118,185,41,191,79,201,122,223,115,149,14,135,25,108,101,173,139,166,223,88,170,33,25,92,101,53,245,189,11,118,190,78,45,40,142,20,109,74,160,16,20,187,115,9,117,184,107,176,158,
47,154,178,114,220,99,229,147,157,52,63,111,135,88,11,158,127,95,154,246,186,244,100,146,85,61,187,63,225,170,207,125,182,217,169,65,176,167,104,18,213,67,173,24,101,151,126,38,166,224,127,209,63,247,
205,199,90,233,168,96,229,163,130,184,79,118,253,142,38,137,160,99,157,107,5,67,18,208,65,106,245,247,47,206,141,132,55,117,36,45,6,70,151,121,86,173,209,0,136,135,94,188,40,134,167,70,53,220,157,29,67,
138,195,50,11,27,93,188,23,48,57,77,155,237,149,231,121,59,88,3,75,85,205,51,255,164,135,58,29,30,70,29,58,52,221,237,212,176,114,96,109,151,137,28,202,100,248,193,199,0,193,170,219,155,214,162,59,18,
211,31,101,110,132,218,52,79,54,230,40,69,236,237,180,26,65,121,99,224,70,74,87,254,22,76,126,53,132,165,219,105,142,223,255,93,252,32,30,40,144,181,110,227,95,139,181,60,179,122,92,109,106,21,208,201,
126,33,26,107,54,64,212,29,206,59,40,234,135,233,128,213,131,179,248,198,161,74,104,38,130,99,233,230,237,160,224,7,217,144,104,208,248,25,146,174,100,238,196,177,137,30,134,12,25,233,43,48,232,188,76,
162,192,230,129,142,192,30,15,193,240,87,49,12,127,27,179,31,230,138,183,49,0,240,114,116,160,218,129,151,29,54,7,122,164,51,10,205,181,26,205,212,4,90,170,34,173,2,60,13,241,30,104,24,253,242,190,67,
225,233,52,251,30,208,22,167,3,9,89,117,49,55,146,74,53,84,58,116,159,198,31,176,82,126,93,168,14,111,91,115,143,234,159,71,35,126,165,198,92,24,251,1,148,14,139,238,168,45,33,198,0,0,0,0,73,69,78,68,
174,66,96,130,0,0};

const char* PluginEditor::background_png = (const char*) resource_PluginEditor_background_png;
const int PluginEditor::background_pngSize = 33581;


//[EndFile] You can add extra defines here...
//[/EndFile]
